      SUBROUTINE X04BAF(NOUT,REC)
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     X04BAF writes the contents of REC to the unit defined by NOUT.
C
C     Trailing blanks are not output, except that if REC is entirely
C     blank, a single blank character is output.
C     If NOUT.lt.0, i.e. if NOUT is not a valid Fortran unit identifier,
C     then no output occurs.
C
C     .. Scalar Arguments ..
      INTEGER           NOUT
      CHARACTER*(*)     REC
C     .. Local Scalars ..
      INTEGER           I
C     .. Intrinsic Functions ..
      INTRINSIC         LEN
C     .. Executable Statements ..
      IF (NOUT.GE.0) THEN
C        Remove trailing blanks
         DO 20 I = LEN(REC), 2, -1
            IF (REC(I:I).NE.' ') GO TO 40
   20    CONTINUE
C        Write record to external file
   40    WRITE (NOUT,FMT=99999) REC(1:I)
      END IF
      RETURN
C
99999 FORMAT (A)
      END

      DOUBLE PRECISION FUNCTION X02AJF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS  (1/2)*B**(1-P)  IF ROUNDS IS .TRUE.
C     RETURNS  B**(1-P)  OTHERWISE
C
      DOUBLE PRECISION X02CON
      DATA X02CON /Z'3CA0000000000001' /
C     .. Executable Statements ..
      X02AJF = X02CON
      RETURN
      END

      DOUBLE PRECISION FUNCTION F06EJF( N, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Entry Points ..
      DOUBLE PRECISION          DNRM2
      ENTRY                     DNRM2 ( N, X, INCX )
C     .. Scalar Arguments ..
      INTEGER                           INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION                  X( * )
C     ..
C
C  F06EJF returns the euclidean norm of a vector via the function
C  name, so that
C
C     F06EJF := sqrt( x'*x )
C
C
C  Nag Fortran 77 version of the Blas routine DNRM2.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 25-October-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION      ONE         , ZERO
      PARAMETER           ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION      NORM, SCALE, SSQ
C     .. External Functions ..
      DOUBLE PRECISION      F06BMF
      EXTERNAL              F06BMF
C     .. External Subroutines ..
      EXTERNAL              F06FJF
C     .. Intrinsic Functions ..
      INTRINSIC             ABS
C     ..
C     .. Executable Statements ..
      IF( N.LT.1 )THEN
         NORM  = ZERO
      ELSE IF( N.EQ.1 )THEN
         NORM  = ABS( X( 1 ) )
      ELSE
         SCALE = ZERO
         SSQ   = ONE
         CALL F06FJF( N, X, INCX, SCALE, SSQ )
         NORM  = F06BMF( SCALE, SSQ )
      END IF
C
      F06EJF = NORM
      RETURN
C
C     End of F06EJF. ( DNRM2 )
C
      END

! This programme determines the surface flows of the sun from the
! motions of granule; 
! 9 Novembre 2012  Thierry Roudier

        program cst

        use param_run
        use segmentation
        use thename
        use readfits
        use interpolationroutine
        use moyenne
        use m_time_set
        use OMP_LIB
        
        implicit none

        character strg*4,strgx*4,strgy*4,suff*3,fichier*100

	character fichier2*100

        integer, parameter:: n_six = 1
        integer, parameter:: n_siy = 1
        integer, parameter:: aire_max = 70  ! taille maxi en aire SDO
!       pour l'exemple sinon pour SDO fen= 5,fenetre pour extraction des granules
!!        integer, parameter:: aire_max = 700  ! taille maxi en aire test simu
!!       integer, parameter:: fen = 20
        integer, parameter:: fen = 5 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!        integer, parameter:: volume = 5000000 ! dimensionne poursequence de  30min 
!!        integer, parameter:: volume = 10000000 ! dimensionne poursequence de  60min 
!        integer, parameter:: volume = 20000000 ! dimensionne poursequence de  120min 
        integer  nunu,numero_gran,num_gran,fen2,npp,soma,soma2
        integer   numbermax,debut,ll,BIN
        integer  i,ii,ic,ip,ipp,k,kk,nn,n,f,g,h,mini,maxi,kks,numkks
        integer  ngmax,lifetime,maxim,maximum,numero_a_arreter,maximum1
        integer  xmin,xmax,ymin,ymax,maxi_objp2,maxigran,minigran
        integer  gran,gran2,posx,posy,fusion,nombre_de_granules
        integer  maxi_obj,xn,yn,nouv,nouvv  !!!!,nx,ny
        integer  gran2t,minum,maxnum,comptgrantemp,gran3,comptgrantemp2

        integer, dimension(:),allocatable ::  numero_granule
        integer, dimension(:),allocatable ::  numgrantemp
        integer, dimension(:,:),allocatable :: image,image2
        integer, dimension (:,:),allocatable :: temporaire, image_tmoins1 
        integer, dimension(:,:),allocatable :: temporaire3, temporaire2
        integer, dimension(:,:),allocatable :: masque,masque2,masque_sun
        integer, dimension(:,:),allocatable :: obj_a_tplus1,obj_a_t,obj_a_tmoins1
        integer, dimension(:,:),allocatable :: obj0,obj1,obj2,obj,obj3
        integer, dimension(:,:),allocatable :: image_t,image_tplus1
        
        real hscale,velo_scale,dt,vvx,vvy,xl,yl,cgx,cgy,cgx1,cgy1,t1,t2
        real dist,R_sol,x_cent,y_cent
 
        real, dimension (:),  allocatable :: x,y,vx,vy,dv
        real, dimension(:,:), allocatable :: xtraj0,ytraj0,duree0
        real, dimension(:),allocatable :: XGRAN,YGRAN

        real, dimension(:),allocatable :: XGRANmoins,YGRANmoins   
        real, dimension(:),allocatable :: XGRANfin,YGRANfin
        real, dimension(:,:), allocatable :: YY,XX,XXtemp,YYtemp 
        real, dimension (:) , allocatable :: comptgran,comptgran2,comptgranfin,comptgrant,comptgran3

       include 'form_num.inc'

 ! For reading the image
       real, pointer :: a(:,:)
       real, pointer :: imagesup(:,:)

       integer naxes(2)          
       character numero*4,frame*128
!! Mesure temps de calcul
!N. Renon 23/05/2011
  integer                      :: ir, t_1, t_2
  real(kind=8)                 :: t_cpu_0, t_cpu_1, t_cpu,temps


  
! read the data from standard input
        call input(ngmax,hscale)

! Save the inputfile in the results directory
        call system('cp '//trim(adjustl(input_file))//' '//postprocessingpath)

!pour definir nx et ny on lit la premiere image

! Find the file
        
       ip=1
       nullify(a)
       write(numero,444) ip_start+istep*(ip-1)
       numero=adjustl(numero)
       frame=trim(prefix)//trim(numero)//suffix
        call readimage(frame,a,naxes)  
        nx=naxes(1) 
        ny=naxes(2)
!
       print*,'nx=',nx,'    ny=',ny

        open(unit=16,file=trim(adjustl(postprocessingpath))//'/nb_gran',position='append')
        write(16,*)  v_thres, arcsec, pixel, seuil

! Prepare the index of the traject files
         write(strg,"(i4)") n_six
         strgx=adjustl(strg)
         write(strg,"(i4)") n_siy
         strgy=adjustl(strg)

! Allocations
          fen2=1+2*fen

         allocate(xtraj0(ngmax,2),ytraj0(ngmax,2),duree0(ngmax,2))
         xtraj0=0.; ytraj0=0.;  duree0=0.
     
         allocate(numero_granule(ngmax0)) ; numero_granule=0

         allocate(XGRAN(ngmax0),YGRAN(ngmax0)) ; XGRAN=0 ; YGRAN=0

         allocate(XGRANmoins(ngmax0),YGRANmoins(ngmax0))   
         XGRANmoins=0 ; YGRANmoins=0

         allocate(XGRANfin(ngmax0),YGRANfin(ngmax0)) 
         XGRANfin=0 ; YGRANfin=0

         allocate(image(nx,ny)) ; image=0 
         allocate(image2(fen2,fen2)) ; image2=0 

         allocate(comptgran(ngmax0), comptgran2(ngmax0))
         allocate(comptgran3(ngmax0))
         allocate(comptgranfin(ngmax0),comptgrant(ngmax0))
         allocate(numgrantemp(ngmax0))                     
         
!         allocate(x(volume),y(volume), vx(volume),vy(volume),dv(volume))
         allocate(x(ngmax),y(ngmax), vx(ngmax),vy(ngmax),dv(ngmax))

           x=0 ; y=0 ; vx=0 ;  vy=0 ; dv=0
        
          allocate(image_t(nx,ny)) ; image_t=0
          allocate(masque_sun(nx,ny)) ; masque_sun=0

          allocate(image_tmoins1(nx,ny),temporaire(nx,ny)) 
          image_tmoins1=0 ; temporaire=0  
          allocate(temporaire3(nx,ny)) 
          temporaire3=0 

          allocate(temporaire2(nx,ny))
          temporaire2=0
        
          allocate(image_tplus1(nx,ny)) ; image_tplus1=0

                
          allocate(YY(ngmax0,aire_max)) ; YY=0
          allocate(XX(ngmax0,aire_max)) ; XX=0 

  
          allocate(XXtemp(ngmax0,aire_max),YYtemp(ngmax0,aire_max))
          XXtemp=0 ; YYtemp=0
    !!Modif N Renon 05/2011    
!! Les tableaux sont alloués dans la région parallèle OpenMP  
#ifndef _OPENMP 
print*, "NON OPENMP"  
         allocate(obj_a_tplus1(fen2,fen2)) ; obj_a_tplus1=0
         allocate(obj_a_t(fen2,fen2))      ; obj_a_t=0
         allocate(obj_a_tmoins1(fen2,fen2)) ; obj_a_tmoins1=0
         allocate(masque(fen2,fen2)) ; masque=0
         allocate(masque2(fen2,fen2)) ; masque2=0
         allocate(obj(fen2,fen2),obj1(fen2,fen2)) ; obj=0 ; obj1=0
         allocate(obj2(fen2,fen2)) ; obj2=0 
         allocate(obj0(fen2,fen2)) ; obj0=0 
         allocate(obj3(fen2,fen2)) ; obj3=0 
#endif
!!Fin modif   

!fabrication d'un masque pour isoler le soleil


         
            R_sol=1873.
            x_cent= 2054.47
            y_cent= 2048.21

             do yl=1,ny 
              do xl=1,nx  
                dist=sqrt((xl - x_cent)*(xl - x_cent) + (yl - y_cent)*(yl - y_cent))
                if(dist.lt.R_sol) masque_sun(xl,yl)=1
               end do 
              end do


! *********** BOUCLE SUR TOUTES LES IMAGES -1  ******

         do ip=1,np-1 
          print*,'======================================================='
          print*,'t=',ip
          call cpu_time(t1)

! ======================= PREMIERE IMAGE ====
           if (ip == 1) then
              nullify(a)
             write(numero,444) ip_start+istep*(ip-1)
             numero=adjustl(numero)
             frame=trim(prefix)//trim(numero)//suffix


             call readimage(frame,a,naxes)  ! nx=naxes(1); ny=naxes(2)
             print*,frame


             a=a*real(masque_sun)

             
             call segmentlab(a,nx,ny,ngmax,image_t)       


! image labellisee: image_t 

             deallocate(a)

             nombre_de_granules=maxval(image_t)
             print*,'nombre_de_granules=',nombre_de_granules
             
            print*,'debut du calcul du masque' 


             comptgran(:)=0 

! Centre de gravite - debut calcul -  
             do yl=1,ny 
              do xl=1,nx  
                if(image_t(xl,yl).gt.0) then
                 gran=0
                 gran= image_t(xl,yl)
                 XGRAN(gran)= real(xl)+ XGRAN(gran)
                 YGRAN(gran)= real(yl)+ YGRAN(gran)            
                 comptgran(gran)= comptgran(gran) + 1
                endif
               end do 
              end do
             
              do i=1,nombre_de_granules   
               if(XGRAN(i) .gt. 0)  then  ! pour eviter les numeros non presents
                xtraj0(i,1)= XGRAN(i)/ real(comptgran(i))       ! cgx du debut
                ytraj0(i,1)= YGRAN(i)/ real(comptgran(i)) 
                duree0(i,1)=1  ! debut en temps  
               endif
              enddo                

! Centre de gravite  - fin calcul -  

! on initialise le nombre de granule maximum

              maximum=nombre_de_granules
              temporaire=image_t

!         image t+1      
              ipp= 1+ip
  ! on remet le pointeur bien en place
              nullify(imagesup) 
             write(numero,444) ip_start+istep*(ipp-1)
             numero=adjustl(numero)
             frame=trim(prefix)//trim(numero)//suffix
             print*,frame

              call readimage(frame,imagesup,naxes)  
              
              imagesup=imagesup*real(masque_sun)
         
              call segmentlab(imagesup,nx,ny,ngmax,image_tplus1) ! image labellisee:  image_tplus
              deallocate(imagesup)

              goto 1111
   
            endif                
!===================  FIN PREMIERE IMAGE ====================

           print*,' debut boucle sur les images'

!lecture de l'image a t+1

            ipp=ip+1
          

            nullify(imagesup)
             write(numero,444) ip_start+istep*(ipp-1)
             numero=adjustl(numero)
             frame=trim(prefix)//trim(numero)//suffix
             print*,frame             

           call readimage(frame,imagesup,naxes)   
         
           imagesup=imagesup*real(masque_sun)

           call segmentlab(imagesup,nx,ny,ngmax,image_tplus1) ! image labellisee:  image_tplus1
           deallocate(imagesup)


!image_t        image labellisee a t
!image_tmoins1  image avec la bonne labellisation dans le temps t-1
!
!=======debut de la boucle sur les ndeallocate(imagesup)umeros 
!de granule a t ==============

! on repere les coordonnees a la  tranche t   
! -----------------------------------------

            comptgran(:)=0 

            XGRAN=0
            YGRAN=0

           do yl=1,ny 
             do xl=1,nx    
              if(image_t(xl,yl).gt.0) then
                gran= image_t(xl,yl)

                XGRAN(gran)= real(xl)+ XGRAN(gran)
                YGRAN(gran)= real(yl)+ YGRAN(gran)
                comptgran(gran)= comptgran(gran) +1
              if ( comptgran(gran) .gt. aire_max-1) goto 1010  
               XX(gran,comptgran(gran))=xl 
               YY(gran,comptgran(gran))=yl
              endif
1010       continue
             end do
            end do

    
              nombre_de_granules=maxval(image_t)
 print*,'             nombre_de_granules a t=',maxval(image_t)

! on repere les coordonnees des granules a t-1
! --------------------------------------------
           numbermax=0                  

            temporaire2=0
            comptgran2=0
 
              where(image_tmoins1 .gt. 0)   
               temporaire2=1                         
              endwhere 
                  
            call label(real(temporaire2),nx,ny,ngmax,temporaire2)
            numbermax= maxval(temporaire2)

           do yl=1,ny         
             do xl=1,nx      
              if(temporaire2(xl,yl).gt.0) then           
               gran=temporaire2(xl,yl) 
               numero_granule(gran)= image_tmoins1(xl,yl)                         
               XGRANmoins(gran)= real(xl)+ XGRANmoins(gran)
               YGRANmoins(gran)= real(yl)+ YGRANmoins(gran)
               comptgran2(gran)= comptgran2(gran) +1
              end if
             end do
           end do


! on travaille sur l'image a t
 ! Temps CPU de calcul initial.
  call cpu_time(t_cpu_0)
  ! Temps CPU de restitution initial.
  call system_clock(count=t_1, count_rate=ir)
 
numgrantemp(:)=0
comptgrantemp=0

!$OMP PARALLEL DEFAULT(FIRSTPRIVATE) SHARED(numgrantemp,comptgrantemp,ip,temporaire,nx,ny,XX,YY,XGRAN,YGRAN,XGRANmoins,YGRANmoins,comptgran,comptgran2,comptgranfin,xtraj0,ytraj0,duree0,ngmax0,image_tplus1,image_t,image_tmoins1,nombre_de_granules,maximum,numero_granule,temporaire2,temporaire3)
#ifdef _OPENMP
print*, "IN OPENMP"
       allocate(obj_a_tplus1(fen2,fen2)) ; obj_a_tplus1=0
         allocate(obj_a_t(fen2,fen2))      ; obj_a_t=0
         allocate(obj_a_tmoins1(fen2,fen2)) ; obj_a_tmoins1=0
         allocate(masque(fen2,fen2)) ; masque=0
         allocate(masque2(fen2,fen2)) ; masque2=0
         allocate(obj(fen2,fen2),obj1(fen2,fen2)) ; obj=0 ; obj1=0
         allocate(obj2(fen2,fen2)) ; obj2=0 
         allocate(obj0(fen2,fen2)) ; obj0=0 
         allocate(obj3(fen2,fen2)) ; obj3=0 
!$OMP BARRIER
#endif
!$OMP DO SCHEDULE(RUNTIME)


  do kk= 1, nombre_de_granules  
!  1)on repere le granule dans la tranche t ici ip
            cgx= XGRAN(kk)/ real(comptgran(kk))       ! cgx 
            cgy= YGRAN(kk)/ real(comptgran(kk))       ! cgy

! on prend comme espace de localisation de chaque granule une boite de fen x fen pixels:

            xmin=cgx-fen       !-5 pixels 
            xmax=cgx+fen       !5
            ymin=cgy-fen       !-5  
            ymax=cgy+fen       !5
        
            if(xmin .lt. 1)  goto 123 
            if(xmax .gt. nx) goto 123 
            if(ymin .lt. 1)  goto 123 
            if(ymax .gt. ny) goto 123 
            
          obj_a_t =0 ; obj_a_tmoins1=0

          obj_a_t=image_t(xmin:xmax,ymin:ymax)
          obj_a_tmoins1=temporaire2(xmin:xmax,ymin:ymax)  
  
!           on prend les dimensions du fichier objet
             xn=0  ; yn=0
             xn=size(obj_a_t,1); yn=size(obj_a_t,2) 

!*********************************
!         nouveaux granules      *
!*********************************
! on regarde les numeros de granule dans la tranche t en liaison
! avec le granules a t-1 

!    fabrication d'un masque
!
           masque=0

            where(obj_a_t .eq. kk)    
             masque=1.                          
            endwhere 
! 
            obj=0 
            obj=obj_a_tmoins1*masque     
!                                                        
 

! NOUVEAU GRANULE
           if( sum(obj) .eq.0) then 
             
             do nn= 1, comptgran(kk)      
                if(nn .gt. aire_max-1) goto 5000 
                temporaire(XX(kk,nn),YY(kk,nn))= 1  
             enddo
5000         continue
             goto 123
          endif
          
! SINON on regarde si un granule ou plusieurs t-1
          maxi_obj=0

          if( sum(obj) .gt. 0) then        
                                            
             xn=size(obj,1); yn=size(obj,2) 
             call label(real(obj),xn,yn,ngmax0,obj0)                  
             f=0
             g=0                            
             f=minval(obj0,mask=obj0 .ne.0)  
             g=maxval(obj0,mask=obj0 .ne.0)   
             if (f.eq.g) then               
                maxi_obj=1.
             else
                maxi_obj=g
             endif
        endif
!
!************************************
!  Meme numero de granule qu'a t-1  *
!************************************

            if( maxi_obj .eq. 1)  then 
             h=0 
             h= maxval(obj,mask=obj.ne.0) 
             numero_gran = numero_granule(h)         
             comptgrantemp=comptgrantemp + 1
             numgrantemp(comptgrantemp)=numero_gran
  
              do nunu=1,comptgran(kk)
               if(nunu .gt. aire_max-1)  goto 1114
                posx=XX(kk,nunu)   
                posy=YY(kk,nunu)
          
              if (posx .lt. 1) goto 1114
              if (posx .gt. nx) goto 1114             
              if (posy .lt. 1) goto 1114           
              if (posy .gt. ny) goto 1114            
        
              temporaire3(posx,posy)=numero_gran  
           enddo
1114          continue 

             goto 123
           endif
 
 
!************************************
!         GESTION des jonctions     *
!************************************

            if( maxi_obj .gt.1) then 
! on arrete les granules qui se melangent
! on recupere les numeros des granules a arreter
      
             do n=f,g                    
              soma=0
 
             soma=sum(obj0,mask=obj0.eq.n) 
              
               masque2=0
              
               if (soma .gt. 0) then            
                where(obj0.eq.n)
                 masque2=1
                endwhere
              
              obj2=obj*masque2  
              numero_a_arreter=maxval(obj2 ,mask=obj2.ne.0) 

! recuperer les CGX et CGY dans l'image a  t-1 
           cgx1= XGRANmoins(numero_a_arreter)/ real(comptgran2(numero_a_arreter))       
           cgy1= YGRANmoins(numero_a_arreter)/ real(comptgran2(numero_a_arreter))       
 
          xtraj0(numero_granule(numero_a_arreter),2)= cgx1 
          ytraj0(numero_granule(numero_a_arreter),2)= cgy1   
          duree0(numero_granule(numero_a_arreter),2)=ip-1                
         endif
        enddo

!  c'est donc un nouveau granule a t. 

             do nunu=1,comptgran(kk)
               if(nunu .gt. aire_max-1) goto 1112
 
              posx=XX(kk,nunu)   
              posy=YY(kk,nunu)
              
              if (posx .lt. 1)   goto 1112 
              if (posx .gt. nx)  goto 1112             
              if (posy .lt. 1)   goto 1112           
              if (posy .gt. ny)  goto 1112                    
   
              temporaire(posx,posy)=1       
             enddo                              
1112         continue

          endif
 
!***********************************************************
!                fin   GESTION des jonctions               *
!***********************************************************
!                 FIN de granule seul                      *
!***********************************************************

123 enddo   !fin de la boucle sur les kk
!$OMP END DO
!========================================================


$#ifdef _OPENMP
$        print*, 'DEALLOCATE IN OPENMP'
$         deallocate(obj_a_tplus1,obj_a_t,obj_a_tmoins1)
$         deallocate(masque,masque2)
$         deallocate(obj,obj1)
$         deallocate(obj2)
$         deallocate(obj0)
$         deallocate(obj3)
$#endif
!$OMP END PARALLEL   

  ! Temps CPU de restitution final
  call system_clock(count=t_2, count_rate=ir)
  temps=real(t_2 - t_1,kind=8)/real(ir,kind=8)

  ! Temps CPU de calcul final
  call cpu_time(t_cpu_1)
  t_cpu = t_cpu_1 - t_cpu_0

print*, "temps boucle I granule elepased", temps
print*, "temps boucle I granule cpu ", t_cpu

 ! Temps CPU de calcul initial.
  call cpu_time(t_cpu_0)
  ! Temps CPU de restitution initial.
  call system_clock(count=t_1, count_rate=ir)
          if (sum(temporaire) .gt. 0) then

          call label(real(temporaire),nx,ny,ngmax0,temporaire)

          maxigran= maxval(temporaire)

          if (sum(temporaire).eq.0) then
            minigran=   minval(temporaire)
           else 
            minigran=   minval(temporaire ,mask=temporaire .ne.0) 
          endif

! on repere les coordonnees des granules dans temporaire
! ------------------------------------------------------
            comptgran3(:)=0 
            XGRAN=0
            YGRAN=0

            do yl=1,ny         
             do xl=1,nx      
              if(temporaire(xl,yl).gt.0) then           
               gran3=temporaire(xl,yl)       
               XGRAN(gran3)= xl + XGRAN(gran3)
               YGRAN(gran3)= yl + YGRAN(gran3)

                comptgran3(gran3)= comptgran3(gran3) + 1

             if ( comptgran3(gran3) .gt. aire_max-1) goto 1811
              endif
1811         continue 
             end do
            end do

           comptgrantemp2 = comptgrantemp  
      
 
       print*,'minigran',minigran,'  maxigran=', maxigran

           do nouv=minigran,maxigran
             comptgrantemp2 = comptgrantemp2 +1
             numgrantemp(comptgrantemp2)=nouv
            cgx= XGRAN(nouv)/ real(comptgran3(nouv))       
            cgy= YGRAN(nouv)/ real(comptgran3(nouv))      

             nouvv=nouv+maximum
             maximum1=maximum

            xtraj0(nouvv,1)= cgx        
            ytraj0(nouvv,1)= cgy       
            duree0(nouvv,1)=ip      

           enddo
          
          comptgrantemp = comptgrantemp2

 endif
! on rajoute le nouveaux granules temporaire a ceux qui continuent
 
           where(temporaire .gt. 0)   
            temporaire(:,:)=temporaire(:,:) + maximum                         
           endwhere 
        
        temporaire = temporaire3 + temporaire
    
         maximum= maxval(temporaire)

        
 print*,'=================================='
 print*,' maximum=',maximum
 print*,'=================================='


!=============================================================
! GESTION DES SEPARATIONS
         
!=============================================================
! on repere les coordonnees des granules a t fichier  
! temporaire
            comptgrant(:)=0   
            minum=minval(temporaire,mask= temporaire .gt. 0)
            maxnum= maximum

print*,'minum=',minum,'  maxnum=',maxnum

            XGRAN(:)=0
            YGRAN(:)=0

            numbermax=0                  

              temporaire2=0

              where(temporaire .gt. 0)   
               temporaire2=1                         
              endwhere 
                  
            call label(real(temporaire2),nx,ny,ngmax,temporaire2)
            numbermax= maxval(temporaire2)

           do yl=1,ny         
             do xl=1,nx      
              if(temporaire2(xl,yl).gt.0) then           
               gran2t=temporaire2(xl,yl) 
               numero_granule(gran2t)= temporaire(xl,yl)             
              
               XGRAN(gran2t)= xl+ XGRAN(gran2t)
               YGRAN(gran2t)= yl+ YGRAN(gran2t)
                comptgrant(gran2t)= comptgrant(gran2t) +1

              if ( comptgrant(gran2t) .gt. aire_max-1) goto 1019
               XXtemp(gran2t,comptgrant(gran2t))=xl 
               YYtemp(gran2t,comptgrant(gran2t))=yl
              endif
1019          continue
             end do
           end do


             temporaire2=0

 ! Temps CPU de restitution final
  call system_clock(count=t_2, count_rate=ir)
  temps=real(t_2 - t_1,kind=8)/real(ir,kind=8)

  ! Temps CPU de calcul final
  call cpu_time(t_cpu_1)
  t_cpu = t_cpu_1 - t_cpu_0

print*, "temps intermediaire  granule elepased", temps
print*, "temps intermediaire granule cpu ", t_cpu

 ! Temps CPU de calcul initial.
  call cpu_time(t_cpu_0)
  ! Temps CPU de restitution initial.
  call system_clock(count=t_1, count_rate=ir)
!!!$OMP PARALLEL DEFAULT(FIRSTPRIVATE) SHARED(comptgrantemp,ip,temporaire,nx,ny,XXtemp,YYtemp,XGRANtemp,YGRANtemp,XGRANmoins,YGRANmoins,comptgrant,comptgran,comptgran2,comptgranfin,xtraj0,ytraj0,duree0,ngmax0,image_tplus1,image_t,image_tmoins1,maximum)


!$OMP PARALLEL DEFAULT(FIRSTPRIVATE) SHARED(comptgrantemp,ip,temporaire,nx,ny,XXtemp,YYtemp,XGRANmoins,YGRANmoins,comptgrant,comptgran,comptgran2,comptgranfin,xtraj0,ytraj0,duree0,ngmax0,image_tplus1,image_t,image_tmoins1,maximum)


#ifdef _OPENMP
!!$ 
         allocate(obj_a_tplus1(fen2,fen2)) ; obj_a_tplus1=0
         allocate(obj_a_t(fen2,fen2))      ; obj_a_t=0
         allocate(obj_a_tmoins1(fen2,fen2)) ; obj_a_tmoins1=0
         allocate(masque(fen2,fen2)) ; masque=0
         allocate(masque2(fen2,fen2)) ; masque2=0
         allocate(obj(fen2,fen2),obj1(fen2,fen2)) ; obj=0 ; obj1=0
         allocate(obj2(fen2,fen2)) ; obj2=0 
         allocate(obj0(fen2,fen2)) ; obj0=0 
         allocate(obj3(fen2,fen2)) ; obj3=0 
!$OMP BARRIER
#endif
!$OMP DO SCHEDULE(RUNTIME)


           do kks=1, numbermax                  

!  1)on repere le granule dans la tranche t ici temporaire
            cgx= XGRAN(kks)/ real(comptgrant(kks))       ! 
            cgy= YGRAN(kks)/ real(comptgrant(kks))       !

! on prend comme espace de localisation de chaque granule une boite de fen x fen pixels:
 
            xmin=cgx-fen       !-5 pixels  
            xmax=cgx+fen       !5
            ymin=cgy-fen       !-5  
            ymax=cgy+fen       !5
        
            if(xmin .lt. 1) goto 1239         
            if(xmax .gt. nx) goto 1239
            if( ymin .lt. 1) goto 1239
            if( ymax .gt. ny) goto 1239
 
         
!   on selection dans les images a t, t+1  l'espace ou est 
!localise le granule kks
  
            obj_a_tplus1=0 ; obj_a_t =0 

            obj_a_tplus1=image_tplus1(xmin:xmax,ymin:ymax)    
            obj_a_t=temporaire(xmin:xmax,ymin:ymax)            !    

!           on prend les dimensions du fichier objet
             xn=0  ; yn=0
             xn=size(obj_a_t,1); yn=size(obj_a_t,2) 
!
           masque=0
            where(obj_a_t .eq. numero_granule(kks))    
             masque=1.                
            endwhere 
! 
            obj=0 
            obj=obj_a_tplus1*masque    
 
             soma=  sum(obj,mask=obj .gt.0) 

             if( soma .eq.0) then       

!  c'est la fin du granule kks
           
          xtraj0(numero_granule(kks),2)= cgx    !    
          ytraj0(numero_granule(kks),2)= cgy    !   
          duree0(numero_granule(kks),2)=ip      !   

          do nunu=1,comptgrant(kks) 
            if(nunu .gt. aire_max-1) goto 1116
 
           posx=XXtemp(kks,nunu)   
           posy=YYtemp(kks,nunu)

           if (posx .lt. 1) goto 1116
           if (posx .gt. nx) goto 1116             
           if (posy .lt. 1) goto 1116           
           if (posy .gt. ny) goto 1116            
             
           temporaire(posx,posy)=0

          enddo 

                           
         goto 1239
       endif

1116       continue
!***********************************************************
!GESTION s'il y a plus de 2 structures a t+1               *
!***********************************************************
!
        maxi_obj=0

    if( soma .gt. 0) then                                                    
         f=minval(obj,mask=obj .ne.0) 
         g=maxval(obj,mask=obj .ne.0)  
         if (f.eq.g) then
           maxi_obj=1.
         else
           maxi_obj=g
         endif
      endif

! s'il y en plus de 2 morceaux
! c'est la fin du granule numkks

  if( maxi_obj .gt. 1) then
               
           xtraj0(numero_granule(kks),2)= cgx       !       
           ytraj0(numero_granule(kks),2)= cgy       !       
           duree0(numero_granule(kks),2)=ip         !     

          do nunu=1,comptgrant(kks)  
          if(nunu .gt. aire_max-1) goto 1117
 
            posx=XXtemp(kks,nunu)   
            posy=YYtemp(kks,nunu)

            if (posx .lt. 1) goto 1117
            if (posx .gt. nx) goto 1117             
            if (posy .lt. 1) goto 1117           
            if (posy .gt. ny) goto 1117             
           
           temporaire(posx,posy)=0      
          end do      
       
1117       continue 
end if   
!
!endif

1239      continue              
        
end do !fin de kks  (granules)
!$OMP END DO
!$OMP END PARALLEL

! 
!***********************************************************
!              fin    GESTION des separations              *
!***********************************************************



!========================================================
 ! Temps CPU de restitution final
  call system_clock(count=t_2, count_rate=ir)
  temps=real(t_2 - t_1,kind=8)/real(ir,kind=8)

  ! Temps CPU de calcul final
  call cpu_time(t_cpu_1)
  t_cpu = t_cpu_1 - t_cpu_0

print*, "temps boucle II granule elepased", temps
print*, "temps boucle II granule cpu ", t_cpu
!on arrete les granules pour la derniere image

       npp=np-1

       if(ip .eq. npp) then       ! avant derniere image
        comptgranfin(:)=0
       
            temporaire2=0

              where(temporaire .gt. 0)   
               temporaire2=1                         
              endwhere 
                  
            call label(real(temporaire2),nx,ny,ngmax,temporaire2)
            numbermax= maxval(temporaire2)

! Centre de gravite
           do yl=1,ny         
             do xl=1,nx      
              if(temporaire2(xl,yl).gt.0) then           
               gran=temporaire2(xl,yl) 
               numero_granule(gran)= temporaire(xl,yl)             
              
                comptgrant(gran)= comptgrant(gran) +1
                XGRANfin(gran)= xl+ XGRANfin(gran)
                YGRANfin(gran)= yl+ YGRANfin(gran)
                comptgranfin(gran)= comptgranfin(gran) +1
              if ( comptgranfin(gran) .gt. aire_max-1) goto 1049
              endif
1049          continue
             end do
           end do

  
        do i=1,numbermax
          xtraj0(numero_granule(i),2)= real(XGRANfin(i)/ comptgranfin(i))       
          ytraj0(numero_granule(i),2)= real(YGRANfin(i)/ comptgranfin(i)) 
          duree0(numero_granule(i),2)=ip      ! fin en temps 
        enddo  

        goto 2000
       endif

1111     continue                                 !suivant:

         maxim=maxval(temporaire)

         image_tmoins1=temporaire       
         image_t=image_tplus1

!     remise a zero
         numero_granule(:)=0

         image_tplus1(:,:)=0 
         temporaire(:,:)=0 
         temporaire2(:,:)=0
         temporaire3(:,:)=0

         XXtemp(:,:)=0
         YYtemp(:,:)=0
         comptgrantemp=0
         comptgran3(:)=0     
         comptgran2(:)=0 
         XGRAN(:)=0 
         YGRAN(:)=0 
         XGRANmoins(:)=0 
         YGRANmoins(:)=0 
         ipp=0
        call cpu_time(t2)
        
        print*,'duree de calcul=',t2-t1


!
2000    enddo !  ********** Fin de la boucle sur les images  *
      
! Output of the trajectories and velocity field

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
         ic=1
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

         write(suff,"(i3)") ic
         fichier=trim(adjustl(postprocessingpath)) &
          //'/traject'//trim(adjustl(suff))//'_'// &
                 trim(strgx)//trim(strgy)
         open(unit=3,file=fichier)

         write(6,100) ic,maximum

100        format('Step number ',i3,'  Number of granule detected',f7.1)
           write(3,*) ic, maximum  

         ii=0; x=0.; y=0.; vx=0.; vy=0.; dv=0.
         lifetime=0d0

         print*, '          maximum=',maximum

         do i=1,maximum ! loop on the all the granules  
           
           if ( duree0(i,2) .ne. 0) then

!    Granules with a lifetime less than t_thresh are not used
         lifetime=(duree0(i,2)-duree0(i,1))*timestep    
       
           if ( lifetime < t_thres) goto 300
           velo_scale=hscale/lifetime ! km/s
    
            vvx=0 ; vvy=0

            vvx=(xtraj0(i,2)-xtraj0(i,1))*velo_scale
            vvy=(ytraj0(i,2)-ytraj0(i,1))*velo_scale
! on retire les vitesses > v_thres definie dans les donnees
            if ( abs(vvx) > v_thres) goto 300
            if ( abs(vvy) > v_thres) goto 300           

           ii=ii+1
           vx(ii)=(xtraj0(i,2)-xtraj0(i,1))*velo_scale
           vy(ii)=(ytraj0(i,2)-ytraj0(i,1))*velo_scale
           x(ii)=(xtraj0(i,2)+xtraj0(i,1))/2.
           y(ii)=(ytraj0(i,2)+ytraj0(i,1))/2.
           dv(ii)=delta_pix

           write(3,10) ii,x(ii),y(ii),duree0(i,1),duree0(i,2),lifetime,vx(ii),vy(ii)

           endif
300      enddo ! i and ii
 
          close(3)

10         format(i9,2x,2(1x,0pf8.2),2(1x,0pf8.2),2x,i9,1x,2(1x,0pf7.3))
         
          
          print*,'Nombre de points de mesure a interpoler',ii


 ! Temps CPU de calcul initial.
          call cpu_time(t_cpu_0)
  ! Temps CPU de restitution initial.
          call system_clock(count=t_1, count_rate=ir)

          call interpol2d_routine(vx,vy,dv,x,y,ii,ic)
        
 !========================================================
 ! Temps CPU de restitution final
  call system_clock(count=t_2, count_rate=ir)
  temps=real(t_2 - t_1,kind=8)/real(ir,kind=8)

  ! Temps CPU de calcul final
  call cpu_time(t_cpu_1)
  t_cpu = t_cpu_1 - t_cpu_0

  print*, "temps interlope  elepased", temps
  print*, "temps interlope cpu ", t_cpu  


end program cst

! input of data
! ngmax: the maximum number of granules detected in one samplping time window
! scale: the number of km per pixel

	subroutine input(ngmax,the_scale)
	use param_run
	use mgetpar
	use readfits
!	use map_dxy
	use m_time_set
	use thename

	implicit none

	real the_scale,s0,surfac
        real, pointer :: a(:,:)
        character equid*3,segm*3
	integer i,ii,ngmax,naxes(2)
	character*128, pointer :: frame(:)
	character*80 :: file_of_compl

 
	call read_stdin
	option=fetch('option','vitesse')
	convolution=fetch('convolution','Id')
	nconv=fetch('nconv',5)     ! size of the convolving window in pix
	ip_start=fetch('ip_start',1)  ! number of the first image
	np=fetch('np',2)
	n_ech = fetch('n_ech',2)
	n_life = fetch('n_life',60)
	ngmax0 = fetch('ngmax0',100)
	ngmax = fetch('ngmax',100)
	istep = fetch('istep',1)
	prec = fetch('precision',0.5)
	bin_sp = fetch('bin_sp',6)
	delta_pix = fetch('delta_pix',0.2)
	arcsec = fetch('arcsec',728e3)
	pixel = fetch('pixel',0.14)
	the_scale=arcsec*pixel
	timestep = fetch('timestep',20.)
	timestep=timestep*abs(istep)
	v_thres=fetch('v_thres',5.0)
	seuil_min=fetch('seuil_min',0.5)
	t_thres=fetch('t_thres',0.0)
	seuil=v_thres*timestep/pixel/arcsec
	print*,'threshold for ID in pixel', seuil

	input_file=fetch('input_file',' ')
	prefix=fetch('prefix','nodir')
	suffix=fetch('suffix','.fits')
	postprocessingpath=fetch('ppp','results/')
	check=fetch('check','no')
	verbose=fetch('verbose',0)
        print*,'verbo',verbose
	wavelet=fetch('wavelet','daub4') ! other options =daub8,splines,lemarie
! Segmentation parameters
	segm=fetch('segmentation','no')
	segmented=(segm == 'yes')
	typeseg=fetch('segmentation_type','strouss')
	ech_lap=fetch('ech_lap',1.5)
	seuil_lap=fetch('seuil_lap',10.)
	seuil_rel=fetch('seuil_rel',0.4)
	seuil_courb=fetch('seuil_courb',0.1)
	seuil_bas=fetch('seuil_bas',-10.)
	seuil_haut=fetch('seuil_haut',10.)
	n_moy=fetch('n_moy',5)


! The default time-sampling is assumed regular
	equid=fetch('equidistance','yes')
	equidistance=(equid == 'yes')
        if (.not. equidistance) the_time_file=fetch('the_times','nofiletime')
        print*,'Time file = ',the_time_file

! Number of time-series
	allocate(nbs(np))
	nbs_max=fetch('nb_series',1)
	n_ref=fetch('n_ref',1)
	nbs(:)=nbs_max
	if (nbs_max > 1) then 
	! Here we read the file containing the number of (good) images
	! at each time step
	  file_of_compl=fetch('file_of_completeness','nofile')
	  if (file_of_compl /= 'nofile') then
	   open(unit=1,file=file_of_compl)
	    read(1,*) nbs(1:np)
	   close(1)
	  endif
	! you must give the place of the distorsion maps
          path_distor=fetch('path_distor','distor')
!	  call setup_themap(nx,ny)
	endif

! parametres de la sous-image
	sub_im=1
	nx1=fetch('nx1',1)
	nx2=fetch('nx2',9999)
	ny1=fetch('ny1',1)
	ny2=fetch('ny2',9999)
	maxdim=fetch('maxdim',9999)
        nx=nx2-nx1+1; ny=ny2-ny1+1

	if (nx2== 9999 .or. ny2==9999) then
	 call the_name(1,frame)
         call readimage(frame(1),a,naxes)
         print*,'read frame in input : ',frame(1)
         nx2=naxes(1); ny2=naxes(2)
         if ( .not. associated(a)) print*,'pas d''image lue en input, nx2,ny2',nx2,ny2
	 if (associated(a)) deallocate(a)
       
         nx=nx2-nx1+1; ny=ny2-ny1+1
         if (nx <0 .or. ny <0 .or. nx>naxes(1) .or. ny>naxes(2)) &
               stop'in input.f90: the sub-image is larger than the image!'
	endif

! Surface of the image determines the maximum number of granules (ngmax)

	surfac=(nx2-nx1)*(ny2-ny1)*pixel**2 ! in arcsec^2
!	ngmax0=2300+700*n_ech*istep
!	ngmax0=230+70*n_ech*istep
	s0=4096
!	ngmax=2*ngmax0*surfac/s0         ! facteur 2 pour la surete
!	ngmax=900000  ! pour 1.8Go (altair)
!	ngmax=1000000 ! pour soleil2
!	ngmax=1000000 ! pour soleil2
!	ngmax=500000  ! pour 1.8Go (altair)
!	ngmax=700000  ! pour 1.8Go (altair)
!	ngmax=350000 ! pour soleil2 avec cst
!	ngmax=30000 ! pour soleil2 avec cst_new

	print*,'le ngmax =',ngmax, 'ngmax0 =',ngmax0

! test a priori: la vitesse max est de l'ordre de 1km/s, si la frequence
! d'echantillonnage est trop haute on ne peut atteindre une grande
! precision
	if (prec < delta_pix*pixel*arcsec/n_ech/timestep/1000) &
	    stop'precision required is too high !'

! the set of dates in seconds : if irregular they should be user-supplied

        if (equidistance) then 
	 allocate(t(ip_start+istep*np))
	 t=(/ (i*timestep, i=0,ip_start+istep*np-1) /)
	else 
	 call the_time_set(the_time_file)
	endif

	end

! Module pour la derivation dans la direction 'n' d'un champ 2D represente
! sur une base d'ondelette de Daubechies. Algorithme basé sur le travail
! de Beylkin 1992, SIAM J. Numer. Anal. 6, 1716
!
! Module for computing the derivative of a 2D field represented on a
! Daubechies wavelet base. The algorithm is based on the work of Beylkin
! 1992, SIAM J. Numer. Anal. 6, 1716
!
! M. Rieutord le 11/7/2000
! 
! Encompass other wavelets in March 2001

	module deriw2d

contains

	function dx(f,n) result(value)

	use param_run
	implicit none

	real(kind(0d0)),pointer, dimension(:,:) :: f,value
	real(kind(0d0)), allocatable, dimension(:) :: r
	integer dim1,dim2,i,j,k,n,ll,L

! Calcul des coefficients de la matrice de derivation 'r'

! choose the wavelet
        if (wavelet == 'daub4') L=8
        if (wavelet == 'daub8') L=16
        if (wavelet == 'lemarie') L=16
        if (wavelet /= 'daub4' .and. wavelet /='daub8' .and. &
            wavelet /= 'lemarie') stop'in deriw2d: no wavelet supplied'

        allocate(r(-L+2:L-2))
        call coef_r(r,L)
	

	dim1=size(f,1) ; dim2=size(f,2)
	allocate(value(dim1,dim2))

	if (n ==1) then
! calcul de la derivee dans la direction '1'
         do j=1,dim2
          do i=1,dim1
           value(i,j)=0d0
           do ll=1,dim1
            if (i-ll >= -L+2 .and. i-ll <= L-2)  &
                     value(i,j)=value(i,j)+r(i-ll)*f(ll,j)
           enddo
          enddo
         enddo
!	 value=value*dim1
	else
         do i=1,dim1
          do j=1,dim2
           value(i,j)=0d0
           do ll=1,dim2
            if (j-ll >= -L+2 .and. j-ll <= L-2)  &
                     value(i,j)=value(i,j)+r(j-ll)*f(i,ll)
           enddo
          enddo
         enddo
!	 value=value*dim2
	endif
	deallocate(r)
	end function

	end module

      module m_writefits

contains
      subroutine writeimage(filename,array,nx,ny,bitpix)

!     Create a FITS primary array containing a 2-D image

      integer status,unit,blocksize,bitpix,naxis,naxes(2)
      integer i,j,group,fpixel,nelements,array(nx,ny)
      integer nx,ny
      character filename*(*)
      logical simple,extend

      status=0
!     Name of the FITS file to be created:
!     filename='ATESTFILEnew.FITS'

!     Get an unused Logical Unit Number to use to create the FITS file
      call ftgiou(unit,status)

!     create the new empty FITS file
      blocksize=1
      call ftinit(unit,filename,blocksize,status)

!  Initialize parameters about the FITS image.
!  BITPIX = 16 means that the image pixels will consist of 16-bit
!  integers.  The size of the image is given by the NAXES values. 
!  The EXTEND = TRUE parameter indicates that the FITS file
!  may contain extensions following the primary array.
      simple=.true.
!     bitpix=16
!     bitpix=8
      naxis=2
      naxes(1)=nx
      naxes(2)=ny
      extend=.true.

!     write the required header keywords
      call ftphpr(unit,simple,bitpix,naxis,naxes,0,1,extend,status)


!  Write the array to the FITS file.
!  The last letter of the subroutine name defines the datatype of the
!  array argument; in this case the 'J' indicates that the array has an
!  integer*4 datatype. ('I' = I*2, 'E' = Real*4, 'D' = Real*8).
!  The 2D array is treated as a single 1-D array with NAXIS1 * NAXIS2
!  total number of pixels.  GROUP is seldom used parameter that should
!  almost always be set = 1.
      group=1
      fpixel=1
      nelements=naxes(1)*naxes(2)
      call ftpprj(unit,group,fpixel,nelements,array,status)

!     write another optional keyword to the header
      call ftpkyj(unit,'EXPOSURE',1500,'Total Exposure Time',status)

!     close the file and free the unit number
      call ftclos(unit, status)
      call ftfiou(unit, status)
      end subroutine

      end module

      DOUBLE PRECISION FUNCTION X02ALF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS  (1 - B**(-P)) * B**EMAX  (THE LARGEST POSITIVE MODEL
C     NUMBER)
C
      DOUBLE PRECISION X02CON
      DATA X02CON /Z'7FEFFFFFFFFFFFFF' /
C     .. Executable Statements ..
      X02ALF = X02CON
      RETURN
      END

c***********************************************************************
      REAL FUNCTION RFETCH(name_variable,default)
c***
      INCLUDE 'undefined.h'
      INCLUDE 'GP_common.h'
      REAL  default, GETREAL
      CHARACTER*(*) name_variable
      INTEGER line, FINDSTRING
      EXTERNAL GETREAL, FINDSTRING
c***
      line = FINDSTRING(name_variable)
      if (line .eq. 0) then
         RFETCH = default
       else
         RFETCH = GETREAL(line)
      endif
c***
c---       write (*,*) RFETCH
c***
      return
      end

      SUBROUTINE C05PDF(IREVCM,N,X,FVEC,FJAC,LDFJAC,XTOL,DIAG,MODE,
     *                  FACTOR,R,LR,QTF,W,IFAIL)
C     MARK 14 RELEASE. NAG COPYRIGHT 1989.
C     **********
C
C     SUBROUTINE C05PDF
C
C     The purpose of C05PDF is to interface to C05PDZ.
C     The latter is based upon MINPACK routine HYBRJ.
C
C     **********
C
C     Revised to output explanatory messages.
C     P.J.D. Mayes, NAG Central Office, December 1987.
C     Revised to reverse communication.
C     M.S. Derakhshan, NAG Central Office, September 1988.
C
C     ..Subroutine Arguments ..
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='C05PDF')
      DOUBLE PRECISION  ZERO
      PARAMETER         (ZERO=0.0D0)
C     .. Scalar Arguments ..
      DOUBLE PRECISION  FACTOR, XTOL
      INTEGER           IFAIL, IREVCM, LDFJAC, LR, MODE, N
C     .. Array Arguments ..
      DOUBLE PRECISION  DIAG(N), FJAC(LDFJAC,N), FVEC(N), QTF(N), R(LR),
     *                  W(N,4), X(N)
C     .. Local Scalars ..
      INTEGER           INFO, LR1, NREC
C     .. Local Arrays ..
      CHARACTER*80      P01REC(2)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          C05PDZ
C     .. Save statement ..
      SAVE
C     .. Executable Statements ..
C
      IF (IREVCM.NE.0) GO TO 20
      INFO = 1
      LR1 = N*(N+1)/2
      NREC = 0
      IF (N.LE.0) THEN
         WRITE (P01REC,FMT=99999) N
         NREC = 1
         GO TO 40
      ELSE IF (LDFJAC.LT.N) THEN
         WRITE (P01REC,FMT=99998) LDFJAC, N
         NREC = 2
         GO TO 40
      ELSE IF (XTOL.LT.ZERO) THEN
         WRITE (P01REC,FMT=99997) XTOL
         NREC = 1
         GO TO 40
      ELSE IF (FACTOR.LE.ZERO) THEN
         WRITE (P01REC,FMT=99996) FACTOR
         NREC = 1
         GO TO 40
      ELSE IF (LR.LT.LR1) THEN
         WRITE (P01REC,FMT=99995) LR, LR1
         NREC = 2
         GO TO 40
      END IF
   20 IF (IREVCM.LT.0 .OR. IREVCM.GT.3) THEN
         INFO = 2
         WRITE (P01REC,FMT=99993) IREVCM
         NREC = 1
         GO TO 40
      END IF
      CONTINUE
      CALL C05PDZ(IREVCM,N,X,FVEC,FJAC,LDFJAC,XTOL,DIAG,MODE,FACTOR,
     *            INFO,R,LR,QTF,W(1,1),W(1,2),W(1,3),W(1,4))
      IF (IREVCM.GT.0) RETURN
      IF (INFO.EQ.1) THEN
         WRITE (P01REC,FMT=99992)
         NREC = 1
      ELSE IF (INFO.EQ.3) THEN
         WRITE (P01REC,FMT=99994) XTOL
         NREC = 2
      ELSE IF (INFO.EQ.4) THEN
         WRITE (P01REC,FMT=99991)
         NREC = 2
      ELSE IF (INFO.EQ.5) THEN
         WRITE (P01REC,FMT=99990)
         NREC = 2
      END IF
   40 IFAIL = P01ABF(IFAIL,INFO,SRNAME,NREC,P01REC)
      RETURN
C
99999 FORMAT (' ** On entry, N must be greater than 0: N = ',I16)
99998 FORMAT (' ** On entry, LDFJAC must be at least N:',/' ** LDFJAC ',
     *       '= ',I16,',    N = ',I16)
99997 FORMAT (' ** On entry, XTOL must be at least 0.0: XTOL = ',1P,
     *       D13.5)
99996 FORMAT (' ** On entry, FACTOR must be greater than 0.0: FACTOR = '
     *       ,1P,D13.5)
99995 FORMAT (' ** On entry, LR must be at least N*(N+1)/2:',/' ** LR ',
     *       '= ',I16,',    N*(N+1)/2 = ',I16)
99994 FORMAT (' ** No further improvement in the solution is possible.',
     *       /' ** XTOL is too small: XTOL = ',1P,D13.5)
99993 FORMAT (' ** On entry, IREVCM was not set to 0,1,2,3: IREVCM = ',
     *       I16)
99992 FORMAT (' ** On entry, MODE=2 and DIAG contained a non-positive ',
     *       'element.')
99991 FORMAT (' ** The iteration is not making good progress as measur',
     *       'ed',/' ** by the improvement from the last 5 Jacobian ev',
     *       'aluations')
99990 FORMAT (' ** The iteration is not making good progress as measur',
     *       'ed',/' ** by the improvement from the last 10 iterations '
     *       )
      END

	module polynomes

contains
! fonction polynomiale p(x,y)
! coefficient de X^n Y^m == coef(n+1,m+1)

	real(kind(0d0)) function val_pol (coef, X, Y)

	implicit none

	integer m,n,i,j
	real(kind(0d0)) coef(:,:),x,y,p

	n=size(coef,1) ; m=size(coef,2)
! n+1 puissance max en x
! m+1 puissance max en y
	
	do j=m,1,-1
	  p=coef(n,j)
	  do i=n-1,1,-1
	   p=p*x+ coef(i,j)
	  enddo
	  if (j == m) then
            val_pol=p
	  else
           val_pol=val_pol*y+p
	  endif
	enddo

	end function

	real(kind(0d0)) function dx_pol (coef, X, Y)

	implicit none

	integer m,n,i,j
	real(kind(0d0)) coef(:,:),x,y,p,dp

	n=size(coef,1) ; m=size(coef,2)
! n+1 puissance max en x
! m+1 puissance max en y
	
	do j=m,1,-1
	  p=coef(n,j)
	  dp=0d0
	  do i=n-1,1,-1
	   dp=dp*x+p
	   p=p*x+ coef(i,j)
	  enddo
	  if (j == m) then
            dx_pol=dp
	  else
           dx_pol=dx_pol*y+dp
	  endif
	enddo

	end function

	real(kind(0d0)) function dy_pol (coef, X, Y)

	implicit none

	integer m,n,i,j
	real(kind(0d0)) coef(:,:),x,y,p,pol

	n=size(coef,1) ; m=size(coef,2)
! n+1 puissance max en x
! m+1 puissance max en y
	
	do j=m,1,-1
	  p=coef(n,j)
	  do i=n-1,1,-1
	   p=p*x+ coef(i,j)
	  enddo
	  if (j == m) then
            dy_pol=0d0
	    pol=p
	  else
           dy_pol=dy_pol*y+pol
           pol=pol*y+p
	  endif
	enddo

	end function

	subroutine deriv_pol(coef,coefx,coefy)

	real(kind(0d0)) coef(:,:)
	real(kind(0d0)), pointer :: coefx(:,:), coefy(:,:)
	integer i,j,nx,ny

	nx=size(coef,1); ny=size(coef,2)
	allocate(coefx(nx-1,ny),coefy(nx,ny-1))

	do j=1,ny
	 do i=1,nx-1
	  coefx(i,j)=i*coef(i+1,j)
	 enddo
	enddo
	
	do j=1,ny-1
	 do i=1,nx
  	  coefy(i,j)=j*coef(i,j+1)
	 enddo
	enddo
	
	end subroutine

	real(kind(0d0)) function jacob(coefx,coefy,x,y)

	real(kind(0d0)) coefx(:,:),coefy(:,:),x,y,p_xx,p_yy,p_xy

	p_xx=dx_pol(coefx,x,y)
	p_yy=dy_pol(coefy,x,y)
	p_xy=dx_pol(coefy,x,y)

	jacob=p_xx*p_yy-(p_xy)**2
	end function

	end module

! detection des structure dans une image binarisee par une fonction
! recursive.

	module detection

contains

	subroutine detect(a,nx,ny,xg,yg,surf,nff)

	use belong

	implicit none

	real xg(:),yg(:)
	double precision g(3)
	integer k,res,i,j,surf(:),nff,nx,ny
	integer, dimension (nx,ny) :: a

	xg=0.; yg=0.; surf=0

	k=1
	do j=1,ny
	 do i=1,nx
	  if (a(i,j) == 4) then
	   g=0.
	   res=belong_to(a,i,j,g)
	   if (nint(g(3)) > 20) then ! on n'enregistre pas le bruit
	    xg(k)=g(1)/g(3)
	    yg(k)=g(2)/g(3)
	    surf(k)=nint(g(3))
	    k=k+1 
	   endif
	  endif
	 enddo
	enddo

 	print*,'nb de structures',k-1
	nff=k-1

	end subroutine

	end module

! Compute the divergence of a horizontal vector field vx(x,y),vy(x,y)
! represented by its discrete approximation using Daubechies' wavelets.
! Using the errors on the velocity field we also evaluate the errors on
! the divergence field
!
! M. Rieutord, 27/6/2000
!
! Add the curl, correct delta_div and rename the module, 8/3/01


	module m_div_curl

contains
	subroutine divergence(ux,uy,du,div,delta_div)

	use deriw2d

	implicit none

	real(kind(0d0)), pointer, dimension(:,:) :: ux,uy,du,div,delta_div
	integer n1,n2
	
	n1=size(ux,1); n2=size(uy,2)
	allocate(div(n1,n2),delta_div(n1,n2))

	div=dx(ux,1)+dx(uy,2)
	delta_div=abs(dx(du,1))+abs(dx(du,2))

	end subroutine

        subroutine rot(ux,uy,du,curl,delta_curl)

        use deriw2d

        implicit none

        real(kind(0d0)), pointer, dimension(:,:) :: ux,uy,du,curl,delta_curl
        integer n1,n2

        n1=size(ux,1); n2=size(uy,2)
        allocate(curl(n1,n2),delta_curl(n1,n2))

        curl=dx(uy,1)-dx(ux,2)
        delta_curl=abs(dx(du,1))+abs(dx(du,2))

        end subroutine

	end module

! Program sampling the velocity field and making the wavelet
! filtering/approximation.
! Author: Michel Rieutord
! new version for the computation of the velocity field 31/8/2006

! input: vx,vy,x,y (velocities and positions of the granules)
! output: write, through the output.f90 routine, files containing the original
! velocity field sampled on a regular grid, and first wavelet-filtered fields
! with resolutions decreasing by a factor 2 each time.
! h-suffix = half resol. compared to original field
! m-suffix = quarter   "    "      "   "       "
! l-suffix = eigth   "    "      "   "       "
! The filtering can be increased by increasing ns


        module interpolationth

contains
        subroutine interpol2dth(vx,vy,dv,x,y,n,nc,nnx,nny)

        use param_run
        use m_mres2d
        use m_div_curl
        use deriw2d
        use m_output

        implicit none

        real, dimension (:), intent(in) :: vx,vy,dv,x,y
        integer, intent(in) :: n,nc,nnx,nny
        real, dimension (:,:), allocatable :: rms_ux,rms_uy

        real(kind(0d0)), dimension (:,:), allocatable :: &
                         ux_detail,du_detail,uy_detail
        real(kind(0d0)), target, dimension (:,:), allocatable :: ux,uy, &
         du,ux_recons,uy_recons,du_recons,rxx,rxy,ryy,u2ux,u2uy,u2,buf, &
         sxx,sxy,syy,bufb,rxx_recons,rxy_recons,ryy_recons, &
         sxx_recons,sxy_recons,syy_recons

        real(kind(0d0)), pointer, dimension(:,:) :: uxp,uyp,dup,div, &
         del_div,curl,rx,ry

        real xmin,xmax,ymin,ymax,dvmin,dumoy,uxmoy,uymoy,u2uxmoy,u2uymoy
        real u2m,rxxmoy,rxymoy,ryymoy,sxxmoy,sxymoy,syymoy
        integer bin_sp_test,dimx,dimy,i,ii,il,j,jj,k,l,ns,kk(1000)
        logical warn

! Make the matrices of data
        !xmin=minval(x(1:n)); xmax=maxval(x(1:n))
        !ymin=minval(y(1:n)); ymax=maxval(y(1:n))
;        xmin=nx1; xmax=nx2
;        ymin=ny1; ymax=ny2
        xmin=0 ; xmax=nnx !!!!!!!! THIERRY LE 7 AVRIL 2011
        ymin=0 ; ymax=nny !!!!!!!! THIERRY LE 7 AVRIL 2011

        dimx=int((xmax-xmin)/bin_sp)+1
        dimy=int((ymax-ymin)/bin_sp)+1
  !!      print*,'nx1,nx2,ny1,ny2',nx1,nx2,ny1,ny2
  !!      print*,'dimensions x y',dimx,dimy

        allocate(ux(dimx,dimy),uy(dimx,dimy),du(dimx,dimy))
        allocate(u2ux(dimx,dimy),u2uy(dimx,dimy),u2(dimx,dimy))
        allocate(rms_ux(dimx,dimy),rms_uy(dimx,dimy))
        allocate(buf(dimx,dimy),bufb(dimx,dimy))
        allocate(ux_recons(dimx,dimy),uy_recons(dimx,dimy))
        allocate(ux_detail(dimx,dimy),uy_detail(dimx,dimy))
        allocate(du_recons(dimx,dimy),du_detail(dimx,dimy))
        allocate(rxx(dimx,dimy),rxy(dimx,dimy),ryy(dimx,dimy))
        allocate(rxx_recons(dimx,dimy),rxy_recons(dimx,dimy),ryy_recons(dimx,dimy))
        allocate(sxx_recons(dimx,dimy),sxy_recons(dimx,dimy),syy_recons(dimx,dimy))
        allocate(sxx(dimx,dimy),sxy(dimx,dimy),syy(dimx,dimy))

! Mise a zero (s'avere necessaire)
        ux=0d0;  uy=0d0; du=0d0; du_recons=0d0; du_detail=0d0
        rms_ux=0d0;  rms_uy=0d0
        ux_recons=0d0; uy_recons=0d0; ux_detail=0d0; uy_detail=0d0
        rxx=0; rxy=0; ryy=0; u2ux=0; u2uy=0; u2=0

! Scan the bins of the velocity map
! For each bin, take the average velocity of granules falling in the bin

        do j=1,dimy
!!         print*,'progress',j,dimy
         do i=1,dimx
! bin (i,j) : find all the granules falling in it!
          l=0; kk=0
          do k=1,n
           ii=int((x(k)-xmin)/bin_sp)+1
           jj=int((y(k)-ymin)/bin_sp)+1
           if ( abs(i-ii)+abs(j-jj) == 0) then
            l=l+1
            kk(l)=k
           endif
          enddo
! Compute the mean velocity in bin (i,j)
          ux(i,j)=0; uy(i,j)=0; u2(i,j)=0
          u2ux(i,j)=0; u2uy(i,j)=0; rxx(i,j)=0; rxy(i,j)=0; ryy(i,j)=0
          do il=1,l
           ux(i,j)=ux(i,j)+vx(kk(il))/l
           uy(i,j)=uy(i,j)+vy(kk(il))/l
           u2(i,j)=u2(i,j)+(vx(kk(il))**2+vy(kk(il))**2)/l
           u2ux(i,j)=u2ux(i,j)+(vx(kk(il))**2+vy(kk(il))**2)*vx(kk(il))/l
           u2uy(i,j)=u2uy(i,j)+(vx(kk(il))**2+vy(kk(il))**2)*vy(kk(il))/l
           rxx(i,j)=rxx(i,j)+vx(kk(il))**2/l
           rxy(i,j)=rxy(i,j)+vx(kk(il))*vy(kk(il))/l
           ryy(i,j)=ryy(i,j)+vy(kk(il))**2/l
          enddo
          if (i==1 .and. j==1 .and. verbose>=2) then
           do il=1,l
 !!!          print*,'l,vx,vy',il,kk(il),vx(kk(il)),vy(kk(il))
           enddo
!!!           print*,'moyenne',ux(i,j),uy(i,j)
          endif
! Rms of velocity in bin (i,j)
          rms_ux(i,j)=0; rms_uy(i,j)=0
          do il=1,l
           rms_ux(i,j)=rms_ux(i,j)+(vx(kk(il))-ux(i,j))**2/l
           rms_uy(i,j)=rms_uy(i,j)+(vy(kk(il))-uy(i,j))**2/l
          enddo
          rms_ux(i,j)=sqrt(rms_ux(i,j)); rms_uy(i,j)=sqrt(rms_uy(i,j))
          du(i,j)=sqrt(rms_ux(i,j)+rms_uy(i,j))/sqrt(2d0)
          if (verbose>=2) print*,'nb granules in ij',i,j,l
          if (verbose>=2) print*,'u',ux(i,j),uy(i,j)
          if (verbose>=2) print*,'rms',du(i,j)
         enddo
        enddo
   !!     print*,'percentage of data',real(count(abs(ux)+abs(uy) /= 0d0))/size(ux)

! Sortie des champs originaux (contenant les zeros)
         uxp => ux
         uyp => uy
         dup => du
         call divergence(uxp,uyp,dup,div,del_div)
         call rot(uxp,uyp,dup,curl,del_div)
         ns=0
         call output(ux,'ux',dimx,dimy,nc,ns)
         call output(uy,'uy',dimx,dimy,nc,ns)
         call output(div,'div',dimx,dimy,nc,ns)
         call output(curl,'rot',dimx,dimy,nc,ns)
         call output(du,'err',dimx,dimy,nc,ns)
! Shear
         buf=dx(uxp,1)
         call output(buf,'sxx',dimx,dimy,nc,ns)
         buf=dx(uyp,1)+dx(uxp,2)
         call output(buf,'sxy',dimx,dimy,nc,ns)
         buf=dx(uyp,2)
         call output(buf,'syy',dimx,dimy,nc,ns)

! Output of the Reynolds stress
         call output(rxx,'rxx',dimx,dimy,nc,ns)
         call output(rxy,'rxy',dimx,dimy,nc,ns)
         call output(ryy,'ryy',dimx,dimy,nc,ns)
         uxp => u2ux
         uyp => u2uy
         call divergence(uxp,uyp,dup,div,del_div)
         call output(div,'tra',dimx,dimy,nc,ns)
! The same but using <u^2>
         buf=(ux**2+uy**2)*ux
         bufb=(ux**2+uy**2)*uy
         uxp => buf
         uyp => bufb
         call divergence(uxp,uyp,dup,div,del_div)
         call output(div,'trb',dimx,dimy,nc,ns)

! Direct calculation of v_j\partial_j v^2
         uxp => u2
         buf=ux*dx(uxp,1)+uy*dx(uxp,2)
         call output(buf,'trc',dimx,dimy,nc,ns)


!        print*,'ux apres le 1er output',ux(1:10,1:10)
! décompositions ondelettes de Daubechies + reconstruction
! the largest scale is given by the user: it is N_min (the minimum
! spatial frequency).

! number of scales
!        ns=int(log(real(min(dimx,dimy)/n_min))/log(2.))+1

        uxmoy=sum(ux)/size(ux); ux=ux-uxmoy
        uymoy=sum(uy)/size(uy); uy=uy-uymoy
        dumoy=sum(du)/size(du); du=du-dumoy
        u2uxmoy=sum(u2ux)/size(u2ux); u2ux=u2ux-u2uxmoy
        u2uymoy=sum(u2uy)/size(u2uy); u2uy=u2uy-u2uymoy
        u2m=sum(u2)/size(u2); u2=u2-u2m
        rxxmoy=sum(rxx)/size(rxx); rxx=rxx-rxxmoy
        rxymoy=sum(rxy)/size(rxy); rxy=rxy-rxymoy
        ryymoy=sum(ryy)/size(ryy); ryy=ryy-ryymoy

! compute the Reynolds force -\partial_j(R_ij)
        buf=ux**2
        bufb=ux*uy

         uxp => buf
         uyp => bufb
         call divergence(uxp,uyp,dup,rx,del_div)
         buf=uy**2
         uxp => bufb
         uyp => buf
         call divergence(uxp,uyp,dup,ry,del_div)
         call output(rx,'rx',dimx,dimy,nc,ns)
         call output(ry,'ry',dimx,dimy,nc,ns)

! computation of the four best approximations+++++++++++++++++++++++++++
        do ns=1,4
         call mres2d(ux,ux_recons,ns,0,wavelet) ! computes the approximation
         call mres2d(uy,uy_recons,ns,0,wavelet)
         call mres2d(du,du_recons,ns,0,wavelet)
        ! print*,'ns',ns
        ! print*,'ux',ux(1:10,1:10)
        ! print*,'ux_recons',ux_recons(1:10,1:10)

         ux_recons=ux_recons+uxmoy
         uy_recons=uy_recons+uymoy
         du_recons=du_recons+dumoy

         uxp => ux_recons
         uyp => uy_recons
         dup => du_recons

         call divergence(uxp,uyp,dup,div,del_div)
         call rot(uxp,uyp,dup,curl,del_div)
!call output(ux_recons,uy_recons,div,curl,du_recons,del_div,dimx,dimy,nc,ns)
         call output(ux_recons,'ux',dimx,dimy,nc,ns)
         call output(uy_recons,'uy',dimx,dimy,nc,ns)
         call output(div,'div',dimx,dimy,nc,ns)
         call output(curl,'rot',dimx,dimy,nc,ns)
         call output(du_recons,'err',dimx,dimy,nc,ns)
! Shear
         buf=dx(uxp,1)
         call output(buf,'sxx',dimx,dimy,nc,ns)
         buf=dx(uyp,1)+dx(uxp,2)
         call output(buf,'sxy',dimx,dimy,nc,ns)
         buf=dx(uyp,2)
         call output(buf,'syy',dimx,dimy,nc,ns)

! Div du tenseur de Reynolds
         buf=ux_recons**2
         bufb=ux_recons*uy_recons

         uxp => buf
         uyp => bufb
         call divergence(uxp,uyp,dup,rx,del_div)
         buf=uy_recons**2
         uxp => bufb
         uyp => buf
         call divergence(uxp,uyp,dup,ry,del_div)
         call output(rx,'rx',dimx,dimy,nc,ns)
         call output(ry,'ry',dimx,dimy,nc,ns)

! Fonction de transfert non-lineaire
         call mres2d(u2ux,ux_recons,ns,0,wavelet) ! computes the approximation
         call mres2d(u2uy,uy_recons,ns,0,wavelet)
         ux_recons=ux_recons+u2uxmoy
         uy_recons=uy_recons+u2uymoy
         uxp => ux_recons
         uyp => uy_recons
         call divergence(uxp,uyp,dup,div,del_div)
         call output(div,'tra',dimx,dimy,nc,ns)
! The same but using <u^2>
         buf=(ux_recons**2+uy_recons**2)*ux_recons
         bufb=(ux_recons**2+uy_recons**2)*uy_recons
         uxp => buf
         uyp => bufb
         call divergence(uxp,uyp,dup,div,del_div)
         call output(div,'trb',dimx,dimy,nc,ns)

! Direct calculation of v_j\partial_j v^2
         call mres2d(u2,ux_recons,ns,0,wavelet) ! computes the approximation
         ux_recons=ux_recons+u2m
         uxp => ux_recons
         buf=ux*dx(uxp,1)+uy*dx(uxp,2)
         call output(buf,'trc',dimx,dimy,nc,ns)

! computation of the Reynolds stress components
         call mres2d(rxx,rxx_recons,ns,0,wavelet) ! computes the approximation
         call mres2d(rxy,rxy_recons,ns,0,wavelet)
         call mres2d(ryy,ryy_recons,ns,0,wavelet)
         rxx_recons=rxx_recons+rxxmoy
         rxy_recons=rxy_recons+rxymoy
         ryy_recons=ryy_recons+ryymoy
         call output(rxx_recons,'rxx',dimx,dimy,nc,ns)
         call output(rxy_recons,'rxy',dimx,dimy,nc,ns)
         call output(ryy_recons,'ryy',dimx,dimy,nc,ns)


! End of computation of the four best approximations+++++++++++++++++++++++++++
        enddo


        ns=4

! computation of the details; useful for checking
        
         if (ns >= 1 .and. check == 'yes') then
                do i=1,ns
                  call mres2d(ux,ux_detail,i,4,wavelet)
                  call mres2d(uy,uy_detail,i,4,wavelet)
                  call mres2d(du,du_detail,i,4,wavelet)
                  ux_recons=ux_recons+ux_detail
                  uy_recons=uy_recons+uy_detail
                  du_recons=du_recons+du_detail
                enddo
         endif

!         if (check == 'yes') then
!         print*,'difference original/reconstruction en relatif'
!         print*,maxval(abs(ux_recons-uxmoy-ux))/maxval(abs(ux))
!        endif
!        print*,maxval(abs(uy_recons-uy))/maxval(abs(uy))
!        print*,'another estimate of the error'
!        print*,maxval(abs(ux_recons-uxmoy-ux)/sqrt(ux**2+uy**2), &
!                        sqrt(ux**2+uy**2) /= 0.)


        deallocate(ux_recons,uy_recons,du_recons)

        end subroutine

        end module

      SUBROUTINE C05NCY(M,N,A,LDA,V,W)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     **********
C
C     SUBROUTINE C05NCY (based on MINPACK routine R1MPYQ)
C
C     Given an M by N matrix A, this subroutine computes A*Q where
C     Q is the product of 2*(N - 1) transformations
C
C        GV(N-1)*...*GV(1)*GW(1)*...*GW(N-1)
C
C     and GV(I), GW(I) are Givens rotations in the (I,N) plane which
C     eliminate elements in the I-th and N-th planes, respectively.
C     Q itself is not given, rather the information to recover the
C     GV, GW rotations is supplied.
C
C     The subroutine statement is
C
C        SUBROUTINE C05NCY(M,N,A,LDA,V,W)
C
C     where
C
C     M is a positive integer input variable set to the number
C     of rows of A.
C
C     N is a positive integer input variable set to the number
C     of columns of A.
C
C     A is an M by N array. On input A must contain the matrix
C     to be postmultiplied by the orthogonal matrix Q
C     described above. On output A*Q has replaced A.
C
C     LDA is a positive integer input variable not less than M
C     which specifies the leading dimension of the array A.
C
C     V is an input array of length N. V(I) must contain the
C     information necessary to recover the Givens rotation GV(I)
C     described above.
C
C     W is an input array of length N. W(I) must contain the
C     information necessary to recover the Givens rotation GW(I)
C     described above.
C
C     Argonne National Laboratory. MINPACK Project. March 1980.
C     Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C
C     **********
C
C     Revised to call BLAS.
C     P.J.D. Mayes, J.J. Du Croz, NAG Central Office, September 1987.
C
C     .. Parameters ..
      DOUBLE PRECISION  ONE
      PARAMETER         (ONE=1.0D0)
C     .. Scalar Arguments ..
      INTEGER           LDA, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(LDA,N), V(N), W(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  COSINE, SINE
      INTEGER           J, NM1, NMJ
C     .. External Subroutines ..
      EXTERNAL          DROT
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, SQRT
C     .. Executable Statements ..
C
C     Apply the first set of Givens rotations to A.
C
      NM1 = N - 1
      IF (NM1.GE.1) THEN
         DO 20 NMJ = 1, NM1
            J = N - NMJ
            IF (ABS(V(J)).GT.ONE) THEN
               COSINE = ONE/V(J)
               SINE = SQRT(ONE-COSINE**2)
            ELSE
               SINE = V(J)
               COSINE = SQRT(ONE-SINE**2)
            END IF
            CALL DROT(M,A(1,N),1,A(1,J),1,COSINE,SINE)
   20    CONTINUE
C
C        Apply the second set of Givens rotations to A.
C
         DO 40 J = 1, NM1
            IF (ABS(W(J)).GT.ONE) THEN
               COSINE = ONE/W(J)
               SINE = SQRT(ONE-COSINE**2)
            ELSE
               SINE = W(J)
               COSINE = SQRT(ONE-SINE**2)
            END IF
            CALL DROT(M,A(1,J),1,A(1,N),1,COSINE,SINE)
   40    CONTINUE
      END IF
      RETURN
      END

      SUBROUTINE C05AGF(X,HH,EPS,ETA,F,A,B,IFAIL)
C     MARK 8 RELEASE. NAG COPYRIGHT 1979.
C     MARK 9 REVISED. IER-300 (SEP 1981).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     DRIVER FOR C05AVF AND C05AZF
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='C05AGF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  A, B, EPS, ETA, HH, X
      INTEGER           IFAIL
C     .. Function Arguments ..
      DOUBLE PRECISION  F
      EXTERNAL          F
C     .. Local Scalars ..
      DOUBLE PRECISION  FX, H, LB, UB, Y
      INTEGER           I, IFAIL1, IND, IR
C     .. Local Arrays ..
      DOUBLE PRECISION  C(17)
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          C05AVF, C05AZF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS
C     .. Executable Statements ..
      H = HH
      IF (EPS.GT.0.0D0 .AND. X+H.NE.X) GO TO 20
C     INPUT ERROR
      I = 1
      GO TO 320
   20 FX = F(X)
      IF (ABS(FX).GE.ETA) GO TO 40
C     ROOT AT INITIAL POINT WITHIN ETA
      I = 0
      A = X
      B = X
      GO TO 320
C     LOOK FOR INTERVAL
   40 IND = -1
      IFAIL1 = 1
      LB = X - 256.0D0*ABS(H)
      UB = X + 256.0D0*ABS(H)
   60 CALL C05AVF(X,FX,H,LB,UB,A,C,IND,IFAIL1)
      IF (IND.EQ.0) GO TO 80
      FX = F(X)
      IF (ABS(FX).GE.ETA) GO TO 60
C     ROOT WITHIN ETA
      A = X
      B = X
      I = 0
      GO TO 320
   80 IF (IFAIL1.EQ.0) GO TO 140
      GO TO (100,100,100,120) IFAIL1
C     IMPOSSIBLE EXIT FROM C05AVF
  100 I = 5
      GO TO 320
C     C05AVF COULD NOT FIND AN INTERVAL
  120 I = 2
      A = C(8)
      B = C(10)
      GO TO 320
  140 IF (A.NE.X) GO TO 160
      IF (ETA.GT.0.0D0) GO TO 100
C     ROOT FOUND EXACTLY
      I = 0
      A = X
      B = X
      GO TO 320
C     INTERVAL FOUND - NOW FIND ROOT
  160 B = X
      Y = A
      IND = -1
      IR = 0
      IFAIL1 = 1
  180 CALL C05AZF(X,Y,FX,EPS,IR,C,IND,IFAIL1)
      IF (IND.EQ.0) GO TO 200
      IF (IND.NE.4) GO TO 220
      FX = F(X)
      IF (ABS(FX).GE.ETA) GO TO 180
C     ROOT WITHIN ETA
      A = X
      B = X
      I = 0
      GO TO 320
  200 IF (IFAIL1.EQ.0) GO TO 280
      GO TO (220,220,220,240,260) IFAIL1
C     IMPOSSIBLE EXIT FROM C05AZF
  220 I = 6
      GO TO 320
C     PROBABLY A POLE
  240 I = 3
      GO TO 320
C     TOO MUCH ACCURACY REQUESTED
  260 I = 4
      GO TO 320
  280 IF (X.NE.Y) GO TO 300
      IF (ETA.GT.0.0D0) GO TO 220
C     ROOT FOUND EXACTLY
      A = X
      B = X
      I = 0
      GO TO 320
C     SUCCESS
  300 I = 0
  320 IF (A.LT.B) GO TO 340
      Y = A
      A = B
      B = Y
  340 IFAIL = P01ABF(IFAIL,I,SRNAME,0,P01REC)
      RETURN
      END

c***********************************************************************
      DOUBLE PRECISION FUNCTION GETDOUBLE(i_line)
c***
      INCLUDE 'undefined.h'
      INCLUDE 'GP_common.h'
      INTEGER i_line, ibegin, i
      CHARACTER*128 line1,line2
      CHARACTER*1 eq_char, blank
      DATA eq_char/'='/, blank/' '/

#ifdef sn4607
      double precision readc2d
      external readc2d
#endif

c***
      line1 = lines_of_text(i_line)
      ibegin = 1 + INDEX(line1,eq_char)
      do i = 1, 128
         line2(i:i) = blank
      enddo
      line2(ibegin:128) = line1(ibegin:128)
#ifdef sn4607
      GETDOUBLE=readc2d(line2)
#else
      read(line2,*) GETDOUBLE
#endif

c***
c---      write(*,*) line1(1:ibegin-1), GETDOUBLE
c***
      return 
      end

! date of frames for the lapalma time serie.

	module m_time_set

        implicit none
        private
        real, save,public, allocatable :: t(:)
        integer, save,public :: ntm
        public :: the_time_set

contains

	subroutine the_time_set(the_time_file)

        integer i,ii
        real angle,heure
        character*80 :: the_time_file
        

        open(unit=7,file=the_time_file,form='formatted')
        read(7,*) ntm
        print*,'nb of times',ntm
        if (.not. allocated(t)) allocate(t(ntm))
          do i=1,ntm
           read(7,*) ii,heure
           t(i)=heure*3600
          enddo
        close(7)

	end subroutine

	end module

! subroutine for the evaluation of the relation between precision and
! spatial resolution

         module m_optsc

contains
         subroutine opt_scale(x,y,vx,vy,dv,n,nc,bin_spt)

         use param_run

         implicit none

         real, dimension (:), intent(in) :: vx,vy,dv,x,y
         integer, intent(in) :: n,nc
         integer, intent(out) :: bin_spt

         real, dimension (:), allocatable :: dvrel,xa,ya,vector
         integer i,ii,j,na,np_vnull
         real dmoy,dmax,d_i,d



         allocate(dvrel(n),xa(n),ya(n),vector(n))
         dvrel=0.; xa=0.; ya=0.; vector=0.

! Calcul du pourcentage d'erreur en chaque point de mesure de v
         where (vx(1:n)**2+vy(1:n)**2 /=0.) &
              dvrel(1:n)=dv(1:n)/sqrt(vx(1:n)**2+vy(1:n)**2)

         np_vnull=count(vx(1:n)**2+vy(1:n)**2 ==0.)
         if (np_vnull /= 0) print*,'nb of pts with v=0   ',np_vnull

! Calcul de la distance moyenne entre plus proches voisins pour une
! precision donnee par l'utilisateur

         open(unit=1,file='precision',position='append')
         if (nc == 1) write(1,*) prec,timestep*n_ech

! selection des points a precision donnee
          where(dvrel <= prec .and. dvrel /= 0.)
             xa=x; ya=y
          endwhere

          xa=pack(xa, xa /= 0., vector)
          ya=pack(ya, ya /= 0., vector)
          na=count(xa /=0.)

! On laisse de coté l'effet de la precision 14/11/2006
          dmoy=0.
          dmax=abs(maxval(x)-minval(x))+abs(maxval(y)-minval(y))
          na=count(x /=0.)
          do i=1,na
           d_i=dmax
           do j=i+1,na
            d=sqrt((x(i)-x(j))**2+(y(i)-y(j))**2)
            d_i = min(d_i,d)
           enddo
           dmoy=dmoy+d_i/na
          enddo
         
         write(1,100) nc,prec,na,dmoy
         bin_spt=nint(dmoy)

         close(1)
100          format(i3,1x,0pf6.3,1x,i6,1pd12.5)
         end subroutine

         end module

! Revised on 11/9/2007 to manage a single field

	module m_output

contains

	subroutine output(field,str_name,dimx,dimy,index,ntype)

	use param_run
	
        implicit none

        real(kind(0d0)), dimension(:,:), intent(in) :: field

	integer,intent(in) :: index,ntype,dimx,dimy
	character suff*3,fichier*150,le_type*1
        character*(*) str_name

        write(suff,"(i3)") index

	if (ntype == 0) write(le_type,"(a)") 'b'   ! raw data
	if (ntype == 1) write(le_type,"(a)") 'h'   ! high resolution
	if (ntype == 2) write(le_type,"(a)") 'm'   ! medium resolution
	if (ntype == 3) write(le_type,"(a)") 'l'   ! low resolution
	if (ntype == 4) write(le_type,"(a)") 'k'   ! very low resolution

        suff=trim(adjustl(suff))//le_type

 fichier=trim(adjustl(postprocessingpath))//'/'//trim(adjustl(str_name))//suff
        print*,'check in output ',fichier
        open(unit=4,file=fichier)
        write(4,'(3i5,2(3x,f7.3))') dimx,dimy,bin_sp,pixel,arcsec
        write(4,'(6(1x,1pd12.5))') field
        close(4)
!       fichier=trim(adjustl(postprocessingpath))//'/uy'//suff
!       open(unit=4,file=fichier)
!       write(4,'(3i5,2(3x,f7.3))') dimx,dimy,bin_sp,pixel,arcsec
!       write(4,'(6(1x,1pd12.5))') uy
!       close(4)
!       fichier=trim(adjustl(postprocessingpath))//'/div'//suff
!       open(unit=4,file=fichier)
!       write(4,'(3i5,2(3x,f7.3))') dimx,dimy,bin_sp,pixel,arcsec
!       write(4,'(6(1x,1pd12.5))') div/(bin_sp*pixel*arcsec)
!       close(4)
!       fichier=trim(adjustl(postprocessingpath))//'/rot'//suff
!       open(unit=4,file=fichier)
!       write(4,'(3i5,2(3x,f7.3))') dimx,dimy,bin_sp,pixel,arcsec
!       write(4,'(6(1x,1pd12.5))') rot/(bin_sp*pixel*arcsec)
!       close(4)
!       fichier=trim(adjustl(postprocessingpath))//'/err'//suff
!       open(unit=4,file=fichier)
!       write(4,'(3i5,2(3x,f7.3))') dimx,dimy,bin_sp,pixel,arcsec
!       write(4,'(6(1x,1pd12.5))') du
!       write(4,'(6(1x,1pd12.5))') ddiv/(bin_sp*pixel*arcsec)
!       close(4)

	end subroutine

	end module

      function readc2d(line2)
      double precision readc2d
      character*(*) line2
c use fort.99:
      rewind 99
      write(99,*)line2
      rewind 99
      read(99,*)readc2d
      rewind 99
      return
      end

c     $Author: rieutord $
c     $Revision: 1.1.1.1 $
c     $Log: sfetch.f,v $
c     Revision 1.1.1.1  2004-03-10 12:30:55  rieutord
c     import cst v. 2.2.3
c
c Revision 1.2  1993/04/21  16:52:26  raus
c size of the char function up to 128
c
c Revision 1.1  1993/04/20  17:41:37  raus
c 1st save; find_string to findstring
c
c***********************************************************************
      CHARACTER*128 FUNCTION SFETCH(name_variable,default)
c***
      INCLUDE 'undefined.h'
      INCLUDE 'GP_common.h'
      CHARACTER*(*) name_variable, default
      CHARACTER*128 GETSTRING
      INTEGER line, FINDSTRING
      EXTERNAL FINDSTRING, GETSTRING
c***
      line = FINDSTRING(name_variable)
      if (line .eq. 0) then
         SFETCH = default
      else 
         SFETCH = GETSTRING(line)
      endif 
c***
c----      write (*,*) SFETCH
c***
      return 
      end

      SUBROUTINE C05AVF(X,FX,H,BOUNDL,BOUNDU,A,C,IND,IFAIL)
C     MARK 8 RELEASE. NAG COPYRIGHT 1979.
C     MARK 10B REVISED. IER-398 (JAN 1983).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     FINDS INTERVAL [A,X] IN WHICH LIES ROOT OF F.
C     [BOUNDL,BOUNDU] CONTAINS [A,X],X IS INITIAL GUESS
C     AND H IS STARTING STEP.
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='C05AVF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  A, BOUNDL, BOUNDU, FX, H, X
      INTEGER           IFAIL, IND
C     .. Array Arguments ..
      DOUBLE PRECISION  C(11)
C     .. Local Scalars ..
      INTEGER           I
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, SIGN, INT
C     .. Executable Statements ..
      IF (IND.NE.1 .AND. IND.NE.-1) GO TO 100
      IF (BOUNDL.LT.BOUNDU) GO TO 20
C     INPUT ERROR
      I = 1
      GO TO 480
   20 IF (X.GE.BOUNDL .AND. X.LE.BOUNDU) GO TO 40
C     INPUT ERROR
      I = 1
      GO TO 480
   40 IF (X+H.NE.X) GO TO 60
C     INPUT ERROR - H TOO SMALL
      I = 2
      GO TO 480
   60 IF ((X+H.GE.BOUNDL .AND. X+H.LE.BOUNDU)
     *    .OR. (X-H.GE.BOUNDL .AND. X-H.LE.BOUNDU)) GO TO 80
C     INPUT ERROR - H TOO LARGE
      I = 1
      GO TO 480
   80 C(3) = X
      C(5) = H
      C(6) = 0.D0
      C(7) = 0.D0
      A = X
      C(8) = X
      C(10) = X
      IF (IND.EQ.-1) GO TO 120
      IND = 2
      RETURN
  100 IF (IND.EQ.2 .OR. IND.EQ.3) GO TO 120
C     INPUT ERROR - IND INCORRECTLY SET
      I = 3
      GO TO 480
  120 IF (FX.NE.0.0D0) GO TO 140
C     HIT ROOT EXACTLY
      A = X
      GO TO 460
  140 IF (IND.EQ.3) GO TO 280
      C(4) = FX
      C(1) = FX
      C(9) = FX
      C(11) = FX
  160 IF (X.EQ.BOUNDL .AND. X+H.LT.BOUNDL) H = -H
      IF (X.EQ.BOUNDU .AND. X+H.GT.BOUNDU) H = -H
      IF (X.EQ.BOUNDL) C(7) = -1.0D0
      IF (X.EQ.BOUNDU) C(7) = 1.0D0
  180 X = X + H
C     TEST FOR ENDS OF INTERVAL
      IF (X.GT.BOUNDL) GO TO 220
      X = BOUNDL
      IF (C(7).EQ.-1.0D0 .OR. ABS(C(7)).GT.1.5D0) GO TO 360
      IF (C(7).EQ.0.0D0) GO TO 200
      C(7) = -2.0D0
      GO TO 260
  200 C(7) = -1.0D0
      GO TO 260
  220 IF (X.LT.BOUNDU) GO TO 260
      X = BOUNDU
      IF (C(7).EQ.1.0D0 .OR. ABS(C(7)).GT.1.5D0) GO TO 360
      IF (C(7).EQ.0.0D0) GO TO 240
      C(7) = 2.0D0
      GO TO 260
  240 C(7) = 1.0D0
  260 IND = 3
      RETURN
  280 C(2) = FX
      IF (SIGN(1.D0,C(1)).NE.SIGN(1.D0,C(2))) GO TO 440
      IF (ABS(X-BOUNDL).GT.ABS(C(8)-BOUNDL)) GO TO 300
      C(8) = X
      C(9) = FX
      GO TO 320
  300 IF (ABS(X-BOUNDU).GT.ABS(C(10)-BOUNDU)) GO TO 320
      C(10) = X
      C(11) = FX
  320 IF (ABS(C(1)).LE.ABS(C(2))) GO TO 340
C     CARRY ON IN SAME DIRECTION
      H = 2.0D0*H
      A = X
      C(1) = C(2)
      GO TO 180
C     BACK TRACK
  340 H = -2.0D0*H
      GO TO 180
  360 IF (C(6).LT.2.5D0) GO TO 420
C     GIVE UP
  380 I = 4
      IF (C(8).GT.C(10)) GO TO 400
      X = C(8)
      FX = C(9)
      A = C(10)
      C(1) = C(11)
      GO TO 480
  400 X = C(10)
      FX = C(11)
      A = C(8)
      C(1) = C(9)
      GO TO 480
C     TRY AGAIN WITH SHORTER STEP
  420 C(6) = C(6) + 1.0D0
      I = INT(C(6)+0.1D0)
      H = (-0.1D0)**I*C(5)
      IF (C(3).EQ.C(3)+H) GO TO 380
      X = C(3)
      A = X
      C(8) = A
      C(10) = A
      C(9) = C(4)
      C(11) = C(4)
      C(1) = C(4)
      C(7) = 0.D0
      GO TO 160
C     INTERVAL FOUND
  440 FX = C(2)
      A = C(8)
      C(1) = C(9)
      IF (ABS(X-C(10)).GE.ABS(X-C(8))) GO TO 460
      A = C(10)
      C(1) = C(11)
  460 I = 0
C     ERROR EXITS
  480 IND = 0
      IFAIL = P01ABF(IFAIL,I,SRNAME,0,P01REC)
      RETURN
      END

c*****************************************************************
      SUBROUTINE sortwithkey(n,ra,key)
c***
c     Sort array ra of length n into decreasing size order
c     using the Heapsort algorithm, and sort key as well
c***
      INTEGER n
      INTEGER ra(n)
      INTEGER rra
      CHARACTER*128 key(n)
      CHARACTER*128 kkey
      INTEGER i,j,k,ir
c***
c     The sort algorithm has a run-time error if n .eq. 1 
c***
      if (n .le. 1) then
         return
      endif
c***
c     k is decremented during heap creation
c***
      k = (n/2) + 1
c***
c     ir is decremented during heap selection
c***
      ir = n
10    continue
      if (k .gt. 1) then
c***  
c     in heap creation phase
c***  
         k = k - 1
         rra = ra(k)
         kkey = key(k)
      else
c***  
c     in heap selection phase
c***  
         rra = ra(ir)
         kkey = key(ir)
         ra(ir) = ra(1)
         key(ir) = key(1)
         ir = ir - 1
         if (ir .eq. 1) then
            ra(1) = rra
            key(1) = kkey
            return
         endif
      endif
      i = k
      j = k + k
      do while (j .le. ir)
         if (j .lt. ir) then
            if (ra(j) .gt. ra(j+1)) then
               j = j + 1
            endif
         endif
         if (rra .gt. ra(j)) then
            ra(i) = ra(j)
            key(i) = key(j)
            i = j
            j = j + j
         else
            j = ir + 1
         endif
      enddo
      ra(i) = rra
      key(i) = kkey
      go to 10
c***  
      end

! programme de fit polynomial de donnees bidimensionnelles
! methodes des moindres carres.
! notations :
! f_00 + f_10x + f_01y + f_11xy + f_20 x^2 + ....
!
! Valide par comparaison a sfit d'IDL (le 2/4/2000)
! Attention les coefficients du polynome sont differents de ceux d'idl
! qui considere que f(x,y)=sum_ij Kx_ji x^iy^j ou x et y sont des
! entiers.

	module m_polyfit

contains

	subroutine polyfit(a,x,y,z,coef,n)

	implicit none

	real(kind(0d0)), dimension(:,:), intent(out) :: coef,z
	real(kind(0d0)), dimension(:,:), intent(in) :: a,x,y
	integer, intent(in) :: n

	integer :: k,i,ndeg,ndegx,npoints,ixa,iya,ixj,iyj,j,lw,info,m,nx,ny
	real(kind(0d0)), allocatable :: c(:,:),b(:,:),work(:)
	integer, allocatable :: ipiv(:),ix(:),iy(:)


! taille de la matrice des moindres carres=nb d'exposants
! Methode d'IDL : degres de x vont de 0 a n, idem pour y ==> le 
! polynome a 2 variable b'est pas vraiment de degres n.

	m=(n+1)*(n+1)
	nx=size(a,1); ny=size(a,2)
	allocate(ix(m),iy(m))

	i=1
	do ndeg=0,n
  	 do ndegx=0,n
   	  ix(i)=ndeg
   	  iy(i)=ndegx
   	  i=i+1
  	 enddo
	enddo

!print,'degres de x',ix
!print,'degres de y',iy

! calcul de la matrice des moindres carres

	lw=m**2
	allocate(c(m,m),b(m,1),ipiv(m),work(lw))
	c=0d0; b=0d0; ipiv=0; work=0d0

	do j=1,m
 	 do i=j,m                        ! la matrice est symetrique
  	  ixa=ix(i)+ix(j) ; iya=iy(i)+iy(j)
	  if (ixa == 0 .and. iya==0) c(i,j)=size(x)
	  if (ixa == 0 .and. iya/=0) c(i,j)=sum(y**iya)
	  if (ixa /= 0 .and. iya==0) c(i,j)=sum(x**ixa)
	  if (ixa /= 0 .and. iya/=0) c(i,j)=sum(x**ixa*y**iya) 
          c(j,i)=c(i,j)
 	 enddo
 	 ixj=ix(j) ; iyj=iy(j)
	 if (ixj == 0 .and. iyj==0) b(j,1)=sum(a)
	 if (ixj /= 0 .and. iyj==0) b(j,1)=sum(a*x**ixj)
	 if (ixj == 0 .and. iyj/=0) b(j,1)=sum(a*y**iyj)
	 if (ixj /= 0 .and. iyj/=0) b(j,1)=sum(a*x**ixj*y**iyj)
	enddo
	
! resolution du systeme
!	print*,'ix',ix
!	print*,'iy',iy
!	print*,'test',sum(real(x)**2)
!	print*,'c',c
!	print*,'b',b

	call dsytrf('u',m,c,m,ipiv,work,lw,info)
	if (info /= 0) stop'problem in factorization of lsq matrix'
!	print*,'optimal lw',work(1)
	call dsytrs('u',m,1,c,m,ipiv,b,m,info)
!	coef(1:m)=b(1:m,1)
!	coef=reshape(b, shape=(/ n+1,n+1/) ) 
        do j=1,n+1
         do i=1,n+1
          coef(i,j)=b(i+(n+1)*(j-1),1)
         enddo
        enddo

!ludc,c,index
!coef=lusol(c,index,b)

! calcul du fit

	z=b(1,1)
        do k=1,m
         if (ix(k) == 0 .and. iy(k) /= 0) z=z+b(k,1)*y**iy(k)
         if (ix(k) /= 0 .and. iy(k) == 0) z=z+b(k,1)*x**ix(k)
         if (ix(k) /= 0 .and. iy(k) /= 0) z=z+b(k,1)*x**ix(k)*y**iy(k)
        enddo

	deallocate(ix,iy,ipiv,b,c,work)

	end subroutine

	end module

      SUBROUTINE C05PBF(FCN,N,X,FVEC,FJAC,LDFJAC,TOL,WA,LWA,IFAIL)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     **********
C
C     SUBROUTINE C05PBF (based on MINPACK routine HYBRJ1)
C
C     The purpose of C05PBF is to find a zero of a system of
C     N nonlinear functions in N variables by a modification
C     of the Powell Hybrid method. This is done by using the
C     more general nonlinear equation solver C05PCF. The user
C     must provide a subroutine which calculates the functions
C     and the Jacobian.
C
C     **********
C
C     Revised to output explanatory messages.
C     P.J.D. Mayes, NAG Central Office, December 1987.
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='C05PBF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  TOL
      INTEGER           IFAIL, LDFJAC, LWA, N
C     .. Array Arguments ..
      DOUBLE PRECISION  FJAC(LDFJAC,N), FVEC(N), WA(LWA), X(N)
C     .. Subroutine Arguments ..
      EXTERNAL          FCN
C     .. Local Scalars ..
      DOUBLE PRECISION  FACTOR, ONE, XTOL, ZERO
      INTEGER           INFO, J, LR, LR1, MAXFEV, MODE, NFEV, NJEV,
     *                  NPRINT, NREC
C     .. Local Arrays ..
      CHARACTER*80      P01REC(2)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          C05PCZ
C     .. Data statements ..
      DATA              FACTOR, ONE, ZERO/1.0D2, 1.0D0, 0.0D0/
C     .. Executable Statements ..
      INFO = 1
C
C     Check the input parameters for errors.
C
      INFO = 1
      LR1 = N*(N+13)/2
      NREC = 0
      IF (N.LE.0) THEN
         WRITE (P01REC,FMT=99999) N
         NREC = 1
         GO TO 40
      ELSE IF (LDFJAC.LT.N) THEN
         WRITE (P01REC,FMT=99998) LDFJAC, N
         NREC = 2
         GO TO 40
      ELSE IF (TOL.LT.ZERO) THEN
         WRITE (P01REC,FMT=99997) TOL
         NREC = 1
         GO TO 40
      ELSE IF (LWA.LT.LR1) THEN
         WRITE (P01REC,FMT=99996) LWA, LR1
         NREC = 2
         GO TO 40
      END IF
C
C     Call C05PCZ.
C
      MAXFEV = 100*(N+1)
      XTOL = TOL
      MODE = 2
      DO 20 J = 1, N
         WA(J) = ONE
   20 CONTINUE
      NPRINT = 0
      LR = (N*(N+1))/2
      CALL C05PCZ(FCN,N,X,FVEC,FJAC,LDFJAC,XTOL,MAXFEV,WA(1),MODE,
     *            FACTOR,NPRINT,INFO,NFEV,NJEV,WA(6*N+1),LR,WA(N+1),
     *            WA(2*N+1),WA(3*N+1),WA(4*N+1),WA(5*N+1))
      IF (INFO.LT.0) THEN
         P01REC(1) = ' ** User set IFLAG negative in FCN'
         NREC = 1
      ELSE IF (INFO.EQ.2) THEN
         P01REC(1) =
     *             ' ** There have been at least 100*(N+1) calls to FCN'
         NREC = 1
      ELSE IF (INFO.EQ.3) THEN
         WRITE (P01REC,FMT=99995) XTOL
         NREC = 2
      ELSE IF (INFO.EQ.4 .OR. INFO.EQ.5) THEN
         P01REC(1) = ' ** The iteration is not making good progress'
         NREC = 1
         INFO = 4
      END IF
   40 IFAIL = P01ABF(IFAIL,INFO,SRNAME,NREC,P01REC)
      RETURN
C
99999 FORMAT (' ** On entry, N must be greater than 0: N = ',I16)
99998 FORMAT (' ** On entry, LDFJAC must be at least N:',/' ** LDFJAC ',
     *       '= ',I16,', N = ',I16)
99997 FORMAT (' ** On entry, XTOL must be at least 0.0: XTOL = ',1P,
     *       D13.5)
99996 FORMAT (' ** On entry, LWA must be at least N*(N+13)/2:',/' ** L',
     *       'WA = ',I16,',    N*(N+13)/2 = ',I16)
99995 FORMAT (' ** No further improvement in the solution is possible.',
     *       /' ** XTOL is too small: XTOL = ',1P,D13.5)
      END

      SUBROUTINE C05ZAF(M,N,X,FVEC,FJAC,LDFJAC,XP,FVECP,MODE,ERR)
C     MARK 9 RELEASE.  NAG COPYRIGHT 1981
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 13 REVISED. USE OF MARK 12 X02 FUNCTIONS (APR 1988).
C     **********
C
C     SUBROUTINE C05ZAF(BASED ON MINPACK ROUTINE CHKDER)
C
C     THIS SUBROUTINE CHECKS THE GRADIENTS OF M NONLINEAR FUNCTIONS
C     IN N VARIABLES, EVALUATED AT A POINT X, FOR CONSISTENCY WITH
C     THE FUNCTIONS THEMSELVES. THE USER MUST CALL C05ZAF TWICE,
C     FIRST WITH MODE = 1 AND THEN WITH MODE = 2.
C
C     MODE = 1. ON INPUT, X MUST CONTAIN THE POINT OF EVALUATION.
C     ON OUTPUT, XP IS SET TO A NEIGHBORING POINT.
C
C     MODE = 2. ON INPUT, FVEC MUST CONTAIN THE FUNCTIONS AND THE
C     ROWS OF FJAC MUST CONTAIN THE GRADIENTS
C     OF THE RESPECTIVE FUNCTIONS EACH EVALUATED
C     AT X, AND FVECP MUST CONTAIN THE FUNCTIONS
C     EVALUATED AT XP.
C     ON OUTPUT, ERR CONTAINS MEASURES OF CORRECTNESS OF
C     THE RESPECTIVE GRADIENTS.
C
C     THE SUBROUTINE DOES NOT PERFORM RELIABLY IF CANCELLATION OR
C     ROUNDING ERRORS CAUSE A SEVERE LOSS OF SIGNIFICANCE IN THE
C     EVALUATION OF A FUNCTION. THEREFORE, NONE OF THE COMPONENTS
C     OF X SHOULD BE UNUSUALLY SMALL (IN PARTICULAR, ZERO) OR ANY
C     OTHER VALUE WHICH MAY CAUSE LOSS OF SIGNIFICANCE.
C
C     **********
C
C     EPSMCH IS THE MACHINE PRECISION.
C
C     .. Scalar Arguments ..
      INTEGER           LDFJAC, M, MODE, N
C     .. Array Arguments ..
      DOUBLE PRECISION  ERR(M), FJAC(LDFJAC,N), FVEC(M), FVECP(M), X(N),
     *                  XP(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  EPS, EPSF, EPSLOG, EPSMCH, FACTOR, ONE, TEMP,
     *                  ZERO
      INTEGER           I, J
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      EXTERNAL          X02AJF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, LOG10, SQRT
C     .. Data statements ..
      DATA              FACTOR, ONE, ZERO/1.0D2, 1.0D0, 0.0D0/
C     .. Executable Statements ..
      EPSMCH = X02AJF()
C
      EPS = SQRT(EPSMCH)
C
      IF (MODE.EQ.2) GO TO 40
C
C     MODE = 1.
C
      DO 20 J = 1, N
         TEMP = EPS*ABS(X(J))
         IF (TEMP.EQ.ZERO) TEMP = EPS
         XP(J) = X(J) + TEMP
   20 CONTINUE
      GO TO 140
   40 CONTINUE
C
C     MODE = 2.
C
      EPSF = FACTOR*EPSMCH
      EPSLOG = LOG10(EPS)
      DO 60 I = 1, M
         ERR(I) = ZERO
   60 CONTINUE
      DO 100 J = 1, N
         TEMP = ABS(X(J))
         IF (TEMP.EQ.ZERO) TEMP = ONE
         DO 80 I = 1, M
            ERR(I) = ERR(I) + TEMP*FJAC(I,J)
   80    CONTINUE
  100 CONTINUE
      DO 120 I = 1, M
         TEMP = ONE
         IF (FVEC(I).NE.ZERO .AND. FVECP(I).NE.ZERO .AND. ABS(FVECP(I)
     *       -FVEC(I)).GE.EPSF*ABS(FVEC(I))) TEMP = EPS*ABS((FVECP(I)
     *       -FVEC(I))/EPS-ERR(I))/(ABS(FVEC(I))+ABS(FVECP(I)))
         ERR(I) = ONE
         IF (TEMP.GT.EPSMCH .AND. TEMP.LT.EPS) ERR(I) = (LOG10(TEMP)
     *       -EPSLOG)/EPSLOG
         IF (TEMP.GE.EPS) ERR(I) = ZERO
  120 CONTINUE
  140 CONTINUE
      RETURN
      END

module correlation

        private
        public :: correlate,correlatefast

contains

        double precision function correlate(a,b)

        real, dimension (:,:), intent(in) :: a,b
        double precision sdeva,sdevb,a_m,b_m
        integer n

        n=size(a)
        a_m=sum(dble(a))/n
        b_m=sum(dble(b))/n

        correlate=sum( (dble(a)-a_m)*(dble(b)-b_m) )/n
        sdeva=sqrt(sum( (dble(a)-a_m)**2)/n)
        sdevb=sqrt(sum( (dble(b)-b_m)**2)/n)

        correlate=correlate/sdeva/sdevb

        end function

        function correlatefast(a,b)

        real, dimension (:,:), intent(in) :: a,b
        real sdeva,sdevb,a_m,b_m
        integer i,j,n,nx,ny

        n=size(a)
        nx=size(a,1)
        ny=size(a,2)
        a_m=0.0; b_m=0.0
        do j=1,ny
         do i=1,nx
          a_m=a_m+a(i,j)
          b_m=b_m+b(i,j)
         enddo
        enddo
        a_m=a_m/n
        b_m=b_m/n

        correlatefast=0.; sdeva=0.; sdevb=0.
        do j=1,ny
         do i=1,nx
          correlatefast=correlatefast+(a(i,j)-a_m)*(b(i,j)-b_m)
          sdeva=sdeva+(a(i,j)-a_m)**2
          sdevb=sdevb+(b(i,j)-b_m)**2
         enddo
        enddo
        sdeva=sqrt(sdeva/n)
        sdevb=sqrt(sdevb/n)

        correlatefast=correlatefast/n/sdeva/sdevb

        end function

end module

! version double precision

	module convolution_sub

	contains
	subroutine convol(a,b,conv)
	implicit none

	real(kind(0d0)), intent(in) :: a(:),b(:)
	real(kind(0d0)),intent(out) :: conv(:)
	integer :: i,k,n,na,nb

	na=size(a) ; nb=size(b)
	n=na+nb-1

	do i=2,n+1
!	 print*,i,a(:),b(:)
	 conv(i-1)=0d0
	 do k=max(1,i-nb),min(i-1,na)
	  conv(i-1)=conv(i-1)+a(k)*b(i-k)
	 enddo
	enddo

	end subroutine convol

	end module

      DOUBLE PRECISION FUNCTION C05NCT(N,X)
C     MARK 9 RELEASE.  NAG COPYRIGHT 1981
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     **********
C
C     FUNCTION C05NCT
C
C     GIVEN AN N-VECTOR X, THIS FUNCTION CALCULATES THE
C     EUCLIDEAN NORM OF X.
C
C     THE EUCLIDEAN NORM IS COMPUTED BY ACCUMULATING THE SUM OF
C     SQUARES IN THREE DIFFERENT SUMS. THE SUMS OF SQUARES FOR THE
C     SMALL AND LARGE COMPONENTS ARE SCALED SO THAT NO OVERFLOWS
C     OCCUR. NON-DESTRUCTIVE UNDERFLOWS ARE PERMITTED. UNDERFLOWS
C     AND OVERFLOWS DO NOT OCCUR IN THE COMPUTATION OF THE UNSCALED
C     SUM OF SQUARES FOR THE INTERMEDIATE COMPONENTS.
C     THE DEFINITIONS OF SMALL, INTERMEDIATE AND LARGE COMPONENTS
C     DEPEND ON TWO CONSTANTS, RDWARF AND RGIANT. THE MAIN
C     RESTRICTIONS ON THESE CONSTANTS ARE THAT RDWARF**2 NOT
C     UNDERFLOW AND RGIANT**2 NOT OVERFLOW. THE CONSTANTS
C     GIVEN HERE ARE SUITABLE FOR EVERY KNOWN COMPUTER.
C
C     THE FUNCTION STATEMENT IS
C
C     REAL FUNCTION C05NCT(N,X)
C
C     WHERE
C
C     N IS A POSITIVE INTEGER INPUT VARIABLE.
C
C     X IS AN INPUT ARRAY OF LENGTH N.
C
C     ARGONNE NATIONAL LABORATORY. MINPACK PROJECT. MARCH 1980.
C     BURTON S. GARBOW, KENNETH E. HILLSTROM, JORGE J. MORE
C
C     **********
C     .. Scalar Arguments ..
      INTEGER                          N
C     .. Array Arguments ..
      DOUBLE PRECISION                 X(N)
C     .. Local Scalars ..
      DOUBLE PRECISION                 AGIANT, FLOATN, ONE, RDWARF,
     *                                 RGIANT, S1, S2, S3, X1MAX, X3MAX,
     *                                 XABS, ZERO
      INTEGER                          I
C     .. Intrinsic Functions ..
      INTRINSIC                        ABS, SQRT
C     .. Data statements ..
      DATA                             ONE, ZERO, RDWARF, RGIANT/1.0D0,
     *                                 0.0D0, 1.0D-19, 1.304D19/
C     .. Executable Statements ..
      S1 = ZERO
      S2 = ZERO
      S3 = ZERO
      X1MAX = ZERO
      X3MAX = ZERO
      FLOATN = N
      AGIANT = RGIANT/FLOATN
      DO 180 I = 1, N
         XABS = ABS(X(I))
         IF (XABS.GT.RDWARF .AND. XABS.LT.AGIANT) GO TO 140
         IF (XABS.LE.RDWARF) GO TO 60
C
C        SUM FOR LARGE COMPONENTS.
C
         IF (XABS.LE.X1MAX) GO TO 20
         S1 = ONE + S1*(X1MAX/XABS)**2
         X1MAX = XABS
         GO TO 40
   20    CONTINUE
         S1 = S1 + (XABS/X1MAX)**2
   40    CONTINUE
         GO TO 120
   60    CONTINUE
C
C        SUM FOR SMALL COMPONENTS.
C
         IF (XABS.LE.X3MAX) GO TO 80
         S3 = ONE + S3*(X3MAX/XABS)**2
         X3MAX = XABS
         GO TO 100
   80    CONTINUE
         IF (XABS.NE.ZERO) S3 = S3 + (XABS/X3MAX)**2
  100    CONTINUE
  120    CONTINUE
         GO TO 160
  140    CONTINUE
C
C        SUM FOR INTERMEDIATE COMPONENTS.
C
         S2 = S2 + XABS**2
  160    CONTINUE
  180 CONTINUE
C
C     CALCULATION OF NORM.
C
      IF (S1.EQ.ZERO) GO TO 200
      C05NCT = X1MAX*SQRT(S1+(S2/X1MAX)/X1MAX)
      GO TO 260
  200 CONTINUE
      IF (S2.EQ.ZERO) GO TO 220
      IF (S2.GE.X3MAX) C05NCT = SQRT(S2*(ONE+(X3MAX/S2)*(X3MAX*S3)))
      IF (S2.LT.X3MAX) C05NCT = SQRT(X3MAX*((S2/X3MAX)+(X3MAX*S3)))
      GO TO 240
  220 CONTINUE
      C05NCT = X3MAX*SQRT(S3)
  240 CONTINUE
  260 CONTINUE
      RETURN
      END

      INTEGER FUNCTION P01ABF(IFAIL,IERROR,SRNAME,NREC,REC)
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C     MARK 13 REVISED. IER-621 (APR 1988).
C     MARK 13B REVISED. IER-668 (AUG 1988).
C
C     P01ABF is the error-handling routine for the NAG Library.
C
C     P01ABF either returns the value of IERROR through the routine
C     name (soft failure), or terminates execution of the program
C     (hard failure). Diagnostic messages may be output.
C
C     If IERROR = 0 (successful exit from the calling routine),
C     the value 0 is returned through the routine name, and no
C     message is output
C
C     If IERROR is non-zero (abnormal exit from the calling routine),
C     the action taken depends on the value of IFAIL.
C
C     IFAIL =  1: soft failure, silent exit (i.e. no messages are
C                 output)
C     IFAIL = -1: soft failure, noisy exit (i.e. messages are output)
C     IFAIL =-13: soft failure, noisy exit but standard messages from
C                 P01ABF are suppressed
C     IFAIL =  0: hard failure, noisy exit
C
C     For compatibility with certain routines included before Mark 12
C     P01ABF also allows an alternative specification of IFAIL in which
C     it is regarded as a decimal integer with least significant digits
C     cba. Then
C
C     a = 0: hard failure  a = 1: soft failure
C     b = 0: silent exit   b = 1: noisy exit
C
C     except that hard failure now always implies a noisy exit.
C
C     S.Hammarling, M.P.Hooper and J.J.du Croz, NAG Central Office.
C
C     .. Scalar Arguments ..
      INTEGER                 IERROR, IFAIL, NREC
      CHARACTER*(*)           SRNAME
C     .. Array Arguments ..
      CHARACTER*(*)           REC(*)
C     .. Local Scalars ..
      INTEGER                 I, NERR
      CHARACTER*72            MESS
C     .. External Subroutines ..
      EXTERNAL                P01ABZ, X04AAF, X04BAF
C     .. Intrinsic Functions ..
      INTRINSIC               ABS, MOD
C     .. Executable Statements ..
      IF (IERROR.NE.0) THEN
C        Abnormal exit from calling routine
         IF (IFAIL.EQ.-1 .OR. IFAIL.EQ.0 .OR. IFAIL.EQ.-13 .OR.
     *       (IFAIL.GT.0 .AND. MOD(IFAIL/10,10).NE.0)) THEN
C           Noisy exit
            CALL X04AAF(0,NERR)
            DO 20 I = 1, NREC
               CALL X04BAF(NERR,REC(I))
   20       CONTINUE
            IF (IFAIL.NE.-13) THEN
               WRITE (MESS,FMT=99999) SRNAME, IERROR
               CALL X04BAF(NERR,MESS)
               IF (ABS(MOD(IFAIL,10)).NE.1) THEN
C                 Hard failure
                  CALL X04BAF(NERR,
     *                     ' ** NAG hard failure - execution terminated'
     *                        )
                  CALL P01ABZ
               ELSE
C                 Soft failure
                  CALL X04BAF(NERR,
     *                        ' ** NAG soft failure - control returned')
               END IF
            END IF
         END IF
      END IF
      P01ABF = IERROR
      RETURN
C
99999 FORMAT (' ** ABNORMAL EXIT from NAG Library routine ',A,': IFAIL',
     *  ' =',I6)
      END

      SUBROUTINE C05NCV(FCN,N,X,FVEC,FJAC,LDFJAC,IFLAG,ML,MU,EPSFCN,WA1,
     *                  WA2)
C     MARK 9 RELEASE.  NAG COPYRIGHT 1981
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 13 REVISED. USE OF MARK 12 X02 FUNCTIONS (APR 1988).
C     **********
C
C     SUBROUTINE C05NCV(BASED ON MINPACK ROUTINE FDJAC1)
C
C     THIS SUBROUTINE COMPUTES A FORWARD-DIFFERENCE APPROXIMATION
C     TO THE N BY N JACOBIAN MATRIX ASSOCIATED WITH A SPECIFIED
C     PROBLEM OF N FUNCTIONS IN N VARIABLES. IF THE JACOBIAN HAS
C     A BANDED FORM, THEN FUNCTION EVALUATIONS ARE SAVED BY ONLY
C     APPROXIMATING THE NONZERO TERMS.
C
C     THE SUBROUTINE STATEMENT IS
C
C     SUBROUTINE C05NCV(FCN,N,X,FVEC,FJAC,LDFJAC,IFLAG,ML,MU,EPSFCN,
C     WA1,WA2)
C
C     WHERE
C
C     FCN IS THE NAME OF THE USER-SUPPLIED SUBROUTINE WHICH
C     CALCULATES THE FUNCTIONS. FCN MUST BE DECLARED
C     IN AN EXTERNAL STATEMENT IN THE USER CALLING
C     PROGRAM, AND SHOULD BE WRITTEN AS FOLLOWS.
C
C     SUBROUTINE FCN(N,X,FVEC,IFLAG)
C     INTEGER N,IFLAG
C     REAL X(N),FVEC(N)
C     ----------
C     CALCULATE THE FUNCTIONS AT X AND
C     RETURN THIS VECTOR IN FVEC.
C     ----------
C     RETURN
C     END
C
C     THE VALUE OF IFLAG SHOULD NOT BE CHANGED BY FCN UNLESS
C     THE USER WANTS TO TERMINATE EXECUTION OF C05NCV.
C     IN THIS CASE SET IFLAG TO A NEGATIVE INTEGER.
C
C     N IS A POSITIVE INTEGER INPUT VARIABLE SET TO THE NUMBER
C     OF FUNCTIONS AND VARIABLES.
C
C     X IS AN INPUT ARRAY OF LENGTH N.
C
C     FVEC IS AN INPUT ARRAY OF LENGTH N WHICH MUST CONTAIN THE
C     FUNCTIONS EVALUATED AT X.
C
C     FJAC IS AN OUTPUT N BY N ARRAY WHICH CONTAINS THE
C     APPROXIMATION TO THE JACOBIAN MATRIX EVALUATED AT X.
C
C     LDFJAC IS A POSITIVE INTEGER INPUT VARIABLE NOT LESS THAN N
C     WHICH SPECIFIES THE LEADING DIMENSION OF THE ARRAY FJAC.
C
C     IFLAG IS AN INTEGER VARIABLE WHICH CAN BE USED TO TERMINATE
C     THE EXECUTION OF C05NCV. SEE DESCRIPTION OF FCN.
C
C     ML IS A NONNEGATIVE INTEGER INPUT VARIABLE WHICH SPECIFIES
C     THE NUMBER OF SUBDIAGONALS WITHIN THE BAND OF THE
C     JACOBIAN MATRIX. IF THE JACOBIAN IS NOT BANDED, SET
C     ML TO AT LEAST N - 1.
C
C     EPSFCN IS AN INPUT VARIABLE USED IN DETERMINING A SUITABLE
C     STEP LENGTH FOR THE FORWARD-DIFFERENCE APPROXIMATION. THIS
C     APPROXIMATION ASSUMES THAT THE RELATIVE ERRORS IN THE
C     FUNCTIONS ARE OF THE ORDER OF EPSFCN. IF EPSFCN IS LESS
C     THAN THE MACHINE PRECISION, IT IS ASSUMED THAT THE RELATIVE
C     ERRORS IN THE FUNCTIONS ARE OF THE ORDER OF THE MACHINE
C     PRECISION.
C
C     MU IS A NONNEGATIVE INTEGER INPUT VARIABLE WHICH SPECIFIES
C     THE NUMBER OF SUPERDIAGONALS WITHIN THE BAND OF THE
C     JACOBIAN MATRIX. IF THE JACOBIAN IS NOT BANDED, SET
C     MU TO AT LEAST N - 1.
C
C     WA1 AND WA2 ARE WORK ARRAYS OF LENGTH N. IF ML + MU + 1 IS AT
C     LEAST N, THEN THE JACOBIAN IS CONSIDERED DENSE, AND WA2 IS
C     NOT REFERENCED.
C
C     ARGONNE NATIONAL LABORATORY. MINPACK PROJECT. MARCH 1980.
C     BURTON S. GARBOW, KENNETH E. HILLSTROM, JORGE J. MORE
C
C     **********
C
C     EPSMCH IS THE MACHINE PRECISION.
C
C     FCN
C     .. Scalar Arguments ..
      DOUBLE PRECISION  EPSFCN
      INTEGER           IFLAG, LDFJAC, ML, MU, N
C     .. Array Arguments ..
      DOUBLE PRECISION  FJAC(LDFJAC,N), FVEC(N), WA1(N), WA2(N), X(N)
C     .. Subroutine Arguments ..
      EXTERNAL          FCN
C     .. Local Scalars ..
      DOUBLE PRECISION  EPS, EPSMCH, H, TEMP, ZERO
      INTEGER           I, J, K, MSUM
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      EXTERNAL          X02AJF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MAX, SQRT
C     .. Data statements ..
      DATA              ZERO/0.0D0/
C     .. Executable Statements ..
      EPSMCH = X02AJF()
C
      EPS = SQRT(MAX(EPSFCN,EPSMCH))
      MSUM = ML + MU + 1
      IF (MSUM.LT.N) GO TO 80
C
C     COMPUTATION OF DENSE APPROXIMATE JACOBIAN.
C
      DO 40 J = 1, N
         TEMP = X(J)
         H = EPS*ABS(TEMP)
         IF (H.EQ.ZERO) H = EPS
         X(J) = TEMP + H
         CALL FCN(N,X,WA1,IFLAG)
         IF (IFLAG.LT.0) GO TO 60
         X(J) = TEMP
         DO 20 I = 1, N
            FJAC(I,J) = (WA1(I)-FVEC(I))/H
   20    CONTINUE
   40 CONTINUE
   60 CONTINUE
      GO TO 200
   80 CONTINUE
C
C     COMPUTATION OF BANDED APPROXIMATE JACOBIAN.
C
      DO 160 K = 1, MSUM
         DO 100 J = K, N, MSUM
            WA2(J) = X(J)
            H = EPS*ABS(WA2(J))
            IF (H.EQ.ZERO) H = EPS
            X(J) = WA2(J) + H
  100    CONTINUE
         CALL FCN(N,X,WA1,IFLAG)
         IF (IFLAG.LT.0) GO TO 180
         DO 140 J = K, N, MSUM
            X(J) = WA2(J)
            H = EPS*ABS(WA2(J))
            IF (H.EQ.ZERO) H = EPS
            DO 120 I = 1, N
               FJAC(I,J) = ZERO
               IF (I.GE.J-MU .AND. I.LE.J+ML) FJAC(I,J) = (WA1(I)
     *             -FVEC(I))/H
  120       CONTINUE
  140    CONTINUE
  160 CONTINUE
  180 CONTINUE
  200 CONTINUE
      RETURN
      END

module moyenne
   implicit none
   private ! by default everything is private. Don't pollute name space!
   public :: mean  ! list of exported routines
   interface mean
      module procedure rmean
      module procedure r2dmean
      module procedure dmean
      module procedure d2dmean
      module procedure cmean
      module procedure c2dmean
      module procedure zmean
      module procedure z2dmean
   end interface
 contains
      function rmean(a) result(value)
         real a(:),value
         value=sum(a)/size(a)
      end function
      function r2dmean(a) result(value)
         real a(:,:),value
         value=sum(a)/size(a)
      end function
      function dmean(a) result(value)
        real(kind(0d0)) a(:), value
        value=sum(a)/size(a)
      end function
      function d2dmean(a) result(value)
        real(kind(0d0)) a(:,:), value
        value=sum(a)/size(a)
      end function
      function cmean(a) result(value)
        complex a(:), value
        value=sum(a)/size(a)
      end function
      function c2dmean(a) result(value)
        complex a(:,:), value
        value=sum(a)/size(a)
      end function
      function zmean(a) result(value)
        complex(kind(0d0)) a(:), value
        value=sum(a)/size(a)
      end function
      function z2dmean(a) result(value)
        complex(kind(0d0)) a(:,:), value
        value=sum(a)/size(a)
      end function
end module moyenne

module standard_dev
   implicit none
   private 
   public :: stdev
   interface stdev
      module procedure rdev
      module procedure r2ddev
      module procedure r3ddev
      module procedure ddev
      module procedure d2ddev
   end interface
 contains
	real function rdev(a)
	 real am,a(:)
	 am=sum(a)/size(a)
	 rdev=sqrt(sum((a-am)**2)/size(a))
	end function
	real function r2ddev(a)
	 real am,a(:,:)
	 am=sum(a)/size(a)
	 r2ddev=sqrt(sum((a-am)**2)/size(a))
	end function
	real function r3ddev(a)
	 real am,a(:,:,:)
	 am=sum(a)/size(a)
	 r3ddev=sqrt(sum((a-am)**2)/size(a))
	end function
	real(kind(0d0)) function ddev(a)
	 real(kind(0d0)) am,a(:)
	 am=sum(a)/size(a)
	 ddev=sqrt(sum((a-am)**2)/size(a))
	end function
	real(kind(0d0)) function d2ddev(a)
	 real(kind(0d0)) am,a(:,:)
	 am=sum(a)/size(a)
	 d2ddev=sqrt(sum((a-am)**2)/size(a))
	end function
end module standard_dev

	module statistics

	use moyenne
	use standard_dev

	end module statistics

      SUBROUTINE F06FJF( N, X, INCX, SCALE, SUMSQ )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      DOUBLE PRECISION   SCALE, SUMSQ
      INTEGER            INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * )
C     ..
C
C  F06FJF returns the values scl and smsq such that
C
C     ( scl**2 )*smsq = x( 1 )**2 +...+ x( n )**2 + ( scale**2 )*sumsq,
C
C  where x( i ) = X( 1 + ( i - 1 )*INCX ). The value of sumsq is assumed
C  to be at least unity and the value of smsq will then satisfy
C
C     1.0 .le. smsq .le. ( sumsq + n ) .
C
C  scale is assumed to be non-negative and scl returns the value
C
C     scl = max( scale, abs( x( i ) ) ) .
C
C  scale and sumsq must be supplied in SCALE and SUMSQ respectively.
C  scl and smsq are overwritten on SCALE and SUMSQ respectively.
C
C  The routine makes only one pass through the vector X.
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 22-October-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   ABSXI
      INTEGER            IX
C     .. Intrinsic Functions ..
      INTRINSIC          ABS
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
            IF( X( IX ).NE.ZERO )THEN
               ABSXI = ABS( X( IX ) )
               IF( SCALE.LT.ABSXI )THEN
                  SUMSQ = 1     + SUMSQ*( SCALE/ABSXI )**2
                  SCALE = ABSXI
               ELSE
                  SUMSQ = SUMSQ +       ( ABSXI/SCALE )**2
               END IF
            END IF
   10    CONTINUE
      END IF
      RETURN
C
C     End of F06FJF. ( SSSQ )
C
      END

        subroutine centre_gravite(coord,image,nx,ny,dimxx,dimyy,aire_max,fene,valeur,cgravx,cgravy)

            implicit none

            integer      valeur,posx,posy,xmin,xmax,ymin,ymax,fene
            integer      xl,yl,dimxx,dimyy,aire_max,nx,ny

            real         cgravx, cgravy, XG,YG,compt
            real image(nx,ny),coord(2),obj(2*fene+1,2*fene+1)

            posx=coord(1) 
            posy=coord(2) 
              
            xmin=posx-fene      
            xmax=posx+fene      
            ymin=posy-fene       
            ymax=posy+fene       
       
            if(xmin .lt. 1)  xmin=1 
            if(xmax .gt. nx) xmax=nx
            if(ymin .lt. 1)  ymin=1 
            if(ymax .gt. ny) ymax=ny 

           obj=0
           obj=image(xmin:xmax,ymin:ymax)  

            compt=0.

            XG=0.
            YG=0.
            cgravx=0
            cgravy=0
  
           do yl=1,dimyy 
             do xl=1,dimxx    
              if(obj(xl,yl) .eq. valeur) then 
                XG= real(xl)+xmin-1+ XG
                YG= real(yl)+ymin-1+ YG                 
                compt= compt +1
                if ( compt .gt. aire_max-1) goto 10  
              endif
             end do      
           end do

 10       continue

          cgravx=(XG/compt)  
          cgravy=(YG/compt) 

         end subroutine

      SUBROUTINE C05AZF(X,Y,FX,TOLX,IR,C,IND,IFAIL)
C     MARK 8 RE-ISSUE. NAG COPYRIGHT 1979.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 12A REVISED. IER-496 (AUG 1986).
C     MARK 13 REVISED. USE OF MARK 12 X02 FUNCTIONS (APR 1988).
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='C05AZF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  FX, TOLX, X, Y
      INTEGER           IFAIL, IND, IR
C     .. Array Arguments ..
      DOUBLE PRECISION  C(17)
C     .. Local Scalars ..
      DOUBLE PRECISION  AB, DIFF, DIFF1, DIFF2, REL, RMAX, TOL, TOL1
      INTEGER           I
      LOGICAL           T
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF, X02AKF
      INTEGER           P01ABF
      EXTERNAL          X02AJF, X02AKF, P01ABF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MAX, SIGN, DBLE, SQRT, INT
C     .. Executable Statements ..
      I = 0
      IF ((IND.GT.0 .AND. IND.LE.4) .OR. IND.EQ.-1) GO TO 20
C     USER NOT CHECKED IND OR CHANGED IT
      I = 2
      IND = 0
      GO TO 640
   20 IF (TOLX.GT.0.D0 .AND. (IR.EQ.0 .OR. IR.EQ.1 .OR. IR.EQ.2))
     *    GO TO 40
      I = 3
      IND = 0
      GO TO 640
   40 REL = 1.D0
      AB = 1.D0
      IF (IR.EQ.1) REL = 0.D0
      IF (IR.EQ.2) AB = 0.D0
      IF (IND.EQ.-1) GO TO 80
      GO TO (60,100,180,480) IND
   60 C(3) = X
      IND = 2
      RETURN
   80 C(3) = X
  100 IF (FX.NE.0.D0) GO TO 140
  120 Y = X
      IND = 0
      I = 0
      GO TO 640
  140 C(4) = FX
      C(15) = ABS(FX)
      C(16) = 0.D0
      X = Y
      Y = C(3)
      C(2) = C(4)
      C(5) = X
      IF (IND.EQ.-1) GO TO 160
      IND = 3
      RETURN
  160 FX = C(1)
      IND = 3
  180 IF (FX.EQ.0.D0) GO TO 120
      IF (SIGN(1.D0,FX).NE.SIGN(1.D0,C(2))) GO TO 200
      IND = 0
      I = 1
      GO TO 640
  200 C(6) = FX
      C(13) = SQRT(X02AJF())
      C(15) = MAX(C(15),ABS(FX))
      C(14) = X02AKF()
      C(16) = 0.0D0
  220 C(1) = C(5)
      C(2) = C(6)
      C(17) = 0.D0
  240 IF (ABS(C(2)).GE.ABS(C(4))) GO TO 280
      IF (C(1).EQ.C(5)) GO TO 260
      C(7) = C(5)
      C(8) = C(6)
  260 C(5) = C(3)
      C(6) = C(4)
      X = C(1)
      C(3) = X
      C(4) = C(2)
      C(1) = C(5)
      C(2) = C(6)
  280 TOL = 0.5D0*TOLX*MAX(AB,REL*ABS(C(3)))
      TOL1 = 2.0D0*X02AJF()*MAX(AB,REL*ABS(C(3)))
      DIFF2 = 0.5D0*(C(1)-C(3))
      C(12) = DIFF2
      DIFF2 = DIFF2 + C(3)
      IF (C(12).EQ.0.D0) GO TO 340
      IF (ABS(C(12)).LE.TOL) GO TO 580
      IF (ABS(C(12)).LE.TOL1) GO TO 340
      IF (C(17).LT.2.5D0) GO TO 300
      C(11) = C(12)
      GO TO 460
  300 TOL = TOL*SIGN(1.D0,C(12))
      DIFF1 = (C(3)-C(5))*C(4)
      IF (C(17).GT.1.5D0) GO TO 320
      DIFF = C(6) - C(4)
      GO TO 380
  320 IF (C(7).NE.C(3) .AND. C(7).NE.C(5)) GO TO 360
  340 IND = 0
      I = 5
      GO TO 640
  360 C(9) = (C(8)-C(4))/(C(7)-C(3))
      C(10) = (C(8)-C(6))/(C(7)-C(5))
      DIFF1 = C(10)*DIFF1
      DIFF = C(9)*C(6) - C(10)*C(4)
  380 IF (DIFF1.GE.0.D0) GO TO 400
      DIFF1 = -DIFF1
      DIFF = -DIFF
  400 IF (ABS(DIFF1).GT.C(14) .AND. DIFF1.GT.DIFF*TOL) GO TO 420
      C(11) = TOL
      GO TO 460
  420 IF (DIFF1.GE.C(12)*DIFF) GO TO 440
      C(11) = DIFF1/DIFF
      GO TO 460
  440 C(11) = C(12)
  460 C(7) = C(5)
      C(8) = C(6)
      C(5) = C(3)
      C(6) = C(4)
      C(3) = C(3) + C(11)
      X = C(3)
      Y = C(1)
      IND = 4
      RETURN
  480 IF (FX.EQ.0.D0) GO TO 120
      C(4) = FX
      RMAX = ABS(FX)
      IF (C(13)*RMAX.LE.C(15)) GO TO 500
      IF (C(16).EQ.1.D0) C(16) = -1.D0
      IF (C(16).EQ.0.D0) C(16) = 1.D0
      GO TO 520
  500 C(16) = 0.D0
  520 IF (C(2).GE.0.D0) GO TO 540
      T = C(4) .LE. 0.D0
      GO TO 560
  540 T = C(4) .GE. 0.D0
  560 IF (T) GO TO 220
      I = INT(C(17)+0.1D0)
      I = I + 1
      IF (C(11).EQ.C(12)) I = 0
      C(17) = DBLE(I)
      GO TO 240
  580 IF (C(16).GE.0.D0) GO TO 600
      I = 4
      GO TO 620
  600 Y = C(1)
      I = 0
  620 IND = 0
  640 IFAIL = P01ABF(IFAIL,I,SRNAME,0,P01REC)
      RETURN
      END

! Generateur de nombre aleatoire extrait de numerical recipes f90

	module random	

contains
	function ran(idum)

	implicit none

	integer, parameter :: k4b=selected_int_kind(9)
	integer(k4b), intent(inout) :: idum
	real :: ran
	integer(k4b), parameter :: ia=16807, im=2147483647, iq=127773, ir=2836
	real, save :: am
	integer(k4b), save :: ix=-1,iy=-1,k

	if (idum <= 0 .or. iy < 0) then
		am=nearest(1.0,-1.0)/im
	 	iy=ior(ieor(888889999,abs(idum)),1)
		ix=ieor(777755555,abs(idum))
		idum=abs(idum)+1
	endif

	ix=ieor(ix,ishft(ix,13))
	ix=ieor(ix,ishft(ix,-17))
	ix=ieor(ix,ishft(ix,5))
	k=iy/IQ
	iy=IA*(iy-k*IQ)-IR*k
	if (iy < 0) iy=iy+IM
	ran=am*ior(iand(IM,ieor(ix,iy)),1)
	
	end function
	end module

module mifetch
   implicit none
   private ! by default everything is private. Don't pollute name space!
   public :: fetch  ! list of exported routines
   interface fetch
      module procedure iifetch
   end interface
contains
   function iifetch(variable_name,default_value) result(value)
      character*(*)                    :: variable_name
      integer                          :: default_value,value
      integer, external                :: ifetch
      value=ifetch(variable_name,default_value)
   end function iifetch
end module mifetch

module mdfetch
   implicit none
   private ! by default everything is private. Don't pollute name space!
   public :: fetch  ! list of exported routines
   interface fetch
      module procedure ddfetch
   end interface
contains
   function ddfetch(variable_name,default_value) result(value)
      character*(*)                    :: variable_name
      double precision                 :: default_value,value
      double precision,  external                :: dfetch
      value=dfetch(variable_name,default_value)
   end function ddfetch
end module mdfetch

module mrfetch
   implicit none
   private ! by default everything is private. Don't pollute name space!
   public :: fetch  ! list of exported routines
   interface fetch
      module procedure rrfetch
   end interface
contains
   function rrfetch(variable_name,default_value) result(value)
      character*(*)                    :: variable_name
      real                             :: default_value,value
      real,    external                :: rfetch
      value=rfetch(variable_name,default_value)
   end function rrfetch
end module mrfetch

module msfetch
   implicit none
   private ! by default everything is private. Don't pollute name space!
   public :: fetch  ! list of exported routines
   interface fetch
      module procedure ssfetch
   end interface
contains
   function ssfetch(variable_name,default_value) result(value)
      character*(*)                    :: variable_name
      character*(*)                    :: default_value
      character*128, external          :: sfetch
      character*128                    :: value   
      value=sfetch(variable_name,default_value)
   end function ssfetch
end module msfetch

module mgetpar
use mifetch
use mrfetch
use mdfetch
use msfetch
end module mgetpar

	module readfits

	contains

      subroutine readimage(filename,buffer,naxes)

!     Read a FITS image and determine the minimum and maximum pixel value
	implicit none

      real, pointer :: buffer(:,:)
!!$      real, allocatable :: buffer(:,:)
      integer status,unit,readwrite,blocksize,naxes(2),nfound
      integer group,firstpix,npixels
      real nullval
      logical anynull
      character*(*) filename

 1    status=0

!     Get an unused Logical Unit Number to use to open the FITS file
 2    call ftgiou(unit,status)

      readwrite=0
 3    call ftopen(unit,filename,readwrite,blocksize,status)

!     determine the size of the image
 4    call ftgknj(unit,'NAXIS',1,2,naxes,nfound,status)

!     check that it found both NAXIS1 and NAXIS2 keywords
 5    if (nfound .ne. 2)then
          print *,'READIMAGE failed to read the NAXISn keywords.'
          return
       end if

!     initialize variables
      npixels=product(naxes)
      allocate(buffer(naxes(1),naxes(2))); buffer=0.

      group=1
      firstpix=1
      nullval=-999

 6    call ftgpve(unit,group,firstpix,npixels,nullval,buffer,anynull,status)

!     close the file and free the unit number
 7    call ftclos(unit, status)
      call ftfiou(unit, status)

!     check for any error, and if so print out error messages
 8    if (status .gt. 0)call printerror(status)
      end subroutine readimage

	end module readfits

      SUBROUTINE C05NCX(N,A,LDA,RDIAG,ACNORM)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     **********
C
C     SUBROUTINE C05NCX (Based on MINPACK routine QRFAC )
C
C     This subroutine uses householder transformations to compute a QR
C     factorization of the N by N matrix A. That is, C05NCX determines
C     an orthogonal matrix Q, and an upper triangular matrix R such
C     that A = Q*R. The Householder transformation for column K, K =
C     1,2,...,N, is of the form
C
C                     T
C     I - (1/U(K))*U*U
C
C     where U has zeros in the first K-1 positions. The form of this
C     transformation first appeared in the corresponding LINPACK
C     subroutine.
C
C     The subroutine statement is
C
C        SUBROUTINE C05NCX(N,A,LDA,RDIAG,ACNORM)
C
C     where
C
C     N is a positive integer input variable set to the number
C     of rows and columns of A.
C
C     A is an N by N array. On input A contains the matrix for
C     which the QR factorization is to be computed. On output
C     the strict upper triangular part of a contains the strict
C     upper triangular part of R, and the lower triangular
C     part of a contains a factored form of Q (the non-trivial
C     elements of the U vectors described above).
C
C     LDA is a positive integer input variable not less than N
C     which specifies the leading dimension of the array A.
C
C     RDIAG is an output array of length N which contains the
C     diagonal elements of R.
C
C     ACNORM is an output array of length N which contains the
C     norms of the corresponding columns of the input matrix A.
C
C     Argonne National Laboratory. MINPACK Project. March 1980.
C     Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C
C     **********
C
C     Revised to call BLAS.
C     P.J.D. Mayes, J.J. Du Croz, NAG Central Office, September 1987.
C
C     .. Parameters ..
      DOUBLE PRECISION  ONE, ZERO
      PARAMETER         (ONE=1.0D0,ZERO=0.0D0)
C     .. Scalar Arguments ..
      INTEGER           LDA, N
C     .. Array Arguments ..
      DOUBLE PRECISION  A(LDA,N), ACNORM(N), RDIAG(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  AJNORM, EPSMCH
      INTEGER           I, J, LDA1
C     .. External Functions ..
      DOUBLE PRECISION  F06EJF, X02AJF
      EXTERNAL          F06EJF, X02AJF
C     .. External Subroutines ..
      EXTERNAL          DGEMV, DGER
C     .. Executable Statements ..
      EPSMCH = X02AJF()
C
C     Compute the intial column norms
C
      DO 20 J = 1, N
         ACNORM(J) = F06EJF(N,A(1,J),1)
   20 CONTINUE
C
C     Reduce A to R with Householder transformations.
C
      LDA1 = LDA
      DO 60 J = 1, N
C
C        Compute the Householder transformation to reduce the
C        J-th column of A to a multiple of the J-th unit vector.
C
         AJNORM = F06EJF(N-J+1,A(J,J),1)
         IF (AJNORM.NE.ZERO) THEN
            IF (A(J,J).LT.ZERO) AJNORM = -AJNORM
            DO 40 I = J, N
               A(I,J) = A(I,J)/AJNORM
   40       CONTINUE
            A(J,J) = A(J,J) + ONE
            IF (J.NE.N) THEN
               IF (J.EQ.N-1) LDA1 = 2
               CALL DGEMV('Transpose',N-J+1,N-J,ONE,A(J,J+1),LDA1,A(J,J)
     *                    ,1,ZERO,RDIAG(J+1),1)
               CALL DGER(N-J+1,N-J,-ONE/A(J,J),A(J,J),1,RDIAG(J+1),1,
     *                   A(J,J+1),LDA1)
            END IF
         END IF
         RDIAG(J) = -AJNORM
   60 CONTINUE
      RETURN
      END

      SUBROUTINE P01ABZ
C     MARK 11.5(F77) RELEASE. NAG COPYRIGHT 1986.
C
C     Terminates execution when a hard failure occurs.
C
C     ******************** IMPLEMENTATION NOTE ********************
C     The following STOP statement may be replaced by a call to an
C     implementation-dependent routine to display a message and/or
C     to abort the program.
C     *************************************************************
C     .. Executable Statements ..
      STOP
      END

      function readc2r(line2)
      real readc2r
      character*(*) line2
c use fort.99:
      rewind 99
      write(99,*)line2
      rewind 99
      read(99,*)readc2r
      rewind 99
      return
      end

      SUBROUTINE X04AAF(I,NERR)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 14 REVISED. IER-829 (DEC 1989).
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     .. Scalar Arguments ..
      INTEGER           I, NERR
C     .. Local Scalars ..
      INTEGER           NERR1
C     .. Save statement ..
      SAVE              NERR1
C     .. Data statements ..
      DATA              NERR1/6/
C     .. Executable Statements ..
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END

      SUBROUTINE C05NDV(IRVNDS,N,X,FVEC,FJAC,LDFJAC,ML,MU,EPSFCN,WA1,
     *                  WA2)
C     MARK 14 RELEASE. NAG COPYRIGHT 1989.
C     **********
C
C     SUBROUTINE C05NDV(BASED ON MINPACK ROUTINE FDJAC1)
C
C     THIS SUBROUTINE COMPUTES A FORWARD-DIFFERENCE APPROXIMATION
C     TO THE N BY N JACOBIAN MATRIX ASSOCIATED WITH A SPECIFIED
C     PROBLEM OF N FUNCTIONS IN N VARIABLES. IF THE JACOBIAN HAS
C     A BANDED FORM, THEN FUNCTION EVALUATIONS ARE SAVED BY ONLY
C     APPROXIMATING THE NONZERO TERMS.
C
C     THE SUBROUTINE STATEMENT IS
C
C     SUBROUTINE C05NDV(IRVNDS,N,X,FVEC,FJAC,LDFJAC,ML,MU,EPSFCN,
C     WA1,WA2)
C
C     WHERE
C
C     IRVNDS IS THE REVERSE COMMUNICATION PARAMETER.
C
C     N IS A POSITIVE INTEGER INPUT VARIABLE SET TO THE NUMBER
C     OF FUNCTIONS AND VARIABLES.
C
C     X IS AN INPUT ARRAY OF LENGTH N.
C
C     FVEC IS AN INPUT ARRAY OF LENGTH N WHICH MUST CONTAIN THE
C     FUNCTIONS EVALUATED AT X.
C
C     FJAC IS AN OUTPUT N BY N ARRAY WHICH CONTAINS THE
C     APPROXIMATION TO THE JACOBIAN MATRIX EVALUATED AT X.
C
C     LDFJAC IS A POSITIVE INTEGER INPUT VARIABLE NOT LESS THAN N
C     WHICH SPECIFIES THE LEADING DIMENSION OF THE ARRAY FJAC.
C
C     ML IS A NONNEGATIVE INTEGER INPUT VARIABLE WHICH SPECIFIES
C     THE NUMBER OF SUBDIAGONALS WITHIN THE BAND OF THE
C     JACOBIAN MATRIX. IF THE JACOBIAN IS NOT BANDED, SET
C     ML TO AT LEAST N - 1.
C
C     EPSFCN IS AN INPUT VARIABLE USED IN DETERMINING A SUITABLE
C     STEP LENGTH FOR THE FORWARD-DIFFERENCE APPROXIMATION. THIS
C     APPROXIMATION ASSUMES THAT THE RELATIVE ERRORS IN THE
C     FUNCTIONS ARE OF THE ORDER OF EPSFCN. IF EPSFCN IS LESS
C     THAN THE MACHINE PRECISION, IT IS ASSUMED THAT THE RELATIVE
C     ERRORS IN THE FUNCTIONS ARE OF THE ORDER OF THE MACHINE
C     PRECISION.
C
C     MU IS A NONNEGATIVE INTEGER INPUT VARIABLE WHICH SPECIFIES
C     THE NUMBER OF SUPERDIAGONALS WITHIN THE BAND OF THE
C     JACOBIAN MATRIX. IF THE JACOBIAN IS NOT BANDED, SET
C     MU TO AT LEAST N - 1.
C
C     WA1 AND WA2 ARE WORK ARRAYS OF LENGTH N. IF ML + MU + 1 IS AT
C     LEAST N, THEN THE JACOBIAN IS CONSIDERED DENSE, AND WA2 IS
C     NOT REFERENCED.
C
C     ARGONNE NATIONAL LABORATORY. MINPACK PROJECT. MARCH 1980.
C     BURTON S. GARBOW, KENNETH E. HILLSTROM, JORGE J. MORE
C
C     **********
C
C     EPSMCH IS THE MACHINE PRECISION.
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION  EPSFCN
      INTEGER           IRVNDS, LDFJAC, ML, MU, N
C     .. Array Arguments ..
      DOUBLE PRECISION  FJAC(LDFJAC,N), FVEC(N), WA1(N), WA2(N), X(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  EPS, EPSMCH, H, TEMP, ZERO
      INTEGER           I, J, K, MSUM
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      EXTERNAL          X02AJF
C     .. External Subroutines ..
      EXTERNAL          DSWAP
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MAX, SQRT
C     .. Save statement ..
      SAVE
C     .. Data statements ..
      DATA              ZERO/0.0D0/
C     .. Executable Statements ..
      GO TO (40,140) IRVNDS
      EPSMCH = X02AJF()
C
      EPS = SQRT(MAX(EPSFCN,EPSMCH))
      MSUM = ML + MU + 1
      IF (MSUM.LT.N) GO TO 80
C
C     COMPUTATION OF DENSE APPROXIMATE JACOBIAN.
C
      J = 1
   20 CONTINUE
      TEMP = X(J)
      H = EPS*ABS(TEMP)
      IF (H.EQ.ZERO) H = EPS
      X(J) = TEMP + H
      CALL DSWAP(N,WA1,1,FVEC,1)
      IRVNDS = 1
      RETURN
   40 CONTINUE
      CALL DSWAP(N,FVEC,1,WA1,1)
      X(J) = TEMP
      DO 60 I = 1, N
         FJAC(I,J) = (WA1(I)-FVEC(I))/H
   60 CONTINUE
      J = J + 1
      IF (J.LE.N) GO TO 20
      GO TO 200
   80 CONTINUE
C
C     COMPUTATION OF BANDED APPROXIMATE JACOBIAN.
C
      K = 1
  100 CONTINUE
      DO 120 J = K, N, MSUM
         WA2(J) = X(J)
         H = EPS*ABS(WA2(J))
         IF (H.EQ.ZERO) H = EPS
         X(J) = WA2(J) + H
  120 CONTINUE
      IRVNDS = 2
      CALL DSWAP(N,WA1,1,FVEC,1)
      RETURN
  140 CONTINUE
      CALL DSWAP(N,FVEC,1,WA1,1)
      DO 180 J = K, N, MSUM
         X(J) = WA2(J)
         H = EPS*ABS(WA2(J))
         IF (H.EQ.ZERO) H = EPS
         DO 160 I = 1, N
            FJAC(I,J) = ZERO
            IF (I.GE.J-MU .AND. I.LE.J+ML) FJAC(I,J) = (WA1(I)-FVEC(I))
     *          /H
  160    CONTINUE
  180 CONTINUE
      K = K + 1
      IF (K.LE.MSUM) GO TO 100
  200 CONTINUE
      IRVNDS = 0
      RETURN
      END

      SUBROUTINE C05AJF(X,EPS,ETA,F,NFMAX,IFAIL)
C     MARK 8 RELEASE. NAG COPYRIGHT 1979.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     MARK 13 REVISED. USE OF MARK 12 X02 FUNCTIONS (APR 1988).
C     DRIVER FOR C05AXF
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='C05AJF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  EPS, ETA, X
      INTEGER           IFAIL, NFMAX
C     .. Function Arguments ..
      DOUBLE PRECISION  F
      EXTERNAL          F
C     .. Local Scalars ..
      DOUBLE PRECISION  FX, SCALE
      INTEGER           FCOUNT, I, IFAIL1, IND, IR
C     .. Local Arrays ..
      DOUBLE PRECISION  C(26)
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      DOUBLE PRECISION  X02AJF
      INTEGER           P01ABF
      EXTERNAL          X02AJF, P01ABF
C     .. External Subroutines ..
      EXTERNAL          C05AXF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MAX, SQRT
C     .. Executable Statements ..
      IF (EPS.GT.0.0D0 .AND. NFMAX.GT.0) GO TO 20
C     INPUT ERROR
      I = 1
      GO TO 180
   20 SCALE = SQRT(SQRT(X02AJF()))*MAX(1.D0,ABS(X))
      FCOUNT = 0
      IR = 0
      IFAIL1 = 1
      IND = -1
   40 FX = F(X)
      FCOUNT = FCOUNT + 1
      IF (ABS(FX).GE.ETA .AND. FX.NE.0.0D0) GO TO 60
C     ROOT FOUND EXACTLY
      I = 0
      GO TO 180
   60 IF (FCOUNT.LT.NFMAX) GO TO 80
C     TOO MANY F CALLS
      I = 4
      GO TO 180
   80 CALL C05AXF(X,FX,EPS,IR,SCALE,C,IND,IFAIL1)
      IF (IND.NE.0) GO TO 40
      IF (IFAIL1.EQ.0) GO TO 160
      GO TO (100,100,120,140,140,140) IFAIL1
C     INPUT ERROR -IMPOSSIBLE
  100 I = 5
      GO TO 180
C     WRONG SCALE
  120 I = 2
      GO TO 180
C     TOO MUCH ACCURACY REQUESTED
  140 I = 3
      GO TO 180
  160 I = 0
  180 IFAIL = P01ABF(IFAIL,I,SRNAME,0,P01REC)
      RETURN
      END

      DOUBLE PRECISION FUNCTION F06BMF( SCALE, SSQ )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      DOUBLE PRECISION                  SCALE, SSQ
C     ..
C
C  F06BMF returns the value norm given by
C
C     norm = ( scale*sqrt( ssq ), scale*sqrt( ssq ) .lt. flmax
C            (
C            ( flmax,             scale*sqrt( ssq ) .ge. flmax
C
C  via the function name.
C
C
C  Nag Fortran 77 O( 1 ) basic linear algebra routine.
C
C  -- Written on 22-October-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      DOUBLE PRECISION      FLMAX, FLMIN, NORM, SQT
      LOGICAL               FIRST
C     .. External Functions ..
      DOUBLE PRECISION      X02AMF
      EXTERNAL              X02AMF
C     .. Intrinsic Functions ..
      INTRINSIC             SQRT
C     .. Save statement ..
      SAVE                  FIRST, FLMAX
C     .. Data statements ..
      DATA                  FIRST/ .TRUE. /
C     ..
C     .. Executable Statements ..
      IF( FIRST )THEN
         FIRST = .FALSE.
         FLMIN =  X02AMF( )
         FLMAX =  1/FLMIN
      END IF
C
      SQT = SQRT( SSQ )
      IF( SCALE.LT.FLMAX/SQT )THEN
         NORM = SCALE*SQT
      ELSE
         NORM = FLMAX
      END IF
C
      F06BMF = NORM
      RETURN
C
C     End of F06BMF. ( SNORM )
C
      END

      function readc2s(line2)
      character*(*) readc2s
      character*(*) line2
c use fort.99:
      rewind 99
      write(99,*)'''',line2,''''
      rewind 99
      read(99,*)readc2s
      rewind 99
      return
      end

      SUBROUTINE C05ADF(A,B,EPS,ETA,F,X,IFAIL)
C     MARK 8 RELEASE. NAG COPYRIGHT 1979.
C     MARK 10C REVISED. IER-422 (JUL 1983).
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C     DRIVER FOR C05AZF
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='C05ADF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  A, B, EPS, ETA, X
      INTEGER           IFAIL
C     .. Function Arguments ..
      DOUBLE PRECISION  F
      EXTERNAL          F
C     .. Local Scalars ..
      DOUBLE PRECISION  FX, Y
      INTEGER           IFAIL1, IND, IR
C     .. Local Arrays ..
      DOUBLE PRECISION  C(17)
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          C05AZF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, SIGN
C     .. Executable Statements ..
      IFAIL1 = 1
C     INPUT ERROR
      IF (A.EQ.B .OR. EPS.LE.0.D0) GO TO 120
      X = A
      FX = F(X)
      IFAIL1 = 0
C     ZERO AT INITIAL POINT
      IF (ABS(FX).LT.ETA .OR. FX.EQ.0.D0) GO TO 120
      Y = X
      C(1) = FX
      X = B
      FX = F(X)
C     ZERO AT INITIAL POINT
      IF (ABS(FX).LT.ETA .OR. FX.EQ.0.D0) GO TO 120
      IFAIL1 = 1
C     NO ROOT IN RANGE
      IF (SIGN(1.D0,FX).EQ.SIGN(1.D0,C(1))) GO TO 120
      IR = 1
      IND = -1
   20 CALL C05AZF(X,Y,FX,EPS,IR,C,IND,IFAIL1)
      IF (IND.EQ.0) GO TO 40
      FX = F(X)
      IF (ABS(FX).GE.ETA .AND. FX.NE.0.D0) GO TO 20
C     ZERO HIT EXACTLY
      IFAIL1 = 0
      GO TO 120
   40 IF (IFAIL1.EQ.0) GO TO 120
      GO TO (60,60,60,100,80) IFAIL1
C     IMPOSSIBLE EXIT
   60 IFAIL1 = 4
      GO TO 120
C     TOO MUCH ACCURACY REQUESTED
   80 IFAIL1 = 2
      GO TO 120
C     PROBABLY A POLE
  100 IFAIL1 = 3
  120 IFAIL = P01ABF(IFAIL,IFAIL1,SRNAME,0,P01REC)
      RETURN
      END

c***********************************************************************
      DOUBLE PRECISION FUNCTION DFETCH(name_variable,default)
c***
      INCLUDE 'undefined.h'
      INCLUDE 'GP_common.h'
      DOUBLE PRECISION  default, GETDOUBLE
      CHARACTER*(*) name_variable
      INTEGER line, FINDSTRING
      EXTERNAL GETDOUBLE, FINDSTRING
c***
      line = FINDSTRING(name_variable)
      if (line .eq. 0) then
         DFETCH = default
       else
         DFETCH = GETDOUBLE(line)
      endif
c***
c---       write (*,*) DFETCH
c***
      return
      end

        module thename
contains
        subroutine the_name(ip,plate)

        use param_run

        implicit none

        integer, intent(in) :: ip
        character*128, pointer :: plate(:)
        character numero*4,serie*4
        integer i,is

        include 'form_num.inc'
        allocate(plate(nbs(ip))) ; plate=''

        write(numero,444) ip_start+istep*(ip-1)
        numero=adjustl(numero)

! The reference serie is n_ref and will be from now on plate(1)
        do i=1,nbs(ip)
         is=modulo(i+nbs(ip)-n_ref,nbs(ip))+1 ! is=1 when i=n_ref or if nbs=1
         write(serie,"(i2)") i
         serie=adjustl(serie)
         if (nbs(ip) /= 1) then
           plate(is)=trim(prefix)//trim(serie)//'.'//trim(numero)//suffix
         else
           plate(is)=trim(prefix)//trim(numero)//suffix
         endif
        enddo


        end subroutine

        end module

	module belong

contains

	integer recursive function belong_to(a,i,j,g) result (res)

	implicit none

	integer, dimension (:,:) :: a
	double precision g(3)
	integer i,j

	if (a(i,j) == 4) then
	  a(i,j)=a(i,j)/2
	  g(1)=g(1)+dble(i)
	  g(2)=g(2)+dble(j)
	  g(3)=g(3)+1.d0

	  if (i-1 >= 1) res=belong_to(a,i-1,j,g)
	  if (j-1 >= 1) res=belong_to(a,i,j-1,g)
	  if (i+1 < size(a,1) ) res=belong_to(a,i+1,j,g)
	  if (j+1 < size(a,2) ) res=belong_to(a,i,j+1,g)
	  res=1
	endif
	end function

	end module

        module m_mres2d

contains
! version double precision

        subroutine mres2d(x,y,sc,specif,wavelet)

!  MRES2D    Performs two dimensional multiresolution analysis.
! 
!                  Y = MRES2D (X,H,RH,G,RG,SC,SPECIF) obtains the detail
!             or the low frequency approximation at scale SC of matrix 
!            X from a 2D multiresolution scheme. The analysis lowpass 
!            filter H, synthesis lowpass filter RH, analysis highpass 
!            filter G and synthesis highpass filter RG are used to
!            implement the scheme.
!
! In this version H,RH,G,RG are set to wavelets in the module 'wavelets'
!
!            The SPECIF parameter selects one of the following outputs: 
!
!        	0: Lowpass vertical and horizontal filtering. (APPROXIMATION)
!        	1: Lowpass vertical and highpass horizontal filtering.
!        	2: Highpass vertical and horizontal filtering. 
!        	3: Highpass vertical and lowpass horizontal filtering. 
!        	4: Sum of 1,2 and 3 outputs (COMPLETE DETAIL).
!
!
!             See also: APROX, DETAIL, MULTIRES, WT, SHOW


!--------------------------------------------------------
! Copyright (C) 1994, 1995, 1996, by Universidad de Vigo 
!                                                      
!                                                      
! Uvi_Wave is free software; you can redistribute it and/or modify it      
! under the terms of the GNU General Public License as published by the    
! Free Software Foundation; either version 2, or (at your option) any      
! later version.                                                           
!                                                                          
! Uvi_Wave is distributed in the hope that it will be useful, but WITHOUT  
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or    
! FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License    
! for more details.                                                        
!                                                                          
! You should have received a copy of the GNU General Public License        
! along with Uvi_Wave; see the file COPYING.  If not, write to the Free    
! Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.             
!                                                                          
!       Author: Sergio J. Garcia Galan
!       e-mail: Uvi_Wave@tsc.uvigo.es
! Translated into fortran90 by Michel Rieutord
!       e-mail: rieutord@obs-mip.fr
!--------------------------------------------------------

         use convolution_sub
        use wavelets_BL
        use wavelets_daub
        use wavelets_daub4
        use wavelets_spline

        implicit none

        real(kind(0d0)), dimension(:,:), intent(in) :: x
        real(kind(0d0)), dimension(:,:), intent(out) :: y
        real(kind(0d0)), dimension (:,:), allocatable :: t2,t2t, tr,tt
        real(kind(0d0)), dimension (:), allocatable :: t2tl,tm,fh,fv,rfh, &
                               rfv,f1,f2,h,rh,g,rg
        integer,intent(in) :: specif
        integer,intent(in) :: sc
        character*128, intent(in) :: wavelet
        integer d,dd,i,init,j,k,lx,ly,lox,loy,lf,spec,specific,s_h,s_g, &
                s_rh,s_rg,stm,jj,i1,j1

! choose the wavelet
        if (wavelet == 'daub4') then
         allocate(h(8),rh(8),g(8),rg(8))
         h=h4; rh=rh4; g=g4; rg=rg4
        else if (wavelet == 'daub8') then
         allocate(h(16),rh(16),g(16),rg(16))
         h=h8; rh=rh8; g=g8; rg=rg8
        else if (wavelet == 'splines') then
         allocate(h(8),rh(4),g(4),rg(8))
         h=hs; rh=rhs; g=gs; rg=rgs
        else if (wavelet == 'lemarie') then
         allocate(h(16),rh(16),g(16),rg(16))
         h=h_l; rh=rh_l; g=g_l; rg=rg_l
        else
         stop'in mres2d: no wavelet supplied'
        endif


!t=x
![loy,lox]=size(t);

lox=size(x,2)
loy=size(x,1)

allocate(tt(loy,lox),tr(loy,lox))

s_h=size(h); s_g=size(g); s_rh=size(rh); s_rg=size(rg)

!print*,'just a check on h and g: sum(h)=sqrt(2), sum(g)=0',sum(h),sum(g)
lf=s_h+s_rh

dd=lf/2-1
d=dd
if (sc>1) then
        do i=2,sc
          d=d+dd*2**(i-1)
        enddo
endif

!initialisation
!y(:,:)=0. !; f1(:)=0. ; f2(:)=0.; fh(:)=0.; fv(:)=0.; rfh(:)=0.; rfv(:)=0.
y=0d0

init=specif
specific=specif

if (specific==4) then
        specific=3;
        init=1;
endif

!print*,'avant la boucle'
!print*,'init,specific,d',init,specific,d,sc,lox,loy
!print*,'minmax of input',minval(x),maxval(x)
!print*,x(:,18)

do spec=init,specific
        tt=x;
  select case(spec)
    case(0); allocate(fh(s_h),fv(s_h),rfh(s_rh),rfv(s_rh))
                      fh=h; fv=h; rfh=rh; rfv=rh;
    case(1); allocate(fh(s_g),fv(s_h),rfh(s_rg),rfv(s_rh))
                      fh=g; fv=h; rfh=rg; rfv=rh;
    case(2); allocate(fh(s_g),fv(s_g),rfh(s_rg),rfv(s_rg))
                      fh=g; fv=g; rfh=rg; rfv=rg;
    case(3); allocate(fh(s_h),fv(s_g),rfh(s_rh),rfv(s_rg))
                      fh=h; fv=g; rfh=rh; rfv=rg;
  end select

  do i=1,sc
        if (i==sc) then
        		allocate(f1(size(fh)),f2(size(fv)))
        		f1=fh; f2=fv
        	else
        		allocate(f1(s_h),f2(s_h))
        		f1=h; f2=h
        endif
        ! fortran 90				      ! Matlab
        deallocate(tr)				      ! tr=[];
        ly=size(tt,1); lx=size(tt,2)                  ! [ly,lx]=size(tt);
        stm=lx+size(f1)-1
        allocate(tr(ly,(stm+1)/2),tm(stm)); tr=0d0; tm=0d0   ! (lx+16-1+1)/2

        do j=1,ly
         call convol(f1,tt(j,:),tm)
         tr(j,:)=tm(1:lx+15:2)
        enddo
        deallocate(tt)                                !	tt=[];

        ly=size(tr,1); lx=size(tr,2)                  !	[ly,lx]=size(tr);
        stm=ly+size(f2)-1
        allocate(tt((stm+1)/2,lx)); tt=0d0
        deallocate(tm); allocate(tm(stm)); tm=0d0
        do j=1,lx
         call convol(f2,tr(:,j),tm)
         tt(:,j)=tm(1:ly+15:2)
        enddo
        deallocate(tm,f1,f2)
  enddo

!print*,'minmax tt',minval(tt),maxval(tt)
        
  do i=1,sc
        if (i==1) then
        	allocate(f1(size(rfh)),f2(size(rfv)))
        	f1=rfh; f2=rfv;
        else
        	allocate(f1(s_rh),f2(s_rh))
        	f1=rh; f2=rh;
        endif
        deallocate(tr)		                      !	tr=[];
        ly=size(tt,1); lx=size(tt,2)                  !	[ly,lx]=size(tt);
        stm=2*ly+size(f2)-1
        allocate(t2(ly,2),t2t(2,ly),t2tl(2*ly),tr(stm,lx),tm(stm))
        t2=0d0; t2t=0d0; t2tl=0d0; tr=0d0; tm=0d0

        do j=1,lx
                                                    ! tm=[tt(:,j),zeros(ly,1)]
         t2=reshape(source=(/ (tt(k,j),k=1,ly),(0.d0,k=1,ly) /),shape=(/ly,2/) )
!        print*,'t2',j,minval(t2),maxval(t2)
         t2t=transpose(t2)
!t2tl=reshape(source=t2t, shape=(/1/)) ! marche sous ifort et pas sous gfortran
         do jj=1,2*ly
          j1=(jj+1)/2; i1=2-modulo(jj,2)
          t2tl(jj)=t2t(i1,j1)
         enddo
!        print*,'t2tl',j,minval(t2tl),maxval(t2tl)
         call convol(f2,t2tl,tm)
!        print*,'tm',j,minval(tm),maxval(tm)
          tr(:,j) = tm(:)
        enddo
!       print*,'minmax next step 1',minval(tr),maxval(tr)


        deallocate(t2,t2t,t2tl,tm,tt)                 !	tt=[];
        ly=size(tr,1); lx=size(tr,2)                  !        [ly,lx]=size(tr);
        stm=2*lx+size(f1)-1
        allocate(t2(lx,2),t2t(2,lx),t2tl(2*lx),tt(ly,stm),tm(stm))
        t2=0d0; t2t=0d0; t2tl=0d0; tt=0d0; tm=0d0

        do j=1,ly
                                                   ! tm=[tr(j,:);zeros(1,lx)];
         t2=reshape(source=(/ (tr(j,k),k=1,lx),(0d0,k=1,lx) /), shape=(/lx,2/) )
         t2t=transpose(t2)
         !t2tl=reshape(source=t2t, shape=(/1/))
         do jj=1,2*lx
          j1=(jj+1)/2; i1=2-modulo(jj,2)
          t2tl(jj)=t2t(i1,j1)
         enddo
         call convol(f1,t2tl,tm)
         tt(j,:) = tm(:)
        enddo
!       print*,'minmax next step 2',minval(tt),maxval(tt)
        deallocate(t2,t2t,t2tl,tm,f1,f2)
  enddo
        
!       print*,'spec=',spec,'dims',ly,2*lx+15
!       print*,'requested=',1+d,loy+d,1+d,lox+d
        y=y+tt(1+d:loy+d,1+d:lox+d);
        deallocate(tt,fh,fv,rfh,rfv)
        allocate(tt(loy,lox))
enddo ! sur spec

!       print*,'minmax la sortie',minval(y),maxval(y)

        deallocate(tt,tr,h,rh,g,rg)
        end subroutine

end module

! Module for the parameters of the run 

	module param_run
        integer, save:: ip_start,np, n_ech, n_life, bin_sp,istep,n_ref
        integer, save:: ngmax0
        integer, save:: nx,ny,nx1,nx2,ny1,ny2,sub_im,verbose,nbs_max,maxdim
        integer, allocatable, save:: nbs(:)
        character*128, save:: prefix, suffix,wavelet,path_distor,typeseg,option
        character*128, save:: input_file,convolution,the_time_file,postprocessingpath
	character*3, save:: check
        real, save:: pixel,arcsec,timestep,delta_pix,seuil,prec,t_thres,v_thres
        real, save:: seuil_min
        real, save:: ech_lap, seuil_lap, seuil_rel, seuil_courb, &
                     seuil_bas,seuil_haut
        integer, save:: n_moy,nconv
!       real, pointer :: t(:)
	logical, save :: segmented,equidistance
	end module

      DOUBLE PRECISION FUNCTION X02AMF()
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C
C     RETURNS THE 'SAFE RANGE' PARAMETER
C     I.E. THE SMALLEST POSITIVE MODEL NUMBER Z SUCH THAT
C     FOR ANY X WHICH SATISFIES X.GE.Z AND X.LE.1/Z
C     THE FOLLOWING CAN BE COMPUTED WITHOUT OVERFLOW, UNDERFLOW OR OTHER
C     ERROR
C
C        -X
C        1.0/X
C        SQRT(X)
C        LOG(X)
C        EXP(LOG(X))
C        Y**(LOG(X)/LOG(Y)) FOR ANY Y
C
      DOUBLE PRECISION X02CON
      DATA X02CON /Z'0020000000000000' /
C     .. Executable Statements ..
      X02AMF = X02CON
      RETURN
      END

        module segmentation

contains

      subroutine segment(a,nx,ny,ia)

!     Segmentation of granules using the curvatures in 4 directions
!     adapted from segmentons.pro (Thierry Roudier, 1998)
!     by Nadege Meunier (2000), then by M. Rieutord (16/2/2000)

! Input:
!     a = input image (size: nx,ny)
!     nx,ny input sizes
! OUTPUT:
!     the binary image 'ia'

!     parameters which could be adjusted: 
!       - nconv (size of the convolution)
!	- fac_open (size of the opening kernel)

        use param_run, only: convolution,nconv

	implicit none

	integer, parameter:: fac_open=2
        integer i,j,k,l,nconv2,n,nx,ny
        real*4, dimension (nx,ny) :: a 
        real*4, dimension (:,:), allocatable :: aconv 
	real*4 kern(nconv,nconv)
        real*4 s(fac_open,fac_open)
        real*4 c1,c2,c3,c4,d,sigma,r
	integer, dimension (nx,ny), intent(out) :: ia

! INITIALIZATION

      nconv2=nconv/2
      if (2*nconv2 == nconv) stop'nconv must be odd'
      if (convolution == 'Id') kern=1.
      if (convolution == 'Gaussian') then
!      kern=1.
!      kern = reshape(source=(/ &
!   1,  8, 15,  8, 1, &
!   8, 63,127, 63, 8, &
!  15,127,255,127,15, &
!   8, 63,127, 63, 8, &
!   1,  8, 15,  8, 1 /), shape=(/5,5/) )
        d=nconv2*sqrt(real(2))
        sigma=d/sqrt(log(255d0))

        do j=1,2*nconv2+1
         do i=1,2*nconv2+1
          r=sqrt(float(i-nconv2-1)**2+float(j-nconv2-1)**2)
          kern(i,j)=255d0*exp(-r**2/sigma**2)
         enddo
        enddo

      endif

      allocate(aconv(nx,ny)); aconv=0.



! CONVOLUTION


      do i=nconv2+1,nx-nconv2
         do j=nconv2+1,ny-nconv2

	    do k=1,nconv
	       do l=1,nconv
		  aconv(i+k-nconv2-1,j+l-nconv2-1)= &
                  aconv(i+k-nconv2-1,j+l-nconv2-1)+a(i,j)*kern(k,l)
               end do
            end do

         end do
      end do

! SEGMENTATION : RESEARCH OF NEGATIVE CURVATURE 

      k=0
      do j=2,ny-1
         do i=2,nx-1

            c1= aconv(i-1,j) - 2.*aconv(i,j) + aconv(i+1,j)
            c2= aconv(i,j-1) - 2.*aconv(i,j) + aconv(i,j+1)
            c3= aconv(i-1,j-1) - 2.*aconv(i,j) + aconv(i+1,j+1)
            c4= aconv(i-1,j+1) - 2.*aconv(i,j) + aconv(i+1,j-1)
!           research of negative curvatures = granules
            if (c1.lt.0.and.c2.lt.0.and.c3.lt.0.and.c4.lt.0) then 
!              k=k+1
!	       ix(k)=i ; iy(k)=j
	      ia(i,j)=4
            end if

         end do
      end do

!	n=k
      deallocate(aconv)

      end subroutine


!=================================================================
!=================================================================

      subroutine segmentlab(a,nx,ny,ngmax,ia)

!     Segmentation of granules using the curvatures in 4 directions
!     adapted from segmentons.pro (Thierry Roudier, 1998)
!     by Nadege Meunier (2000), then by M. Rieutord (16/2/2000)
!     then Th. Roudier (2/3/2011) 

! Input:
!     a = input image (size: nx,ny)
!     nx,ny input sizes
! OUTPUT:
!     the binary image 'ia'

!     parameters which could be adjusted: 
!       - nconv (size of the convolution)
!	- fac_open (size of the opening kernel)

        use param_run, only: convolution,nconv

	implicit none

        integer i,j,k,l,nconv2,n,nx,ny,ngmax

        character fichier3*100 !!!!!!!!!!!!!!

        real*4, dimension (nx,ny) :: a      
        real*4, dimension (:,:), allocatable :: aconv 
	double precision kern(nconv,nconv)
        real*4 c1,c2,c3,c4,c5,d,sigma,r
        real*4 egal(ngmax)
	real :: MAX
        real*4 diago, lambda_moins, lambda_plus
        integer, dimension (nx,ny), intent(out) :: ia
        integer, dimension (nx,ny) :: tempo
        integer xmoins,ymoins,m,epsilon,ii,num,kk,x,y, num_new
        integer :: H(ngmax),HGRAN(ngmax),BIN,gran,maxi


        xmoins=0 ; ymoins=0 ; m=0 ;epsilon= 0 
        ii=0 ; num= 0 ; kk=0 
        H=0 ; HGRAN=0 ; BIN=0 ; gran=0 ; maxi=0
        tempo=0
        ia=0 
 


! INITIALIZATION

      nconv2=nconv/2
      
      if (2*nconv2 == nconv) stop'nconv must be odd'
      if (convolution == 'Id') kern=1.
      if (convolution == 'Gaussian') then
  
        d=nconv2*sqrt(real(2))
        sigma=d/sqrt(log(255d0))

        do j=1,2*nconv2+1
         do i=1,2*nconv2+1
          r=sqrt(float(i-nconv2-1)**2+float(j-nconv2-1)**2)
          kern(i,j)=255d0*exp(-r**2/sigma**2)
         enddo
        enddo

      end if

      allocate(aconv(nx,ny)); aconv=0.

 a(:,1)=0.
 a(:,ny)=0.
 a(1,:)=0.
 a(nx,:)=0.

 
! CONVOLUTION
!      do i=nconv2+1,nx-nconv2
!         do j=nconv2+1,ny-nconv2
!	    do k=1,nconv
!	       do l=1,nconv
!		  aconv(i+k-nconv2-1,j+l-nconv2-1)= &
!                  aconv(i+k-nconv2-1,j+l-nconv2-1)+a(i,j)*kern(k,l)
!               end do
!            end do
!         end do
!      end do


! SEGMENTATION : RESEARCH OF NEGATIVE CURVATURE 


      do j=2,ny-1
         do i=2,nx-1
!            c1= aconv(i-1,j) - 2.*aconv(i,j) + aconv(i+1,j)
!            c2= aconv(i,j-1) - 2.*aconv(i,j) + aconv(i,j+1)
!            c3= aconv(i-1,j-1) - 2.*aconv(i,j) + aconv(i+1,j+1)
!            c4= aconv(i-1,j+1) - 2.*aconv(i,j) + aconv(i+1,j-1)
!            research of negative curvatures = granules Version Francois 7sept2015
!            c5=  (aconv(i+1,j+1) +aconv(i-1,j-1)-aconv(i-1,j+1)-aconv(i+1,j-1))/4.

!     equivalent pour nconv=1 on evite ainsi la convolution
            c1= a(i-1,j) - 2.*a(i,j) + a(i+1,j)
            c2= a(i,j-1) - 2.*a(i,j) + a(i,j+1)
            c3= a(i-1,j-1) - 2.*a(i,j) + a(i+1,j+1)
            c4= a(i-1,j+1) - 2.*a(i,j) + a(i+1,j-1)
!            research of negative curvatures = granules Version Francois 7sept2015
            c5=  (a(i+1,j+1) +a(i-1,j-1)-a(i-1,j+1)-a(i+1,j-1))/4.


!            research of negative curvatures = granules
!            if (c1.lt.0.and.c2.lt.0.and.c3.lt.0.and.c4.lt.0.) then 
!	      ia(i,j)=1.
!            end if

!            research of negative curvatures = granules Version Francois 7sept2015
            diago=sqrt((c1-c2)**2 /4. +(c5)**2) 
            lambda_moins = (c1+c2)/2. - diago
            lambda_plus  = (c1+c2)/2. + diago
            if (lambda_moins.lt.0.and.lambda_plus.lt.0) then 
	      ia(i,j)=1.
            end if

         end do
      end do
     
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! pour sauvegarder une image pour le controle
	  fichier3='results/image_cont'
          open(unit=4,file=fichier3,form='formatted')
           write(4,*) nx,ny
           write(4,*) ia(1:nx,1:ny)
          close(4)  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!=================================================================


          
num_new=1
!mise à zero des bordures afin que l'etiquetage 
!fonctionne correctement


! premier passage

do y=2,ny
 do x=2,nx 

   xmoins=ia(x-1,y) 
   ymoins=ia(x,y-1)

 if(ia(x,y) .gt. 0) then 
  
  if (xmoins .eq. 0 .and. ymoins .eq. 0) then 
    ia(x,y)=num_new
    egal(num_new)=num_new
    num_new=num_new+1
  else 

   if (xmoins .eq. ymoins) then 
    ia(x,y)=xmoins
   else 
      
    if (ymoins .gt. xmoins) then  
     if(xmoins .gt. 0) then 
      epsilon=egal(xmoins)
     end if
     if(xmoins .eq. 0) then 
      epsilon=egal(ymoins)
     end if
    end if 

   if (ymoins .lt. xmoins) then  
     if(ymoins .gt. 0) then 
        epsilon=egal(ymoins)
     end if 
     if(ymoins .eq. 0) then 
      epsilon=egal(xmoins) 
     end if
   end if 

    ia(x,y)=epsilon

    if(xmoins .ne. 0) then      
     do while(egal(xmoins) .ne. epsilon) 
      m=egal(xmoins) 
      egal(xmoins)=epsilon
      xmoins=m
     end do
    end if
 
   if(ymoins .ne. 0) then 
    do while(egal(ymoins) .ne. epsilon) 
     m=egal(ymoins) 
     egal(ymoins)=epsilon
     ymoins=m
    end do
   end if
        
  end if
 end if
end if

 end do
end do 


do kk=1,ngmax
 if(egal(kk) .eq. 0) then 
    go to 9999
 end if

  m=kk
  do while(egal(m) .ne. m)      ! m+1)  
   m=egal(m)                    ! - 1
   egal(kk)=m                   ! +1
  end do
end do

9999 continue

do y=2.,ny 
 do x=2.,nx 
  if(ia(x,y) .gt. 0) then 
   ia(x,y)=egal(ia(x,y))
  end if
 end do
end do 


!goto 888


!on renumerote par ordre croissant sans trou.

!print*,'maxval(ia)=',maxval(ia)

max=maxval(ia)


H=0
BIN=0

! on fait l'histogramme
 
do y=1.,ny 
 do x=1.,nx 
  if(ia(x,y).gt.0) then
   BIN=INT(ia(x,y)) 
   H(BIN)=H(BIN)+1 
  end if
 end do
end do

!=========== ajout le 3 sept2015 ===================================
!on elimine les granules avec une aire inferieure a une aire donnee
! ici 1 pixel
! ici 3 pixels
! ici 7 pixel
! ici 10 pixel 
! ici 15 pixel
! ici 0 pixel on garde tout

!do ii=1,max
!if (H(ii).lt.2) then

! ici 3 pixels
!if (H(ii).lt.4) then  

! if (H(ii).lt.8) then
! if (H(ii).lt.11) then
! if (H(ii).lt.16) then
! if (H(ii).lt.0) then
!  H(ii)=0.
! endif
!enddo 
! on enleve les pixels non utiles

!do y=1.,ny 
! do x=1.,nx 
!  if(ia(x,y).gt.0) then
!   BIN=INT(ia(x,y))
!   if (H(bin).eq.0) then 
!     ia(x,y)=0.
!   end if
!  end if
! end do
!end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! pour sauvegarder une image pour le controle
!	  fichier3='results/image_cont'
!          open(unit=4,file=fichier3,form='formatted')
!           write(4,*) nx,ny
!           write(4,*) ia(1:nx,1:ny)
!          close(4)  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!=========== ajout le 3 sept2015 ====================

! on renumerote
num=1

do ii=1,max
if (H(ii).gt.0) then  
  HGRAN(ii)=num 
  num=num+1   
 endif
enddo 

do y=1.,ny 
 do x=1.,nx     
  if(ia(x,y).gt.0) then
    gran= ia(x,y)
    tempo(x,y)=HGRAN(gran)
  endif
 end do
end do


ia=tempo
 
888   continue


maxi=maxval(ia)
!print*,'maxii out=',maxi


!=================================================================


      deallocate(aconv)

      end subroutine


!=================================================================
!       subroutine pour l'etiquetage seulement
!=================================================================

      subroutine label(a,nx,ny,ngmax,ia)
!      subroutine label_NR(a,nx,ny,ngmax,ia)

!     Segmentation of granules using the curvatures in 4 directions
!     adapted from segmentons.pro (Thierry Roudier, 1998)
!     by Nadege Meunier (2000), then by M. Rieutord (16/2/2000)
!     then Th. Roudier (2/3/2011) 

! Input:
!     xn,yn input sizes
! OUTPUT:
!     the binary image 'ia'

        

	implicit none

        integer i,j,k,l,n,nx,ny,ngmax
!        
        real*4, dimension (nx,ny) :: a   
! modif N. Renon
!        integer, dimension (nx,ny) :: a      

        real*4 egal(ngmax)
! modif N.Renon
!        integer egal(ngmax)
	real :: MAX
        integer, dimension (nx,ny), intent(out) :: ia
        integer, dimension (nx,ny) :: tempo
        integer xmoins,ymoins,m,epsilon,ii,num,kk,x,y, num_new
        integer :: H(ngmax),HGRAN(ngmax),BIN,gran,maxi
!       integer, dimension (nx,ny) :: a     
 

      xmoins=0 ; ymoins=0 ; m=0 ;epsilon= 0 
        ii=0 ; num= 0 ; kk=0 
        H=0 ; HGRAN=0 ; BIN=0 ; gran=0 ; maxi=0
        tempo=0
        ia=0 
!=================================================================

num_new=1

!mise à zero des bordures afin que l'etiquetage 
!fonctionne correctement

! Quand a était un simple precision
ia=int(a)
 !ia=a

 ia(:,1)=0.
 ia(:,ny)=0.
 ia(1,:)=0.
 ia(nx,:)=0.

! premier passage

do y=2,ny
 do x=2,nx 

   xmoins=ia(x-1,y) 
   ymoins=ia(x,y-1)

 if(ia(x,y) .gt. 0) then 
  
  if (xmoins .eq. 0 .and. ymoins .eq. 0) then 
    ia(x,y)=num_new
    egal(num_new)=num_new
    num_new=num_new+1
  else 

   if (xmoins .eq. ymoins) then 
    ia(x,y)=xmoins
   else 
      
    if (ymoins .gt. xmoins) then  
     if(xmoins .gt. 0) then 
      epsilon=egal(xmoins)
     end if
     if(xmoins .eq. 0) then 
      epsilon=egal(ymoins)
     end if
    end if 

   if (ymoins .lt. xmoins) then  
     if(ymoins .gt. 0) then 
        epsilon=egal(ymoins)
     end if 
     if(ymoins .eq. 0) then 
      epsilon=egal(xmoins) 
     end if
   end if 

    ia(x,y)=epsilon

    if(xmoins .ne. 0) then      
     do while(egal(xmoins) .ne. epsilon) 
      m=egal(xmoins) 
      egal(xmoins)=epsilon
      xmoins=m
     end do
    end if
 
   if(ymoins .ne. 0) then 
    do while(egal(ymoins) .ne. epsilon) 
     m=egal(ymoins) 
     egal(ymoins)=epsilon
     ymoins=m
    end do
   end if
        
  end if
 end if
end if

 end do
end do 


do kk=1,ngmax 
 if(egal(kk) .eq. 0) then 
    go to 9999
 end if

  m=kk
  do while(egal(m) .ne. m)      ! m+1)   
   m=egal(m)                    ! - 1
   egal(kk)=m                   ! +1
  end do
end do

9999 continue

do y=2.,ny 
 do x=2.,nx 
  if(ia(x,y) .gt. 0) then 
   ia(x,y)=egal(ia(x,y))
  end if
 end do
end do 


!on renumerote par ordre croissant sans trou.

max=maxval(ia)

H=0
BIN=0

! on fait l'histogramme
 
do y=1.,ny 
 do x=1.,nx 
  if(ia(x,y).gt.0) then
   BIN=INT(ia(x,y)) 
   H(BIN)=H(BIN)+1 
  end if
 end do
end do

! on renumerote
num=1


do ii=1,max
 if (H(ii).gt.0) then
  HGRAN(ii)=num 
  num=num+1   
 endif
enddo 

do y=1.,ny 
 do x=1.,nx     
  if(ia(x,y).gt.0) then
    gran= ia(x,y)
     tempo(x,y)=HGRAN(gran)
  endif
 end do
end do

ia=tempo
 
maxi=maxval(ia)
!!!print*,'maxii out=',maxi


      end subroutine


      end module

c     $Author: rieutord $
c     $Revision: 1.1.1.1 $
c     $Log: findstring.f,v $
c     Revision 1.1.1.1  2004-03-10 12:30:55  rieutord
c     import cst v. 2.2.3
c
c Revision 1.2  1993/04/21  16:53:35  raus
c size of char strings up to 128
c
c Revision 1.1  1993/04/20  17:43:17  raus
c 1st save; find_string to findstring
c
c***********************************************************************
      INTEGER FUNCTION FINDSTRING(name_variable)
c***
      INCLUDE 'undefined.h'
      INCLUDE 'GP_common.h'
      CHARACTER*(*) name_variable
      INTEGER i, count, l, l1
      LOGICAL flag_ok
      CHARACTER*1 char
      CHARACTER*128 name
c***
      l1 = LEN(name_variable)
      FINDSTRING = 0
      if (nlines .lt. 1) return
      do count=1,nlines
         l = name_var_len(count)
         if (l1 .ne. l) then
            flag_ok = .false.
         else 
            name = lines_of_text(count)
            flag_ok = .true.
            do i=1,l1
               char = name_variable(i:i)
               if (name(i:i) .ne. char) flag_ok = .false.
            enddo
         endif 
         if (flag_ok) FINDSTRING = count
      enddo
c***
      return
      end

c***********************************************************************
      SUBROUTINE read_file(name)
c***
      INCLUDE 'undefined.h'
      INCLUDE 'GP_common.h'
      CHARACTER*(*) name
      CHARACTER*128 line_of_text, line_aux
      CHARACTER*1 blank, eq_char, tab, com_1, com_2, char
      INTEGER i, k, m, count, len_line
      DATA blank/' '/, eq_char/'='/, tab/'\t'/, com_1/'#'/, com_2/'!'/
c***  
c repetitive read:
c     count = nlines
c or refresh read:
      count=0
      open(unit=10,file=name,status='old',ERR=100)  
      do k = 1,nlines_max
         read (10,'(A128)',ERR=100,END=100) line_of_text  
         len_line = LEN(line_of_text)
         m = INDEX(line_of_text,eq_char)
c***  
c     lines with no '=' are discarded
c***  
         if (m .gt. 0) then
c***  
c     the text line is copied into the initialised auxiliary line,
c     all blanks and tabs are removed in the process
c***  
            do i=1,len_line
               line_aux(i:i) = blank
            enddo 
            m = 1
            do i = 1,len_line
               char = line_of_text(i:i)
               if (char .ne. blank .and. char .ne. tab) then
                  line_aux(m:m) = char
                  m = m + 1
               endif
            enddo 
c***  
c     discard line if 1st char is a '=', '#' or '!' and also if
c     1st character after '=' is a '#' or '!'
c***  
            m = 1
            char = line_aux(1:1)
            if (char .eq. eq_char .or. char .eq. com_1 .or.
     %          char .eq. com_2) m = 0 
            i = INDEX(line_aux,eq_char)
            char = line_aux(i+1:i+1)   
            if (char .eq. com_1 .or. char .eq. com_2) m = 0
c***  
c     eventual comments at end of line are discarded
c***  
            if (m .gt. 0) then
               m = INDEX(line_aux,com_1)
               if ( m .eq. 0) m = INDEX(line_aux,com_2)
               if (m .gt. 0) then
                  do i = m,len_line
                     line_aux(i:i) = blank
                  enddo 
               endif 
               line_of_text = line_aux
               len_line = LEN(line_of_text)
c***  
c     we've got it, finally !
c***  
               count = count + 1
               lines_of_text(count) = line_of_text
               name_var_len(count) = INDEX(line_of_text,eq_char) - 1
            endif 
         endif
      enddo 
c***  
  100 nlines = count
      close (10)
c***  
c---      call GPsort
c***
      return 
      end

! Calcul des coefficients r par la methode de Beylkin
! nouvelle version tenant compte des differentes ondelettes possibles

	subroutine coef_r(rr,L)

	use param_run
        use wavelets_BL
        use wavelets_daub
        use wavelets_daub4
        use wavelets_spline


	implicit none

	integer, parameter :: ni=10
	integer n,i,ll,k,m,L
	real(kind(0d0)) som,rr(-L+2:L-2)
	real(kind(0d0)), dimension (:), allocatable :: h,rh,g,rg,a
	real(kind(0d0)), dimension (:,:), allocatable :: r

! choose the wavelet
        if (wavelet == 'daub4') then
         allocate(h(L),rh(L),g(L),rg(L),a(L-1),r(-L+2:L-2,ni))
         h=h4; rh=rh4; g=g4; rg=rg4
        else if (wavelet == 'daub8') then
         allocate(h(L),rh(L),g(L),rg(L),a(L-1),r(-L+2:L-2,ni))
         h=h8; rh=rh8; g=g8; rg=rg8
        else if (wavelet == 'splines') then
         allocate(h(8),rh(4),g(4),rg(8))
         h=hs; rh=rhs; g=gs; rg=rgs
	 print*,'There may be a problem with splines'
        else if (wavelet == 'lemarie') then
         allocate(h(L),rh(L),g(L),rg(L),a(L-1),r(-L+2:L-2,ni))
         h=h_l; rh=rh_l; g=g_l; rg=rg_l
        else
         stop'in mres2d: no wavelet supplied'
        endif


! 1) calcul des a(2k-1)

	do n=1,L-1,2
	 a(n)=0
	 do i=0,L-1-n
	  a(n)=a(n)+2*rh(i+1)*rh(i+1+n)
	 enddo
	enddo

! 1b) calcul direct des a(2k-1) : gives the same results as above
!
!	forall(i=1:L/2-1) b(i)=real(2*i+1)/2
!	C8=product(b)**2
!	do m=1,L/2
!	 fm=1d0
!	 do i=1,L/2-m
!	  fm=fm*i
!	 enddo
!	 fmp=1d0
!	 do i=1,L/2+m-1
!	  fmp=fmp*i
!	 enddo
!	 aa(2*m-1)=(-1)**(m-1)*C8/fm/fmp/(2*m-1)
!	enddo

! 2) calcul des r_l par methode iterative de Beylkin 1992

	r=0
	r(-1,1)=0.5 ; r(1,1)=-0.5

	do i=2,ni
	 do ll=-L+2,L-2
	  som=0.0
	  do k=1,L/2
	   if (2*ll+2*k-1 < L-1 .and. 2*ll+2*k-1 > -L+1) &
                                   som=som+a(2*k-1)*r(2*ll+2*k-1,i-1)
	   if (2*ll-2*k+1 < L-1 .and. 2*ll-2*k+1 > -L+1) &
                                   som=som+a(2*k-1)*r(2*ll-2*k+1,i-1)
	  enddo
	  r(ll,i)=som
	  if (2*ll < L-1 .and. 2*ll > -L+1) r(ll,i)=som+2*r(2*ll,i-1)
	 enddo
	enddo

! verification

!	forall (i= -L+2:l+2) rr(i)=i*r(i,ni)
!	print*,'check',sum(rr)+1
	rr(:)=r(:,ni)

	deallocate(h,rh,g,rg)
	end

      CHARACTER*128 FUNCTION GETSTRING(i_line)
c***
      INCLUDE 'undefined.h'
      INCLUDE 'GP_common.h'
      INTEGER i_line
      INTEGER ibegin, i, iend
      CHARACTER*128 line1,line2
      CHARACTER*1 eq_char, blank
      DATA eq_char/'='/, blank/' '/
      INTRINSIC INDEX
#ifdef sn4607
      character*128 readc2s
      external readc2s
#endif
c***
      line1 = lines_of_text(i_line)
      ibegin = 1 + INDEX(line1,eq_char)
      do i = 1, 128
         line2(i:i) = blank
      enddo
      line2(1:128 - ibegin + 1) = line1(ibegin:128)
#ifdef sn4607
      GETSTRING=readc2s(line2)
#else
      read(line2,'(A)') GETSTRING
#endif
c***
c---      write(*,*) line1(1:ibegin-1), '>>>', GETSTRING, '<<<'
c***
      return 
      end

      SUBROUTINE C05NCU(N,R,LR,DIAG,QTB,DELTA,X,WA1,WA2)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     MARK 14C REVISED. IER-869 (NOV 1990).
C     **********
C
C     SUBROUTINE C05NCU (based on MINPACK routine DOGLEG)
C
C     Given an M by N matrix A, an N by N nonsingular diagonal
C     matrix D, an M-vector B, and A positive number DELTA, the
C     problem is to determine the convex combination X of the
C     Gauss-Newton and scaled gradient directions that minimizes
C     (A*X - B) in the least squares sense, subject to the
C     restriction that the euclidean norm of D*X be at most DELTA.
C
C     This subroutine completes the solution of the problem
C     if it is provided with the necessary information from the
C     QR factorization of A. That is, if A = Q*R, where Q has
C     orthogonal columns and R is an upper triangular matrix,
C     then C05NCU expects the full upper triangle of R and
C     the first N components of (Q transpose)*B.
C
C     The subroutine statement is
C
C     SUBROUTINE C05NCU(N,R,LR,DIAG,QTB,DELTA,X,WA1,WA2)
C
C     where
C
C     N is a positive integer input variable set to the order of R.
C
C     R is an input array of length LR which must contain the upper
C     triangular matrix R stored by rows.
C
C     LR is a positive integer input variable not less than
C     (N*(N+1))/2.
C
C     DIAG is an input array of length N which must contain the
C     diagonal elements of the matrix D.
C
C     QTB is an input array of length N which must contain the first
C     N elements of the vector (Q transpose)*B.
C
C     DELTA is a positive input variable which specifies an upper
C     bound on the Euclidean norm of D*X.
C
C     X is an output array of length N which contains the desired
C     convex combination of the Gauss-Newton direction and the
C     scaled gradient direction.
C
C     WA1 and WA2 are work arrays of length N.
C
C     Argonne National Laboratory. MINPACK project. March 1980.
C     Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C
C     **********
C
C     Revised to call BLAS.
C     P.J.D. Mayes, J.J. Du Croz, NAG Central Office, September 1987.
C
C     .. Parameters ..
      DOUBLE PRECISION  ONE, ZERO
      PARAMETER         (ONE=1.0D0,ZERO=0.0D0)
C     .. Scalar Arguments ..
      DOUBLE PRECISION  DELTA
      INTEGER           LR, N
C     .. Array Arguments ..
      DOUBLE PRECISION  DIAG(N), QTB(N), R(LR), WA1(N), WA2(N), X(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  ALPHA, BNORM, EPSMCH, GNORM, QNORM, SGNORM, TEMP
      INTEGER           I, J, JJ, L
C     .. External Functions ..
      DOUBLE PRECISION  F06EJF, X02AJF
      EXTERNAL          F06EJF, X02AJF
C     .. External Subroutines ..
      EXTERNAL          DTPMV, DTPSV
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MAX, MIN, SQRT
C     .. Executable Statements ..
      EPSMCH = X02AJF()
C
C     First, calculate the Gauss-Newton direction.
C
      JJ = 1
      DO 40 J = 1, N
         WA1(J) = R(JJ)
         IF (R(JJ).EQ.ZERO) THEN
            TEMP = ZERO
            L = J
            DO 20 I = 1, J - 1
               TEMP = MAX(TEMP,ABS(R(L)))
               L = L + N - I
   20       CONTINUE
            IF (TEMP.EQ.ZERO) THEN
               R(JJ) = EPSMCH
            ELSE
               R(JJ) = EPSMCH*TEMP
            END IF
         END IF
         JJ = JJ + N - J + 1
   40 CONTINUE
      DO 60 I = 1, N
         X(I) = QTB(I)
   60 CONTINUE
      CALL DTPSV('Lower triangle','Transpose','Non-unit diagonal',N,R,X,
     *           1)
      JJ = 1
      DO 80 J = 1, N
         R(JJ) = WA1(J)
         JJ = JJ + N - J + 1
   80 CONTINUE
C
C     Test whether the Gauss-Newton direction is acceptable.
C
      DO 100 J = 1, N
         WA2(J) = DIAG(J)*X(J)
  100 CONTINUE
      QNORM = F06EJF(N,WA2,1)
      IF (QNORM.GT.DELTA) THEN
C
C        The Gauss-Newton direction is not acceptable.
C        next, calculate the scaled gradient direction.
C
         DO 120 I = 1, N
            WA1(I) = QTB(I)
  120    CONTINUE
         CALL DTPMV('Lower triangle','Not transpose',
     *              'Non-unit diagonal',N,R,WA1,1)
         DO 140 I = 1, N
            WA1(I) = WA1(I)/DIAG(I)
  140    CONTINUE
C
C        Calculate the norm of the scaled gradient and test for
C        the special case in which the scaled gradient is zero.
C
         GNORM = F06EJF(N,WA1,1)
         SGNORM = ZERO
         ALPHA = DELTA/QNORM
         IF (GNORM.NE.ZERO) THEN
C
C           Calculate the point along the scaled gradient
C           at which the quadratic is minimized.
C
            DO 160 J = 1, N
               WA1(J) = (WA1(J)/GNORM)/DIAG(J)
  160       CONTINUE
            DO 180 I = 1, N
               WA2(I) = WA1(I)
  180       CONTINUE
            CALL DTPMV('Lower triangle','Transpose','Non-unit diagonal',
     *                 N,R,WA2,1)
            TEMP = F06EJF(N,WA2,1)
            SGNORM = (GNORM/TEMP)/TEMP
C
C           Test whether the scaled gradient direction is acceptable.
C
            ALPHA = ZERO
            IF (SGNORM.LT.DELTA) THEN
C
C              The scaled gradient direction is not acceptable.
C              Finally, calculate the point along the dogleg
C              at which the quadratic is minimized.
C
               BNORM = F06EJF(N,QTB,1)
               TEMP = (BNORM/GNORM)*(BNORM/QNORM)*(SGNORM/DELTA)
               TEMP = TEMP - (DELTA/QNORM)*(SGNORM/DELTA)**2 +
     *                SQRT((TEMP-(DELTA/QNORM))**2+(ONE-(DELTA/QNORM)
     *                **2)*(ONE-(SGNORM/DELTA)**2))
               ALPHA = ((DELTA/QNORM)*(ONE-(SGNORM/DELTA)**2))/TEMP
            END IF
         END IF
C
C        Form appropriate convex combination of the Gauss-Newton
C        direction and the scaled gradient direction.
C
         TEMP = (ONE-ALPHA)*MIN(SGNORM,DELTA)
         DO 200 J = 1, N
            X(J) = TEMP*WA1(J) + ALPHA*X(J)
  200    CONTINUE
      END IF
      RETURN
      END

c     $Author: rieutord $
c     $Revision: 1.1.1.1 $
c     $Log: gpsort.f,v $
c     Revision 1.1.1.1  2004-03-10 12:30:55  rieutord
c     import cst v. 2.2.3
c
c Revision 1.2  1993/04/21  16:57:23  raus
c string size up to 128 char
c
c Revision 1.1  1993/04/20  17:47:06  raus
c 1st save
c
c*****************************************************************
      SUBROUTINE GPsort
c***
      INCLUDE 'undefined.h'
      INCLUDE 'GP_common.h'
c***
      call sortwithkey(nlines,name_var_len,lines_of_text)
c***
      return
      end

      SUBROUTINE C05NDS(IREVCM,N,X,FVEC,XTOL,ML,MU,EPSFCN,DIAG,MODE,
     *                  FACTOR,INFO,FJAC,LDFJAC,R,LR,QTF,WA1,WA2,WA3,
     *                  WA4)
C     MARK 14 RELEASE. NAG COPYRIGHT 1989.
C     **********
C
C     SUBROUTINE C05NDS (based on MINPACK routine HYBRD )
C
C     The purpose of C05NDS is to find a zero of a system of
C     N nonlinear functions in N variables by a modification
C     of the Powell hybrid method. The Jacobian is
C     calculated by a forward-difference approximation.
C
C     **********
C
C     Revised to call BLAS.
C     P.J.D. Mayes, J.J. Du Croz, NAG Central Office, September 1987.
C     Revised to reverse communication.
C     M.S. Derakhshan, NAG Central Office, September 1988.
C
C     .. Parameters ..
      DOUBLE PRECISION  ONE, P1, P5, P001, P0001, ZERO
      PARAMETER         (ONE=1.0D0,P1=0.1D0,P5=0.5D0,P001=0.001D0,
     *                  P0001=0.0001D0,ZERO=0.0D0)
C     .. Scalar Arguments ..
      DOUBLE PRECISION  EPSFCN, FACTOR, XTOL
      INTEGER           INFO, IREVCM, LDFJAC, LR, ML, MODE, MU, N
C     .. Array Arguments ..
      DOUBLE PRECISION  DIAG(N), FJAC(LDFJAC,N), FVEC(N), QTF(N), R(LR),
     *                  WA1(N), WA2(N), WA3(N), WA4(N), X(N)
C     .. Local Scalars ..
      DOUBLE PRECISION  ACTRED, DELTA, EPSMCH, FNORM, FNORM1, PNORM,
     *                  PRERED, RATIO, SUM, TEMP, XNORM
      INTEGER           I, IREV1, IREV2, IRVNDS, ITER, J, JM1, L, MSUM,
     *                  NCFAIL, NCSUC, NSLOW1, NSLOW2
      LOGICAL           JEVAL, SING
C     .. External Functions ..
      DOUBLE PRECISION  F06EJF, X02AJF
      EXTERNAL          F06EJF, X02AJF
C     .. External Subroutines ..
      EXTERNAL          C05NCU, C05NCW, C05NCX, C05NCY, C05NCZ, C05NDV,
     *                  DSWAP, DGEMV, DTPMV
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MAX, MIN
C     .. Save statement ..
      SAVE
C     .. Executable Statements ..
C
      GO TO (300,40) IREVCM
      EPSMCH = X02AJF()
C
      IREV1 = 0
      IREV2 = 0
      IRVNDS = 0
      INFO = 1
C
C     Check the input parameters for errors.
C
      IF (MODE.EQ.2) THEN
         DO 20 J = 1, N
            IF (DIAG(J).LE.ZERO) GO TO 460
   20    CONTINUE
      END IF
C
C     Return to user-level to evaluate the function
C     at the starting point and calculate its norm.
C
      IREVCM = 2
      RETURN
   40 CONTINUE
      GO TO (80,340) IREV2
      FNORM = F06EJF(N,FVEC,1)
C
C     Determine the number of calls to the function, specified
C     in user-level, needed to compute the Jacobian matrix.
C
      MSUM = MIN(ML+MU+1,N)
C
C     Initialize iteration counter and monitors.
C
      ITER = 1
      NCSUC = 0
      NCFAIL = 0
      NSLOW1 = 0
      NSLOW2 = 0
C
C     Beginning of the outer loop.
C
   60 CONTINUE
      JEVAL = .TRUE.
C
C     Calculate the Jacobian matrix by returning to the
C     user-level to evaluate the function.
C
      IREV2 = 1
   80 CONTINUE
      CALL C05NDV(IRVNDS,N,X,FVEC,FJAC,LDFJAC,ML,MU,EPSFCN,WA1,WA2)
      IF (IRVNDS.EQ.1 .OR. IRVNDS.EQ.2) RETURN
      CONTINUE
C
C     Compute the QR factorization of the Jacobian.
C
      CALL C05NCX(N,FJAC,LDFJAC,WA1,WA2)
C
C     On the first iteration and if MODE is 1, scale according
C     to the norms of the columns of the initial Jacobian.
C
      IF (ITER.EQ.1) THEN
         IF (MODE.NE.2) THEN
            DO 100 J = 1, N
               DIAG(J) = WA2(J)
               IF (WA2(J).EQ.ZERO) DIAG(J) = ONE
  100       CONTINUE
         END IF
C
C        On the first iteration, calculate the norm of the scaled X
C        and initialize the step bound DELTA.
C
         DO 120 J = 1, N
            WA3(J) = DIAG(J)*X(J)
  120    CONTINUE
         XNORM = F06EJF(N,WA3,1)
         DELTA = FACTOR*XNORM
         IF (DELTA.EQ.ZERO) DELTA = FACTOR
      END IF
C
C           T
C     form Q *FVEC and store in QTF.
C
      DO 140 I = 1, N
         QTF(I) = FVEC(I)
  140 CONTINUE
      DO 200 J = 1, N
         IF (FJAC(J,J).NE.ZERO) THEN
            SUM = ZERO
            DO 160 I = J, N
               SUM = SUM + FJAC(I,J)*QTF(I)
  160       CONTINUE
            TEMP = -SUM/FJAC(J,J)
            DO 180 I = J, N
               QTF(I) = QTF(I) + FJAC(I,J)*TEMP
  180       CONTINUE
         END IF
  200 CONTINUE
C
C     Copy the triangular factor of the QR factorization into R.
C
      SING = .FALSE.
      DO 240 J = 1, N
         L = J
         JM1 = J - 1
         IF (JM1.GE.1) THEN
            DO 220 I = 1, JM1
               R(L) = FJAC(I,J)
               L = L + N - I
  220       CONTINUE
         END IF
         R(L) = WA1(J)
         IF (WA1(J).EQ.ZERO) SING = .TRUE.
  240 CONTINUE
C
C     Accumulate the orthogonal factor in FJAC.
C
      CALL C05NCW(N,FJAC,LDFJAC,WA1)
C
C     Rescale if necessary.
C
      IF (MODE.NE.2) THEN
         DO 260 J = 1, N
            DIAG(J) = MAX(DIAG(J),WA2(J))
  260    CONTINUE
      END IF
C
C     Beginning of the inner loop.
C
  280 CONTINUE
C
C     If requested, return to user-level for printing the iterates.
C
      IREVCM = 1
      RETURN
  300 CONTINUE
      IF (IREV1.EQ.1) GO TO 480
C
C     Determine the direction P.
C
      CALL C05NCU(N,R,LR,DIAG,QTF,DELTA,WA1,WA2,WA3)
C
C     Store the direction P and X + P. Calculate the norm of P.
C
      DO 320 J = 1, N
         WA1(J) = -WA1(J)
         WA2(J) = X(J) + WA1(J)
         WA3(J) = DIAG(J)*WA1(J)
  320 CONTINUE
      PNORM = F06EJF(N,WA3,1)
C
C     On the first iteration, adjust the initial step bound.
C
      IF (ITER.EQ.1) DELTA = MIN(DELTA,PNORM)
C
C     Return to user-level to evaluate the function
C     at X + P and calculate its norm.
C
      IREVCM = 2
      IREV2 = 2
      CALL DSWAP(N,WA2,1,X,1)
      CALL DSWAP(N,WA4,1,FVEC,1)
      RETURN
  340 CONTINUE
      CALL DSWAP(N,X,1,WA2,1)
      CALL DSWAP(N,FVEC,1,WA4,1)
      FNORM1 = F06EJF(N,WA4,1)
C
C     Compute the scaled actual reduction.
C
      ACTRED = -ONE
      IF (FNORM1.LT.FNORM) ACTRED = ONE - (FNORM1/FNORM)**2
C
C     Compute the scaled predicted reduction.
C
      DO 360 I = 1, N
         WA3(I) = WA1(I)
  360 CONTINUE
      CALL DTPMV('Lower triangle','Transpose','Non-unit diagonal',N,R,
     *           WA3,1)
      DO 380 I = 1, N
         WA3(I) = WA3(I) + QTF(I)
  380 CONTINUE
      TEMP = F06EJF(N,WA3,1)
      PRERED = 1.0D0
      IF (TEMP.LT.FNORM) PRERED = ONE - (TEMP/FNORM)**2
C
C     Compute the ratio of the actual to the predicted
C     reduction.
C
      RATIO = ZERO
      IF (PRERED.GT.ZERO) RATIO = ACTRED/PRERED
C
C     Update the step bound.
C
      IF (RATIO.LT.P1) THEN
         NCSUC = 0
         NCFAIL = NCFAIL + 1
         DELTA = P5*DELTA
      ELSE
         NCFAIL = 0
         NCSUC = NCSUC + 1
         IF (RATIO.GE.P5 .OR. NCSUC.GT.1) DELTA = MAX(DELTA,PNORM/P5)
         IF (ABS(RATIO-ONE).LE.P1) DELTA = PNORM/P5
      END IF
C
C     Test for successful iteration.
C
      IF (RATIO.GE.P0001) THEN
C
C        Successful iteration. Update X, FVEC, and their norms.
C
         DO 400 J = 1, N
            X(J) = WA2(J)
            WA2(J) = DIAG(J)*X(J)
            FVEC(J) = WA4(J)
  400    CONTINUE
         XNORM = F06EJF(N,WA2,1)
         FNORM = FNORM1
         ITER = ITER + 1
      END IF
C
C     Determine the progress of the iteration.
C
      NSLOW1 = NSLOW1 + 1
      IF (ACTRED.GE.P001) NSLOW1 = 0
      IF (JEVAL) NSLOW2 = NSLOW2 + 1
      IF (ACTRED.GE.P1) NSLOW2 = 0
C
C     Test for convergence.
C
      IF (DELTA.LE.XTOL*XNORM .OR. FNORM.EQ.ZERO .OR. PNORM.EQ.ZERO)
     *    INFO = 0
      IF (INFO.NE.1) GO TO 460
C
C     Tests for termination and stringent tolerances.
C
      IF (DELTA.LE.EPSMCH*XNORM) INFO = 3
      IF (NSLOW2.EQ.5) INFO = 4
      IF (NSLOW1.EQ.10) INFO = 5
      IF (INFO.NE.1) GO TO 460
C
C     Criterion for recalculating Jacobian approximation
C     by forward differences.
C
      IF (NCFAIL.NE.2) THEN
C
C        Calculate the rank one modification to the Jacobian
C        and update QTF if necessary.
C
         CALL DGEMV('Transpose',N,N,ONE,FJAC,LDFJAC,WA4,1,ZERO,WA2,1)
         IF (RATIO.GE.P0001) THEN
            DO 420 J = 1, N
               QTF(J) = WA2(J)
  420       CONTINUE
         END IF
         DO 440 J = 1, N
            WA2(J) = (WA2(J)-WA3(J))/PNORM
            WA1(J) = DIAG(J)*((DIAG(J)*WA1(J))/PNORM)
  440    CONTINUE
C
C        Compute the QR factorization of the updated Jacobian.
C
         CALL C05NCZ(N,N,R,LR,WA1,WA2,WA3,SING)
         CALL C05NCY(N,N,FJAC,LDFJAC,WA2,WA3)
         CALL C05NCY(1,N,QTF,1,WA2,WA3)
C
C        End of the inner loop.
C
         JEVAL = .FALSE.
         GO TO 280
      END IF
C
C     End of the outer loop.
C
      GO TO 60
  460 CONTINUE
C
C     Termination, either normal or user imposed.
C
      IREVCM = 1
      IREV1 = 1
      RETURN
  480 CONTINUE
      IREVCM = 0
      RETURN
      END

      subroutine printerror(status)

!      Print out the FITSIO error messages to the user

      integer status
      character errtext*30,errmessage*80

!     check if status is OK (no error); if so, simply return
      if (status .le. 0)return

!     get the text string which describes the error
 1    call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

!     read and print out all the error messages on the FITSIO stack
 2    call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      end do
      end

      SUBROUTINE C05NCZ(M,N,S,LS,U,V,W,SING)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     **********
C
C     SUBROUTINE C05NCZ (based on MINPACK Routine R1UPDT)
C
C     Given an M by N lower trapezoidal matrix S, an M-vector U,
C     and an N-vector V, the problem is to determine an
C     orthogonal matrix Q such that
C
C             T
C     (S + U*V )*Q
C
C     is again lower trapezoidal.
C
C     This subroutine determines Q as the product of 2*(N - 1)
C     transformations
C
C        GV(N-1)*...*GV(1)*GW(1)*...*GW(N-1)
C
C     where GV(I), GW(I) are Givens rotations in the (I,N) plane
C     which eliminate elements in the I-th and N-th planes,
C     respectively. Q itself is not accumulated, rather the
C     information to recover the GV, GW rotations is returned.
C
C     The subroutine statement is
C
C        SUBROUTINE C05NCZ(M,N,S,LS,U,V,W,SING)
C
C     where
C
C     M is a positive integer input variable set to the number
C     of rows of S.
C
C     N is a positive integer input variable set to the number
C     of columns of S. N must not exceed M.
C
C     S is an array of length LS. On input S must contain the lower
C     trapezoidal matrix S stored by columns. On output S contains
C     the lower trapezoidal matrix produced as described above.
C
C     LS is a positive integer input variable not less than
C     (N*(2*M-N+1))/2.
C
C     U is an input array of length M which must contain the
C     vector U.
C
C     V is an array of length N. On input V must contain the vector
C     V. On output V(I) contains the information necessary to
C     recover the Givens rotation GV(I) described above.
C
C     W is an output array of length M. W(I) contains information
C     necessary to recover the Givens rotation GW(I) described
C     above.
C
C     SING is a logical output variable. SING is set .TRUE. if any
C     of the diagonal elements of the output S are zero. Otherwise
C     SING is set .FALSE.
C
C     Argonne National Laboratory. MINPACK project. March 1980.
C     Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More,
C     John L. Nazareth
C
C     **********
C
C     Revised to call BLAS.
C     P.J.D. Mayes, J.J. Du Croz, NAG Central Office, September 1987.
C
C     .. Parameters ..
      DOUBLE PRECISION  ONE, P5, P25, ZERO
      PARAMETER         (ONE=1.0D0,P5=0.5D0,P25=0.25D0,ZERO=0.0D0)
C     .. Scalar Arguments ..
      INTEGER           LS, M, N
      LOGICAL           SING
C     .. Array Arguments ..
      DOUBLE PRECISION  S(LS), U(M), V(N), W(M)
C     .. Local Scalars ..
      DOUBLE PRECISION  COSINE, COTAN, GIANT, SINE, TANGNT, TAU
      INTEGER           I, J, JJ, L, NM1, NMJ
C     .. External Functions ..
      DOUBLE PRECISION  X02ALF
      EXTERNAL          X02ALF
C     .. External Subroutines ..
      EXTERNAL          DROT
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, SQRT
C     .. Executable Statements ..
      GIANT = X02ALF()
C
C     Initialize the diagonal element pointer.
C
      JJ = (N*(2*M-N+1))/2 - (M-N)
C
C     Move the nontrivial part of the last column of S into W.
C
      L = JJ
      DO 20 I = N, M
         W(I) = S(L)
         L = L + 1
   20 CONTINUE
C
C     Rotate the vector V into a multiple of the N-th unit vector
C     in such a way that a spike is introduced into W.
C
      NM1 = N - 1
      IF (NM1.GE.1) THEN
         DO 60 NMJ = 1, NM1
            J = N - NMJ
            JJ = JJ - (M-J+1)
            W(J) = ZERO
            IF (V(J).EQ.ZERO) GO TO 40
C
C           Determine a Givens rotation which eliminates the
C           J-th element of V.
C
            IF (ABS(V(N)).LT.ABS(V(J))) THEN
               COTAN = V(N)/V(J)
               SINE = P5/SQRT(P25+P25*COTAN**2)
               COSINE = SINE*COTAN
               TAU = ONE
               IF (ABS(COSINE)*GIANT.GT.ONE) TAU = ONE/COSINE
            ELSE
               TANGNT = V(J)/V(N)
               COSINE = P5/SQRT(P25+P25*TANGNT**2)
               SINE = COSINE*TANGNT
               TAU = SINE
            END IF
C
C           Apply the transformation to V and store the information
C           necessary to recover the Givens rotation.
C
            V(N) = SINE*V(J) + COSINE*V(N)
            V(J) = TAU
C
C           Apply the transformation to S and extend the spike in W.
C
            CALL DROT(M-J+1,W(J),1,S(JJ),1,COSINE,SINE)
   40       CONTINUE
   60    CONTINUE
      END IF
C
C     Add the spike from the rank 1 update to W.
C
      DO 80 I = 1, M
         W(I) = W(I) + V(N)*U(I)
   80 CONTINUE
C
C     Eliminate the spike.
C
      SING = .FALSE.
      IF (NM1.GE.1) THEN
         DO 100 J = 1, NM1
            IF (W(J).NE.ZERO) THEN
C
C              Determine a Givens rotation which eliminates the
C              J-th element of the spike.
C
               IF (ABS(S(JJ)).LT.ABS(W(J))) THEN
                  COTAN = S(JJ)/W(J)
                  SINE = P5/SQRT(P25+P25*COTAN**2)
                  COSINE = SINE*COTAN
                  TAU = ONE
                  IF (ABS(COSINE)*GIANT.GT.ONE) TAU = ONE/COSINE
               ELSE
                  TANGNT = W(J)/S(JJ)
                  COSINE = P5/SQRT(P25+P25*TANGNT**2)
                  SINE = COSINE*TANGNT
                  TAU = SINE
               END IF
C
C              Apply the transformation to S and reduce the spike in W.
C
               CALL DROT(M-J+1,S(JJ),1,W(J),1,COSINE,SINE)
C
C              Store the information necessary to recover the
C              Givens rotation.
C
               W(J) = TAU
            END IF
C
C           Test for zero diagonal elements in the output S.
C
            IF (S(JJ).EQ.ZERO) SING = .TRUE.
            JJ = JJ + (M-J+1)
  100    CONTINUE
      END IF
C
C     Move W back into the last column of the output S.
C
      L = JJ
      DO 120 I = N, M
         S(L) = W(I)
         L = L + 1
  120 CONTINUE
      IF (S(JJ).EQ.ZERO) SING = .TRUE.
      RETURN
      END

! Determines the centres of gravity of the granules in the frame

	module centres_de_gravite

contains

	subroutine cg(ip,xg,yg,card,ng_com)

	use param_run
	use thename
	use readfits
	use detection
!	use m_correction
!	use m_intersec
!	use m_elimin
	use segmentation

	implicit none

	integer n,k,i,ip,ngmax,nbss,nx_cg,ny_cg
	integer, allocatable :: ia(:,:),nff(:)
	real, allocatable :: xgc(:,:),ygc(:,:),b(:,:)


 ! For reading the image
 
	real, pointer :: a(:,:)
!!$        real, allocatable :: a(:,:)
        integer naxes(2)
	character*128, pointer :: frame(:)

! For output
	real, intent(out) :: xg(:,:),yg(:,:)
	integer, intent(out) :: card(:,:),ng_com
	character suff*4,fichier*100

! Find the file
	call the_name(ip,frame)
	ngmax=size(xg,1)

	nbss=nbs(ip)
	allocate(nff(nbss),xgc(ngmax,nbss),ygc(ngmax,nbss))

! We transform the images into a set of points (xg,yg): the barycentres
	nx_cg=nx2-nx1+1; ny_cg=ny2-ny1+1
	allocate(ia(nx_cg,ny_cg),b(nx_cg,ny_cg)); ia=0; b=0
	 if (sub_im ==1) print*, 'we treat a sub-image of size',nx_cg,ny_cg
	 if (sub_im ==1) print*, ''
	 sub_im=0 ! this is a flag for the above prints

	do k=1,nbss
	 if (verbose >= 1) print*,'in cg ip,k,frame(k)',ip,k,frame(k)
	 nullify(a)
	 call readimage(frame(k),a,naxes)  ! nx=naxes(1); ny=naxes(2)
	 if (nx_cg <0 .or. ny_cg <0 .or. nx_cg>naxes(1) .or. ny_cg>naxes(2)) &
	       stop'in cg.f90: the sub-image is larger than the image!'

         b(1:nx_cg,1:ny_cg)=a(nx1:nx2,ny1:ny2)
	 if (.not. segmented) then
          if (typeseg == 'strouss') then
!           call segment(a(nx1:nx2,ny1:ny2),nx,ny,ia)
            call segment(b,nx_cg,ny_cg,ia)
          else if (typeseg == 'CD') then
           call segment_CD(a(nx1:nx2,ny1:ny2),nx_cg,ny_cg,ia, &
                          ech_lap,seuil_lap,seuil_rel,seuil_courb)
	    if (maxval(ia) == 1) ia=4*ia
          else if (typeseg == 'CD2') then
           call segment_CD2(a(nx1:nx2,ny1:ny2),nx_cg,ny_cg,ia, &
                          ech_lap,seuil_haut,seuil_bas)
	    if (maxval(ia) == 1) ia=4*ia
          else if (typeseg == 'CD3') then
            call segment_CD3(a(nx1:nx2,ny1:ny2),nx_cg,ny_cg,ia,n_moy, &
                           seuil_lap,seuil_bas)
	    if (maxval(ia) == 1) ia=4*ia
	  else
	   print*,'typeseg = ',typeseg
	   stop'this type of segmentation is not included'
	  endif
	 else
	  print*,'The image is already segmented; true level assumed =255'
	  ia=int(a/255)*4
	 endif
	
	 if (option == 'segmentation') then
	  if (verbose >= 1) print*,'option segmentation in cg'
	  write(suff,"(i4)") ip
	  suff=trim(adjustl(suff))
	  fichier='results/image_seg'//suff
          open(unit=4,file=fichier,form='formatted')
          !open(unit=4,file=fichier,form='unformatted')
                write(4,*) nx_cg,ny_cg
                write(4,*) ia(1:nx_cg,1:ny_cg)
                !write(4) nx_cg
                !write(4) ny_cg
                !write(4) ia
          close(4)
          n=count(ia == 4)
          print*,'nb of pixels with data',n,'fraction of total',float(n)/nx_cg/ny_cg
	  return
	 endif

	 if (verbose >= 4) then
           open(unit=4,file='image_seg')
                write(4,*) nx_cg,ny_cg
                write(4,*) ia
           close(4)
	 else if (verbose >= 1) then
	  n=count(ia == 4)
	  print*,'nb of pixels with data',n,'fraction of total',float(n)/nx_cg/ny_cg
	 endif

	 call detect(ia,nx_cg,ny_cg,xg(:,k),yg(:,k),card(:,k),nff(k)) 
	 if (verbose >=1) print*,'nb of pix. in granules',sum(card(1:nff(k),k))
	enddo

! All the sets need to have the same set of granules. We first determine the
! corrected (from distorsion) positions and then the common set

!	do k=2,nbss
!	 call correction(xg(:,k),yg(:,k),nff(k),xgc(:,k),ygc(:,k),ip,k)
!	 call intersection(xg(:,1),yg(:,1),xgc(:,k),ygc(:,k),nff(1),nff(k))
!	enddo

! The intersection is in xg,yg(:,1); we select the same granules in all
! the other frames k#1
!	do k=2,nbss
!	 call elimination(xg(:,1),yg(:,1),nff(1),xgc(:,k),ygc(:,k),&
!                          xg(:,k),yg(:,k),nff(k),ng_com)
!	enddo

	if (nbss == 1) ng_com=nff(1)

	deallocate(a,ia,nff)
	end subroutine


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!      Centre de gravite pour la version CST de 2013

      subroutine centre_gravite(coord,image,nx,ny,dimxx,dimyy,aire_max,fene,valeur,cgravx,cgravy)

            implicit none

            integer      valeur,posx,posy,xmin,xmax,ymin,ymax,fene
            integer      xl,yl,dimxx,dimyy,aire_max,nx,ny

            integer      image(nx,ny), obj(2*fene+1,2*fene+1)

            real         cgravx, cgravy, XG,YG,compt
            real         coord(2)

            posx=coord(1) 
            posy=coord(2) 
              
            xmin=posx-fene      
            xmax=posx+fene      
            ymin=posy-fene       
            ymax=posy+fene       
       
            if(xmin .lt. 1)  xmin=1 
            if(xmax .gt. nx) xmax=nx
            if(ymin .lt. 1)  ymin=1 
            if(ymax .gt. ny) ymax=ny 

           obj=0
           obj=image(xmin:xmax,ymin:ymax)  

            compt=0.

            XG=0.
            YG=0.
            cgravx=0
            cgravy=0
  
           do yl=1,dimyy 
             do xl=1,dimxx    
              if(obj(xl,yl) .eq. valeur) then 
                XG= real(xl)+xmin-1+ XG
                YG= real(yl)+ymin-1+ YG                 
                compt= compt +1
                if ( compt .gt. aire_max-1) goto 10  
              endif
             end do      
           end do

 10       continue

          cgravx=(XG/compt)  
          cgravy=(YG/compt) 

         end subroutine

	end module

      SUBROUTINE C05NCW(N,Q,LDQ,WA)
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     **********
C
C     SUBROUTINE C05NCW (based on MINPACK routine QFORM )
C
C     This subroutine proceeds from the computed QR factorization of
C     an N by N matrix A to accumulate the N by N orthogonal matrix
C     Q from its factored form.
C
C     The subroutine statement is
C
C        SUBROUTINE C05NCW(N,Q,LDQ,WA)
C
C     where
C
C     N is a positive integer input variable set to the number
C     of rows and columns of A and the order of Q.
C
C     Q is an N by N array. On input the full lower trapezoid in
C     the first N columns of Q contains the factored form.
C     On output Q has been accumulated into a square matrix.
C
C     LDQ is a positive integer input variable not less than N
C     which specifies the leading dimension of the array Q.
C
C     WA is a work array of length N.
C
C     Argonne National Laboratory. MINPACK project. March 1980.
C     Burton S. Garbow, Kenneth E. Hillstrom, Jorge J. More
C
C     **********
C
C     Revised to call BLAS.
C     P.J.D. Mayes, J.J. Du Croz, NAG Central Office, September 1987.
C
C     .. Parameters ..
      DOUBLE PRECISION  ONE, ZERO
      PARAMETER         (ONE=1.0D0,ZERO=0.0D0)
C     .. Scalar Arguments ..
      INTEGER           LDQ, N
C     .. Array Arguments ..
      DOUBLE PRECISION  Q(LDQ,N), WA(N)
C     .. Local Scalars ..
      INTEGER           I, J, K, LDQ1
C     .. External Subroutines ..
      EXTERNAL          DGEMV, DGER
C     .. Executable Statements ..
      DO 40 J = 2, N
         DO 20 I = 1, J - 1
            Q(I,J) = ZERO
   20    CONTINUE
   40 CONTINUE
C
C     Accumulate Q from its factored form.
C
      DO 80 K = N, 1, -1
         IF (Q(K,K).NE.ZERO .AND. K.NE.N) THEN
            IF (K.EQ.N-1) THEN
               LDQ1 = 2
            ELSE
               LDQ1 = LDQ
            END IF
            CALL DGEMV('Transpose',N-K+1,N-K,ONE,Q(K,K+1),LDQ1,Q(K,K),1,
     *                 ZERO,WA(K+1),1)
            CALL DGER(N-K+1,N-K,-ONE/Q(K,K),Q(K,K),1,WA(K+1),1,Q(K,K+1),
     *                LDQ1)
         END IF
         DO 60 I = K + 1, N
            Q(I,K) = -Q(I,K)
   60    CONTINUE
         Q(K,K) = ONE - Q(K,K)
   80 CONTINUE
C
      RETURN
      END

c $Author: rieutord $
c $Revision: 1.1.1.1 $
c $Log: term_string.F,v $
c Revision 1.1.1.1 2004-03-10 12:30:55 rieutord
c import cst v. 2.2.3
c
c Revision 1.2 1993/04/21 16:58:05 raus
c fixed a bug (i counter)
c
c Revision 1.1 1993/04/20 17:48:27 raus
c 1st save
c
c***********************************************************************
      SUBROUTINE term_string(string)
c***


      INCLUDE 'undefined.h'
      INTEGER len_string, i, ibegin
      CHARACTER*(*) string
      CHARACTER*1 end_char, blank, char
      DATA end_char/'\0'/, blank/' '/
c DATA end_char/' '/, blank/' '/
c***
      len_string = LEN(string)
      ibegin = 1
      i = 1
      char = string(1:1)
      do while (char .ne. blank .and. i .le. len_string)
         ibegin = ibegin + 1
         char = string(ibegin:ibegin)
      enddo
c***
c--- print*,'>>>',string,'<<<'
c***
      do i=ibegin,len_string
         string(i:i) = end_char
      enddo


c***
c--- print*,'>>>',string,'<<<'
c***
      return
      end

#!/bin/bash
#SBATCH -J script_art435
#SBATCH -N 1 
#SBATCH -n 1 
#SBATCH --threads-per-core=1
#SBATCH --cpus-per-task=18
#SBATCH --time=100:00:00

ulimit -a
ulimit -s unlimited
ulimit -a
source /opt/intel/compilers_and_libraries_2018.3.222/linux/bin/compilervars.sh intel64

set -x
free
make clean
make
workdir=${SLURM_SUBMIT_DIR}/JOB_${SLURM_JOBID}
mkdir ${workdir} 
cd ${workdir}

#lfs setstripe -c 1 .

cp $0 .
export OMP_NUM_THREADS=${SLURM_CPUS_PER_TASK}
MKL_NUM_THREADS=$OMP_NUM_THREADS 
export KMP_STACKSIZE=1000000000
export KMP_MONITOR_STACKSIZE=1000000000


cp ../cst_labv7_FS_2017 .
cp ../param_seq_29nov2018_EOS_30mn .
mkdir results
cp param_seq_29nov2018_EOS_30mn param_2018_EOS_tempo

NINDEX=0               #indice de boucle  1ere heure


while [ $NINDEX -le 0 ]         #on decide jusqu'a va la boucle    
 
do
        let NSTART=40*$NINDEX+1    #indice de depart
	Nfich=$(printf "%04d" $NINDEX)
	echo $Nfich
        echo "New execution: starting frame $NSTART"
        cp param_seq_29nov2018_EOS_30mn param_2018_EOS_tempo #on copie le fichier de parametre de depart dans un temporaire
        echo "ip_start=$NSTART # numero de la plaque de demarrage">> param_2018_EOS_tempo  #on ajoute une ligne
sed -i 's#param_seq_29nov2018_EOS_30mn#param_2018_EOS_tempo#g' param_2018_EOS_tempo
srun -N 1 -n 1 -c $OMP_NUM_THREADS cst_labv7_FS_2017 < param_2018_EOS_tempo  >> output_${SLURM_JOBID}.log

     #liste des fichiers a renommer
	echo ${workdir}
	mv ${workdir}/results/div1b ${workdir}/results/div_b_$Nfich
	mv ${workdir}/results/div1h ${workdir}/results/div_h_$Nfich
	mv ${workdir}/results/div1k ${workdir}/results/div_k_$Nfich
	mv ${workdir}/results/div1l ${workdir}/results/div_l_$Nfich
	mv ${workdir}/results/div1m ${workdir}/results/div_m_$Nfich
	mv ${workdir}/results/err1b ${workdir}/results/err_b_$Nfich
	mv ${workdir}/results/err1h ${workdir}/results/err_h_$Nfich
	mv ${workdir}/results/err1k ${workdir}/results/err_k_$Nfich
	mv ${workdir}/results/err1l ${workdir}/results/err_l_$Nfich
	mv ${workdir}/results/err1m ${workdir}/results/err_m_$Nfich
	mv ${workdir}/results/rot1b ${workdir}/results/rot_b_$Nfich
	mv ${workdir}/results/rot1h ${workdir}/results/rot_h_$Nfich
	mv ${workdir}/results/rot1k ${workdir}/results/rot_k_$Nfich
	mv ${workdir}/results/rot1l ${workdir}/results/rot_l_$Nfich
	mv ${workdir}/results/rot1m ${workdir}/results/rot_m_$Nfich
	mv ${workdir}/results/ux1b ${workdir}/results/ux_b_$Nfich
	mv ${workdir}/results/ux1h ${workdir}/results/ux_h_$Nfich
	mv ${workdir}/results/ux1k ${workdir}/results/ux_k_$Nfich
	mv ${workdir}/results/ux1l ${workdir}/results/ux_l_$Nfich
	mv ${workdir}/results/ux1m ${workdir}/results/ux_m_$Nfich
	mv ${workdir}/results/uy1b ${workdir}/results/uy_b_$Nfich
	mv ${workdir}/results/uy1h ${workdir}/results/uy_h_$Nfich
	mv ${workdir}/results/uy1k ${workdir}/results/uy_k_$Nfich
	mv ${workdir}/results/uy1l ${workdir}/results/uy_l_$Nfich
	mv ${workdir}/results/uy1m ${workdir}/results/uy_m_$Nfich
	mv ${workdir}/results/nb_gran ${workdir}/results/nb_gran_$Nfich
	mv ${workdir}/results/param_2018_EOS_tempo ${workdir}/results/param_2018_EOS_tempo_$Nfich
	mv ${workdir}/results/traject1_11 ${workdir}/results/traject_11_$Nfich

	let NINDEX=NINDEX+1 #on augmente l'indice de la boucle de 1
rm param_2018_EOS_tempo #on vire le fichier temporaire

done
